# File: 2OneLinesForDiv_Perl.pl
# Date            Author        number of nodes
# 2005/9/4        Walking Lint  35
# 2005/9/4        Walking Lint  23 (2OneLines_Perl->2OneLinesForDiv_Perl)
# 2005/9/4        Walking Lint  26
# 2005/9/4        Walking Lint  26 (2OneLine_Perl->2OneLines_Perl)
# 2003/8/31       Walking@Lint 26
# 2003/8/6        Walking@Lint 20
# 2003/7/16       Walking Lint  18
# 2003/6/15       Walking Lint  14
# 2003/6/8        Walking Lint  13
# 2003/5/26       Walking Lint  9
# 2003/5/26

=pod

=head1 NAME

2OneLinesForDiv_Perl.pl - to one line for div

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$in_div = 0;
$first = 1;
while (<STDIN>) {
  $_ =~ s/[ \t\n]+$//;
  if ($_ =~ /^<div/) {
    $in_div = 1;
    $first = 1;
  } elsif ($_ =~ /^<\/div/) {
    $in_div = 0;
  }
  if ($in_div == 1) {
    if (($_ =~ /^</) or (length($_) == 0)) {
      if ($first == 0) {
        print "$line\n";
        $line = '';
        $first = 1;
      }
      print "$_\n";
    } elsif ($first) {
      $first = 0;
      $line = $_;
    } else {
      $line .=  $_;
    }
  } else {
    if ($first == 0) {
      print "$line\n";
      $first = 1;
    }
    print "$_\n";
  }
}
if ($first == 0) {
  print "$line\n";
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
