# File: 2Ref_Perl.pl
# Date            Author        number of nodes
# 2003/8/13       Walking@Lint 25
# 2003/7/20       Walking Lint  23
# 2003/7/17       Walking Lint  23
# 2003/7/17       Walking Lint  20 (2OneLine_Perl->2Ref_Perl)
# 2003/7/16       Walking Lint  18
# 2003/6/15       Walking Lint  14
# 2003/6/8        Walking Lint  13
# 2003/5/26       Walking Lint  9
# 2003/5/26

=pod

=head1 NAME

2Ref_Perl.pl - to ref

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$first = 1;
while (<STDIN>) {
  if ($_ =~ /^__EOF__$/) {
    last;
  }
  $tmp = $_;
  $tmp =~ s/[ \t\n]+$//;
  if ($first) {
    $first = 0;
    $line = '<div class="ref">' . "\n" . $_;
  } elsif (length($tmp) == 0) {
    $line .=  '</div>' . "\n\n" . '<div class="ref">' . "\n";
  } else {
    $line .=  $_;
  }
}
if ($line =~ /\n$/) {
  $line .=  '</div>';
} else {
  $line .=  "\n" . '</div>';
}
print $line;
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
