# File: AI_Perl.pl
# Date            Author        number of nodes
# 2005/3/13       Walking Lint  1293
# 2005/2/3        Walking Lint  1288
# 2004/12/2       Walking Lint  1289
# 2004/9/8        Walking Lint  1289
# 2004/8/20       Walking Lint  1284
# 2004/8/17       Walking Lint  1284
# 2004/8/16       Walking Lint  1284
# 2004/8/2        Walking Lint  1234
# 2004/7/26       Walking Lint  1234
# 2004/7/23       Walking Lint  1233
# 2004/7/1        Walking Lint  1226
# 2004/6/23       Walking Lint  1225
# 2004/6/17       Walking Lint  1214
# 2004/6/15       Walking Lint  1196
# 2004/6/8        Walking Lint  1196
# 2004/6/4        Walking Lint  1195
# 2004/6/1        Walking Lint  1187
# 2004/3/26       Walking Lint  1162
# 2004/1/21       Walking Lint  1162
# 2003/11/21      Walking Lint  1158
# 2003/10/15      Walking Lint  1146
# 2003/10/14      Walking Lint  1145
# 2003/9/24       Walking Lint  1119
# 2003/9/18       Walking Lint  1115
# 2003/9/17       Walking Lint  1115
# 2003/6/24       Walking Lint  1099
# 2003/6/11       Walking Lint  1097
# 2003/5/12       Walking Lint  1097
# 2003/5/9        Walking Lint  1093
# 2003/4/8        Walking Lint  1092
# 2003/3/23       Walking Lint  1090
# 2003/3/3        Walking Lint  1084
# 2003/2/17       Walking Lint  1084
# 2003/1/29       Walking Lint  1066
# 2003/1/28       Walking Lint  1064
# 2003/1/21       Walking Lint  1025
# 2003/1/17       Walking Lint  1021
# 2003/1/15       Walking Lint  976
# 2003/1/6        Walking Lint  971
# 2002/12/26      Walking Lint  951
# 2002/12/25      Walking Lint  937
# 2002/12/13      Walking Lint  934
# 2002/12/11      Walking Lint  934
# 2002/12/9       Walking Lint  853
# 2002/12/8       Walking Lint  833
# 2002/12/7       Walking Lint  821
# 2002/12/5       Walking Lint  715
# 2002/12/4       Walking Lint  636
# 2002/11/29      Walking Lint  608
# 2002/11/28      Walking Lint  590
# 2002/11/27      Walking Lint  549
# 2002/11/26      Walking Lint  463
# 2002/11/25      Walking Lint  331
# 2002/11/25      Walking Lint  177 (Memo_Perl->AI_Perl)
# 2002/11/25      Walking Lint  177 (AddToMemo_Perl->Memo_Perl)
# 2002/11/21      Walking Lint  167
# 2002/11/21      Walking Lint  119 (AddToMeno_Perl->AddToMemo_Perl)
# 2002/11/16      Walking Lint  92
# 2002/10/25      Walking Lint  92
# 2002/10/23      Walking Lint  92
# 2002/10/22      Walking Lint  138 (AddToMemo_Perl->AddToMeno_Perl)
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (AddToMemo_Perl->AddToMemo_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->AddToMemo_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

AI_Perl.pl - AI - lH\쐬̎... ^^

=head1 DESCRIPTION

ex. perl.exe AI_Perl "T" ""

<a href="http://www.tsg.ne.jp/buho1999/212/b212mattaka.html">lH\</a> ɂ
T[oƐڑĒ点@Ƃ...

=head1 AUTHOR

Walking Lint

=cut

use CVTree_Perl;
use Time::localtime;
use Time::Local;
$timestr = '(?:PM|AM)?[0-9]+:[0-9]+(?:-(?:[0-9]+:[0-9]+)?)?(?:PM|AM)?';
$timestr2 = '(?:PM|AM)?[0-9]+:[0-9]+';
@yobi = ('', '', '', '', '', '', 'y');
$prestr = "\n> ";
$poststr = "ł";
$birthyear = 2002;
$birthmonth = 11;
$birthday = 25;
$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
$weblogfolder = $ENV{WEBLOGFOLDER};
$weblogfolder =~ s/"//g;
$responsefile = $templatesfolder . '\Response.pat';
$perl = $ENV{PERL};
$perl =~ s/"//g;
$python = $ENV{PYTHON};
$python =~ s/"//g;
$ruby = $ENV{RUBY};
$ruby =~ s/"//g;
$line = shift;
$savedline = $line;
if (not defined($line)) {
  DebugPrint($prestr . "?");
  exit;
}
$tm = localtime;
$year = $tm->year + 1900;
$month = $tm->mon + 1;
$line = &zen2han($line);
# this is hack ... think later ...
if ($line eq $month . '') {
  $line = '';
} elsif ($line eq $month + 1 . '') {
  $line = '';
}
$arg = shift;
$savedarg = $arg;
$arg = &zen2han($arg);
$arg2 = shift;
$savedarg2 = $arg2;
$arg2 = &zen2han($arg2);
$arg3 = shift;
$savedarg3 = $arg3;
$arg3 = &zen2han($arg3);
$arg4 = shift; # this is hack ...
$savedarg4 = $arg4;
if (defined($arg4)) {
  $arg4 = &zen2han($arg4);
  while ($rest = shift) {
    if (length($rest)) {
      $arg4 .= ' ' . &zen2han($rest);
    }
  }
}
$arg5 = shift; # this is hack ...
$savedarg5 = $arg5;
$tmpline = join(' ', ($line, $arg, $arg2, $arg3));
if (($line=~ /^[a-z]:/i) and ($arg =~ //)) {
  $line = $line . ' ' . $arg;
  $arg = $arg2; # think later ...
  $arg2 = $arg3;
  $line =~ s/(.*)/"$1"/;
}
if (not defined($arg)) {
  ($line, $arg) = split(/ /, $line, 2);
}
if (($arg2 eq '-') and ($arg =~ /^$timestr2$/i) and ($arg3=~ /^$timestr2$/i)) {
  $arg = $arg . $arg2 . $arg3;
  $arg2 = $arg4;
  $arg3 = $arg5;
  $arg4 = $arg6;
  undef $arg5;
  $savedarg = $savedarg . $savedarg2 . $savedarg3;
  $savedarg2 = $savedarg4;
  $savedarg3 = $savedarg5;
  $savedarg4 = $savedarg6;
  undef $savedarg5;
} elsif ($arg =~ /^($timestr)([^0-9\-APM]+)$/i) { # and not defined($arg5) %% may not be good ...
  $arg = $2 . $arg2;
  $arg2 = $1;
}
if (($arg =~ /\([^\)]*$/) and ($arg2 =~ /^[^\(]*\)/)) {
  $arg .= $arg2;
  $arg2 = $arg3;
  $arg3 = $arg6;
  $arg4 = $arg5;
  undef $arg5;
  $savedarg .= $savedarg2;
  $savedarg2 = $savedarg3;
  $savedarg3 = $savedarg6;
  $savedarg4 = $savedarg5;
  undef $savedarg5;
} elsif (($arg =~ /^[0-9]+:[0-9]+$/) and ($arg2 =~ /^(-[0-9]+:[0-9]+)(.+)/)) { # may not be good ...
  $arg .= $1;
  $arg2 = $2;
} elsif (($arg =~ /^[0-9]+:[0-9]+$/) and ($arg2 =~ /^-[0-9]+:[0-9]+/)) { # this is hack ...
  $arg .= $arg2;
  $arg2 = $arg3;
  $arg3 = $arg6;
  $arg4 = $arg5;
  undef $arg5;
  $savedarg .= $savedarg2;
  $savedarg2 = $savedarg3;
  $savedarg3 = $savedarg6;
  $savedarg4 = $savedarg5;
  undef $savedarg5;
}
if ($line =~ /(^[^\(]+\([^\)]+\))./) {
  $arg5 = $arg4;
  $arg4 = $arg3;
  $arg3 = $arg2;
  $arg2 = $arg;
  ($line, $arg) = split(/\)/, $line, 2);
  $line .= ')';
}
$arg =~ s/^[ \t]*//;
if (($arg =~ /^([A-Z]c|$timestr)$/i) and defined($arg2)) { # may not be good ...
  $tmp = $arg;
  $arg = $arg2;
  $arg2 = $tmp;
} elsif ($arg =~ /^[0-9]+(|-)[0-9]+$/ and defined($arg2)) { # may not be good ...
  $tmp = $arg;
  $arg = $arg2;
  $arg2 = $tmp;
}
if ($arg3 =~ /(c(|)||u|$timestr)/i) {
  $arg2 .= ' ' . $arg3;
} elsif (defined($arg3)) {
  $arg .= ' ' . $arg3;
}
if ($arg4 =~ /(c(|)||u|$timestr)/i) {
  $arg2 .= ' ' . $arg4;
} elsif (defined($arg4)) {
  $arg .= ' ' . $arg4;
}
if ($arg5 =~ /(c(|)||u|$timestr)/i) {
  $arg2 .= ' ' . $arg5;
} elsif (defined($arg5)) {
  $arg .= ' ' . $arg5;
}
undef $arg3;
undef $arg4;
undef $arg5;
undef $savedarg3;
undef $savedarg4;
undef $savedarg5;
$datestr = &getdatestr($line);
$verbose = 0;
if (length($datestr) != 0) { # tŏɗp^[ɑ΂ϊ ex. ...
  if (not defined($arg)) {
    if ($line =~ /\x82\xCC/) { # 
      $line =~ s/(\?)?$//;
      ($line, $arg) = split(//, $line);
      if (length($arg) == 0) {
        $arg = '\';
      } elsif ($arg =~ /^S/) {
        $verbose = 1;
        $arg = '\';
      }
    }
  }
  if ($arg eq '\') { # ex.  \ -> Q 
    $arg = $line;
    $line = 'Q';
  } elsif (not defined($arg)) { # ex.  -> œĂ܂
    $arg = $line;
    $line = 'Q';
  } else { # ex.   -> ǉ  
    if (($arg =~ /^[0-9]+:[0-9]+$/) and ($arg2 eq '-') and ($arg3 =~ /^[0-9]+:[0-9]+$/)) { # and defined($arg4)
      $arg3 = &normalizetime($arg) . $arg2 . &normalizetime($arg3);
      if (defined($arg4)) { # this is assumed ...
        if (defined($arg5)) {
          if ($arg4 =~ /^[0-9]+c$/) {
            $arg2 = $savedarg5 . ' ' . $arg4;
          } else {
            $arg2 = $savedarg4 . ' ' . $arg5;
          }
        } else {
          if ($arg4 =~ /^([0-9]+c[ ]*)/) {
            $room = $1;
            $room =~ s/[ ]*$//;
            $arg4 = $savedarg4;
            $arg4 =~ s/^[0-9OPQRSTUVWX]+c[ ]*//;
            $arg2 = $arg4 . ' ' . $room;
          } else {
            $arg2 = $arg4;
          }
        }
      } else {
        $arg2 = ''; # this is hack???
      }
    } elsif (($arg =~ /[0-9]+:[0-9]+$/) and ($arg2 eq '-') and ($arg3 =~ /^[0-9]+:[0-9]+$/)) { # and defined($arg4)
      $arg =~ /([0-9]+):([0-9]+)$/;
      $arg3 = &normalizetime($1 . ':' . $2) . $arg2 . &normalizetime($arg3);
      $arg = $savedarg;
      $arg =~ s/[0-99OPQRSTUVWX]+:[0-99OPQRSTUVWX]+$//;
      if (defined($arg4)) { # this is assumed ...
        if (defined($arg5)) {
          if ($arg4 =~ /^[0-9]+c$/) {
            $arg2 = $arg . ' ' . $savedarg5 . ' ' . $arg4;
          } else {
            $arg2 = $arg . ' ' . $savedarg4 . ' ' . $arg5;
          }
        } else {
          if ($arg4 =~ /^([0-9]+c[ ]*)/) {
            $room = $1;
            $room =~ s/[ ]*$//;
            $arg4 = $savedarg4;
            $arg4 =~ s/^[0-9OPQRSTUVWX]+c[ ]*//;
            $arg2 = $arg . ' ' . $arg4 . ' ' . $room;
          } else {
            $arg2 = $arg . ' ' . $arg4;
          }
        }
      } else {
        $arg2 = $arg;
      }
    } else {
      if ($arg =~ /^[0-9]+:[0-9]+\-[0-9]+:[0-9]+$/) {
        if (defined($arg4)) {
          $arg3 = $savedarg3 . ' ' . $savedarg4; # this is hack ...
        }
        if (defined($arg3)) {
          $arg3 = $savedarg2 . ' ' . $savedarg3;
        } else {
          $arg3 = $savedarg2;
        }
        $arg2 = $arg3;
        $arg3 = &normalizetimerange($arg);
      } else {
        if (defined($arg4)) {
          $arg3 = $arg3 . ' ' . $arg4; # this is hack ...
        }
        if (defined($arg3)) {
          $arg3 = $arg2 . ' ' . $arg3;
        } else {
          $arg3 = $arg2;
        }
        $arg2 = $arg;
      }
    }
    $arg = $line;
    $line = 'ǉ';
  }
}
$responded = 0;
$str = quotemeta '[';
$str2 = quotemeta 'Rs[';
if (($line eq /^$str/) or ($line eq /$str2/)) { # [ׂXNvgRs[
  open IN, '"' . $perl . '" "' . $templatesfolder . '\CopyFilesToMail_Perl.pl" "' . $templatesfolder . '" "' . $templatesfolder . '\mail" |' or die "cannot execute script";
  @lines = <IN>;
  $line = join('', @lines);
  close IN;
  DebugPrint($prestr . "[p̃t@CRs[܂");
  exit;
} elsif (($line =~ //) or ($line =~ /Ƃ/) or ($line =~ /Ȃ񂳂/) or ($line =~ //)) {
  if ($month - $birthmonth >= 0) {
    DebugPrint($prestr . ($year - $birthyear) . "  " . ($month - $birthmonth) . " ł");
  } else {
    DebugPrint($prestr . ($year - $birthyear - 1) . "  " . (12 + $month - $birthmonth) . " ł");
  }
  exit;
} elsif ((($line =~ /^ǉ/) or ($line =~ /^o^/)) and defined($arg) and defined($arg2)) {
  if (defined($arg3)) {
    $tmp = '%' . '%';
    $arg2 =~ s/$tmp$//;
    if ($arg3 =~ /(.*)$tmp (.*)/) { # this is hack ...
      $arg2 .= ' ' . $1;
      $arg3 = $2;
    } else {
      $arg3 =~ s/^- //;
    }
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Memo_Perl.pl" "' . $arg . '" "' . $arg2 . '" "' . $arg3 . '" |' or die "cannot execute script";
  } else {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Memo_Perl.pl" "' . $arg . '" "' . $arg2 . '" |' or die "cannot execute script";
  }
  $line = <IN>;
  close IN;
  if (defined($arg3)) {
    DebugPrint($prestr . $arg2 . ' - ' . $arg3 . '  ' . $arg . ' ̗\ɒǉ܂');
  } else {
    DebugPrint($prestr . $arg2 . '  ' . $arg . ' ̗\ɒǉ܂');
  }
  $line = 'Q'; # this is hack ... ^^
}
if (($line =~ /^Q/) and defined($arg)) {
  if ($arg eq '挎') {
    if ($verbose) {
      $prestr .= '挎̑S\';
    } else {
      $prestr .= '挎̗\';
    }
    $tm = localtime;
    $year = $tm->year + 1900;
    $month = $tm->mon;
    if ($month == 0) {
      $year--;
      $month = 12;
    }
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Calendar_Perl.pl" ' . $verbose . ' ' . $year . ' ' . $month . ' |' or die "cannot execute script";
    @lines = <IN>;
    $line = join('', @lines);
    close IN;
    DebugPrint($prestr . "\n");
    DebugPrint($line . $poststr);
    exit;
  } elsif ($arg eq '') {
    if ($verbose) {
      $prestr .= '̑S\';
    } else {
      $prestr .= '̗\';
    }
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Calendar_Perl.pl" ' . $verbose . ' 1 |' or die "cannot execute script";
    @lines = <IN>;
    $line = join('', @lines);
    close IN;
    DebugPrint($prestr . "\n");
    DebugPrint($line . $poststr);
    exit;
  } elsif ($arg eq '') {
    if ($verbose) {
      $prestr .= '̑S\';
    } else {
      $prestr .= '̗\';
    }
    $tm = localtime;
    $year = $tm->year + 1900;
    $month = $tm->mon + 1 + 1;
    if ($month > 12) {
      $year++;
      $month -= 12;
    }
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Calendar_Perl.pl" ' . $verbose . ' ' . $year . ' ' . $month . ' |' or die "cannot execute script";
    @lines = <IN>;
    $line = join('', @lines);
    close IN;
    DebugPrint($prestr . "\n");
    DebugPrint($line . $poststr);
    exit;
  } elsif ($arg =~ /^([0-9]+)N([0-9]+)$/) {
    if ($verbose) {
      $prestr .= $arg . '̑S\';
    } else {
      $prestr .= $arg . '̗\';
    }
    $year = $1;
    $month = $2;
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Calendar_Perl.pl" ' . $verbose . ' ' . $year . ' ' . $month . ' |' or die "cannot execute script";
    @lines = <IN>;
    $line = join('', @lines);
    close IN;
    DebugPrint($prestr . "\n");
    DebugPrint($line . $poststr);
    exit;
  } elsif ($arg =~ /^([0-9]+)$/) {
    if ($verbose) {
      $prestr .= $arg . '̑S\';
    } else {
      $prestr .= $arg . '̗\';
    }
    $arg =~ s/$//;
    $tm = localtime;
    $year = $tm->year + 1900;
    $month = $tm->mon + 1;
    if ($arg < $month) {
      $year++;
    }
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Calendar_Perl.pl" ' . $verbose . ' ' . $year . ' ' . $arg . ' |' or die "cannot execute script";
    @lines = <IN>;
    $line = join('', @lines);
    close IN;
    DebugPrint($prestr . "\n");
    DebugPrint($line . $poststr);
    exit;
  } elsif ($arg eq 'T') {
    $datestr = &getdatestr('');
    ($year, $month, $day) = split(/[\/ \(]/, $datestr);
    $yobinum = &day_of_week($year, $month, $day);
    $first = 1;
    $line = '';
    @lines = ();
    if ($yobinum == 1) {
      $first = 0;
      open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "̗\" |' or die "cannot execute script";
      @lines = <IN>;
      $line .= join('', @lines);
      close IN;
    }
    if ($yobinum == 2 or not $first) {
      if ($first) {
        $first = 0;
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      } else {
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "Ηj̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      }
    }
    if ($yobinum == 3 or not $first) {
      if ($first) {
        $first = 0;
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      } else {
        $first = 0;
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "j̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      }
    }
    if ($yobinum == 4 or not $first) {
      if ($first) {
        $first = 0;
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      } else {
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "ؗj̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      }
    }
    if ($yobinum == 5 or not $first) {
      if ($first) {
        $first = 0;
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      } else {
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "j̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      }
    }
    if ($yobinum == 6 or not $first) {
      if ($first) {
        $first = 0;
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      } else {
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "yj̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      }
    }
    if ($yobinum == 0 or not $first) {
      if ($first) {
        $first = 0;
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      } else {
        open IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "j̗\" |' or die "cannot execute script";
        @lines = <IN>;
        $line .= join('', @lines);
        close IN;
      }
    }
    exit;
  } else {
    $datestr = &getdatestr($arg);
    if (length($datestr) != 0) {
      $tmparg = $datestr;
      ($year, $month, $day) = split(/[\/ \(]/, $datestr);
      $datestr .= '(' . $yobi[&day_of_week($year, $month, $day)] . ')';
      if ($arg =~ /^[0-9]+\/[0-9]+\/[0-9]+/) {
        $prestr .= $datestr . ' ̗\';
      } else {
        $prestr .= $arg . ' ' . $datestr . ' ̗\';
      }
      $arg = $tmparg;
    } else {
      $prestr .= $arg . ' ̗\';
    }
    $arg = quotemeta $arg; # not sure ...
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ViewMemo_Perl.pl" "' . $arg . '" |' or die "cannot execute script";
    @lines = <IN>;
    $line = join('', @lines);
    close IN;
    if (length($line) != 0) {
      DebugPrint($prestr . "\n");
      DebugPrint($line . $poststr);
    } else {
      DebugPrint($prestr . "܂");
    }
    exit;
  }
} else {
  $root = {}; # should not use my
  &initnode($root, 'root', '', '', '');
  &gentree($root, $responsefile);
  &response($root);
}
if (not $responded) { # IEԂ...
  $generated_random_number = int(rand(3));
  if ($generated_random_number == 0) {
    DebugPrint($prestr . $line);
  } elsif ($generated_random_number == 1) {
    $line =~ s/\?+$//;
    DebugPrint("line = $line");
    DebugPrint($prestr . '킽' . $line);
  } else {
    $line =~ s/\?+$//;
    DebugPrint($prestr . $line . 'ȂČȂł');
  }
  exit;
}
DebugPrint($prestr . "\n");
if (length($line) != 0) {
  DebugPrint($line);
}
if (length($poststr) != 0) {
  DebugPrint($poststr);
}
# [[Re: Getting Day of Week for a specific date!http://granite.unh.edu/pasnews/msg00674.html]]
sub day_of_week {
  my($y, $m, $d) = @_;
  @t = (0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4);
  $y -= ($m < 3);
  return ($y + int($y / 4) - int($y / 100) + int($y / 400) +$t[$m - 1] + $d) % 7;
}
sub getdatestr {
  my($str) = @_;
  $res = '';
  if ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Yesterday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Today_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Tomorrow_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\DayAfterTomorrow_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextMonday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextTuesday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextWednesday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextThursday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextFriday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^Ty/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextSaturday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextSunday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^T/) or ($str =~ /^T/)) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextFriday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^T/ or $str =~ /^T/)) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\MondayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\TuesdayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\WednesdayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThursdayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^T/ or $str =~ /^T/)) { # may not be true ...
    open IN, '"' . $perl . '" "' . $templatesfolder . '\FridayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^Ty/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\SaturdayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\SundayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^ėT/ or $str =~ /^ėT/)) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\MondayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\TuesdayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\WednesdayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThursdayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^ėT/ or $str =~ /^ėT/)) { # may not be true ...
    open IN, '"' . $perl . '" "' . $templatesfolder . '\FridayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėTy/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\SaturdayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\SundayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^挎/) {
    if ($str =~ /^挎([0-9]+)()?/) {
      $tmpday = $1;
      open IN, '"' . $perl . '" "' . $templatesfolder . '\PrevMonth_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
      $res =~ s/[0-9]+$/$tmpday/;
    } else {
      $res = '挎'; # currently not right ... think later ...
    }
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisMonth_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    if ($str =~ /^([0-9]+)()?/) {
      $tm = localtime;
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900, $tm->mon + 1, $1);
    } else {
      open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisMonth_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
    }
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\StartOfNextMonth_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    if ($str =~ /^([0-9]+)()?/) {
      $tmpday = $1;
      open IN, '"' . $perl . '" "' . $templatesfolder . '\NextMonth_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
      $res =~ s/[0-9]+$/$tmpday/;
    } else {
      open IN, '"' . $perl . '" "' . $templatesfolder . '\NextMonth_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
    }
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisQuarter_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\StartOfNextQuarter_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextQuarter_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^N/) {
    if ($str =~ /^N([0-9]+)\/([0-9]+)/) {
      $tm = localtime;
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900, $1, $2);
    } else {
      open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisYear_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
    }
  } elsif ($str =~ /^N/) {
    if ($str =~ /^N([0-9]+)\/([0-9]+)/) {
      $tm = localtime;
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900 + 1, $1, $2);
    } else {
      open IN, '"' . $perl . '" "' . $templatesfolder . '\NextYear_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
    }
  } elsif ($str =~ /^j/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextMonday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^Ηj/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextTuesday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^j/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextWednesday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ؗj/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextThursday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^j/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextFriday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^yj/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextSaturday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^j/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextSunday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^([0-9]+)(\/|N)[ @]*([0-9]+)(\/|)[ @]*([0-9]+)/) {
    $res = sprintf("%04d/%02d/%02d" , $1, $3, $5);
  } elsif ($str =~ /^([0-9]+)N[ @]*([0-9]+)/) {
    $res = sprintf("%04dN%02d" , $1, $2);
  } elsif ($str =~ /^([0-9]+)(\/|)[ @]*([0-9]+)/) {
    $tm = localtime;
    if ($1 < $tm->mon + 1) { # better ?
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900 + 1, $1, $3);
    } else {
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900, $1, $3);
    }
  } elsif ($str =~ /^([0-9]+)(\x8C\x8E|\x96\x96)/) { # | is not functioning? or OK? ^^
    $tm = localtime;
    $mn = $1;
    if ($mn < $tm->mon + 1) { # better ?
      $yr = $tm->year + 1900 + 1;
    } else {
      $yr = $tm->year + 1900;
    }
    $dt = &GetLastDayOfMonth($yr, $mn);
    $res = sprintf("%04d/%02d/%02d" , $yr, $mn, $dt);
  } elsif ($str =~ /^([0-9]+)/) {
    $tm = localtime;
    $mn = $1;
    if ($mn < $tm->mon + 1) { # better ?
      $yr = $tm->year + 1900 + 1;
    } else {
      $yr = $tm->year + 1900;
    }
    $dt = 15;
    $res = sprintf("%04d/%02d/%02d" , $yr, $mn, $dt);
  } elsif (($str =~ /^([0-9]+) /) and $1 < 32) { # this is hack ...
    $tm = localtime;
    $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900, $tm->mon + 1, $1);
  }
  return $res;
}
# [[Penguin Club-Perl!http://penguinclub.net/linux/perl/learn/page3.html]]
sub GetLastDayOfMonth {
  my($year, $month) = @_;
  @month_days = (0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
  if (($year % 4) == 0 and ($year % 100) != 0 or ($year % 400) == 0) {
    $month_days[2] = 29;
  }
  $last_date = $month_days[$month];
  return $last_date;
}
sub zen2han {
  my($str) = @_;
  $str =~ s/i/(/g;
  $str =~ s/j/)/g;
  $str =~ s/F/:/g;
  $str =~ s/`/-/g;
  $str =~ s/\x81\x7C/-/g;
  $str =~ s/\x81\x5B/-/g; # [
  $str =~ s/\x81\x5E/\//g; # ^ does not work?
  $str =~ s/@/ /g;
  $str =~ s/`/A/g;
  $str =~ s/a/B/g;
  $str =~ s/b/C/g;
  $str =~ s/c/D/g;
  $str =~ s/d/E/g;
  $str =~ s/e/F/g;
  $str =~ s/f/G/g;
  $str =~ s/g/H/g;
  $str =~ s/h/I/g;
  $str =~ s/i/J/g;
  $str =~ s/j/K/g;
  $str =~ s/k/L/g;
  $str =~ s/l/M/g;
  $str =~ s/m/N/g;
  $str =~ s/n/O/g;
  $str =~ s/o/P/g;
  $str =~ s/p/Q/g;
  $str =~ s/q/R/g;
  $str =~ s/r/S/g;
  $str =~ s/s/T/g;
  $str =~ s/t/U/g;
  $str =~ s/u/V/g;
  $str =~ s/v/W/g;
  $str =~ s/w/X/g;
  $str =~ s/x/Y/g;
  $str =~ s/y/Z/g;
  $str =~ s/O/0/g;
  $str =~ s/P/1/g;
  $str =~ s/Q/2/g;
  $str =~ s/R/3/g;
  $str =~ s/S/4/g;
  $str =~ s/T/5/g;
  $str =~ s/U/6/g;
  $str =~ s/V/7/g;
  $str =~ s/W/8/g;
  $str =~ s/X/9/g;
  $str =~ s//a/g;
  $str =~ s//b/g;
  $str =~ s//c/g;
  $str =~ s//d/g;
  $str =~ s//e/g;
  $str =~ s//f/g;
  $str =~ s//g/g;
  $str =~ s//h/g;
  $str =~ s//i/g;
  $str =~ s//j/g;
  $str =~ s//k/g;
  $str =~ s//l/g;
  $str =~ s//m/g;
  $str =~ s//n/g;
  $str =~ s//o/g;
  $str =~ s//p/g;
  $str =~ s//q/g;
  $str =~ s//r/g;
  $str =~ s//s/g;
  $str =~ s//t/g;
  $str =~ s//u/g;
  $str =~ s//v/g;
  $str =~ s//w/g;
  $str =~ s//x/g;
  $str =~ s//y/g;
  $str =~ s//z/g;
  return $str;
}
sub normalizetime {
  my($str) = @_;
  $str =~ /([0-9]+):([0-9]+)/;
  $hour = $1;
  $munute = $2;
  return sprintf("%02d:%02d", $hour, $minute);
}
sub normalizetimerange {
  my($str) = @_;
  $str =~ /([0-9]+):([0-9]+)\-([0-9]+):([0-9]+)/;
  $hour = $1;
  $munute = $2;
  $hour2 = $3;
  $munute2 = $4;
  return sprintf("%02d:%02d-%02d:%02d", $hour, $minute, $hour2, $minute2);
}
sub processscript {
  my($script) = @_;
  $scriptprocessor = $perl;
  if ($script =~ /_Perl$/) {
    $script .= '.pl';
  } elsif ($script =~ /_Python$/) {
    $script .= '.py';
    $scriptprocessor = $python;
  } elsif ($script =~ /_Ruby$/) {
    $script .= '.rb';
    $scriptprocessor = $ruby;
  }
  if (not ($script =~ /\\/)) { # customize here if needed ...
    $script = $templatesfolder . "\\" . $script;
  }
  $prestr .= $response;
  if (length($args) != 0) {
    if ($str =~ //) { # this ks hack think later ...
      $line =~ /(.*)/;
      $arg = $1;
      $arg =~ s/^["]+/"/;
      $arg =~ s/["]+$/"/;
    } elsif ($str =~ //) { # this ks hack think later ...
      $line =~ /(.*)/;
      $arg = $1;
      $arg =~ s/^["]*/"/;
      $arg =~ s/["]*$/"/;
    }
    if (defined($arg)) { # currently only this ...
      $args =~ s/\|/$arg/;
      $prestr =~ s/\|/$arg/;
    }
    $cmd = '"' . $scriptprocessor . '" "' . $script . '" ' . $args . ' |'; # | means pipe!!!
    open IN, $cmd or die "cannot execute script";
    $args =~ s/^"//;
    $args =~ s/"$//;
    @args = split(/" "/, $args); # this is assumed ...
    foreach $i (0..$#args) {
      $str = '\|' . ($i + 1);
      $argstr = $args[$i];
      $prestr =~ s/$str/$argstr/;
    }
  } elsif (defined($arg3)) {
    $arg =~ s/^["]+/"/;
    $arg =~ s/["]+$/"/;
    $arg2 =~ s/^["]+/"/;
    $arg2 =~ s/["]+$/"/;
    $arg3 =~ s/^["]+/"/;
    $arg3 =~ s/["]+$/"/;
    $cmd = '"' . $scriptprocessor . '" "' . $script . '" ' . $arg . ' ' . $arg2 . ' ' . $arg3 . ' |';
    open IN, $cmd or die "cannot execute script";
    $prestr =~ s/\|1/$arg/;
    $prestr =~ s/\|2/$arg2/;
    $prestr =~ s/\|3/$arg3/;
  } elsif (defined($arg2)) {
    $arg =~ s/^["]+/"/;
    $arg =~ s/["]+$/"/;
    $arg2 =~ s/^["]+/"/;
    $arg2 =~ s/["]+$/"/;
    $cmd = '"' . $scriptprocessor . '" "' . $script . '" ' . $arg . ' ' . $arg2 . ' |';
    open IN, $cmd or die "cannot execute script";
    $prestr =~ s/\|1/$arg/;
    $prestr =~ s/\|2/$arg2/;
  } elsif (defined($arg)) {
    $arg =~ s/^["]+/"/;
    $arg =~ s/["]+$/"/;
    $cmd = '"' . $scriptprocessor . '" "' . $script . '" ' . $arg . ' |';
    open IN, $cmd or die "cannot execute script";
    $prestr =~ s/\|/$arg/;
  } else {
    if ($str =~ /^/) { # think later ...
      $line =~ /(.*)(.*)/;
      $arg = $1;
      $arg2 = $2;
      if (length($arg) != 0 and length($arg2) != 0) {
        $arg =~ s/^["]+/"/;
        $arg =~ s/["]+$/"/;
        $arg2 =~ s/^["]+/"/;
        $arg2 =~ s/["]+$/"/;
        $cmd = '"' . $scriptprocessor . '" "' . $script . '" ' . $arg . ' ' . $arg2 . ' |';
        $prestr =~ s/\|1/$arg/;
        $prestr =~ s/\|2/$arg2/;
      } else {
        $line =~ /(.*)(.*)(.*)/;
        $arg = $1;
        $arg2 = $2;
        $arg3 = $3;
        if (length($arg) != 0 and length($arg2) != 0 and length($arg3)) {
          $arg =~ s/^["]+/"/;
          $arg =~ s/["]+$/"/;
          $arg2 =~ s/^["]+/"/;
          $arg2 =~ s/["]+$/"/;
          $arg3 =~ s/^["]+/"/;
          $arg3 =~ s/["]+$/"/;
          $cmd = '"' . $scriptprocessor . '" "' . $script . '" ' . $arg . ' ' . $arg2 . ' ' . $arg3 . ' |';
          $prestr =~ s/\|1/$arg/;
          $prestr =~ s/\|2/$arg2/;
          $prestr =~ s/\|3/$arg3/;
        } else {
          return 0;
        }
      }
    } elsif ($str =~ //) {
      $line =~ /(.*)/;
      $arg = $1;
      if (length($arg) != 0) {
        $arg =~ s/^["]+/"/;
        $arg =~ s/["]+$/"/;
        $cmd = '"' . $scriptprocessor . '" "' . $script . '" ' . $arg . ' |';
        $prestr =~ s/\|/$arg/;
      } else {
        return 0;
      }
    } elsif ($str =~ //) {
      $line =~ /(.*)/;
      $arg = $1;
      if (length($arg) != 0) {
        $arg =~ s/^["]+/"/;
        $arg =~ s/["]+$/"/;
        $cmd = '"' . $scriptprocessor . '" "' . $script . '" ' . $arg . ' |';
        $prestr =~ s/\|/$arg/;
      } else {
        return 0;
      }
    } else {
      $cmd = '"' . $scriptprocessor . '" "' . $script . '" |';
    }
    open IN, $cmd or die "cannot execute script";
  }
  @lines = <IN>; # may be better ...
  close IN;
  $line = join('', @lines);
  $line =~ s/[\n]+$//;
  if (length($line) == 0) {
    $poststr = '';
  } else {
    $line .= "\n";
  }
  return 1;
}
sub response {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    $foundresponse = '';
    $cn = $nd->{CHILD};
    if (&response_body(1)) {
      exit;
    }
    if (length($foundresponse) != 0) {
      DebugPrint($prestr . $foundresponse);
      exit;
    } elsif ($responded) {
      return;
    }
    $foundresponse = '';
    $cn = $nd->{CHILD};
    if (&response_body(0)) {
      exit;
    }
    if (length($foundresponse) != 0) {
      DebugPrint($prestr . $foundresponse);
      exit;
    }
  }
}
sub response_body {
  my($first) = @_;
  my $res = 0;
  while (1) {
    if ($first and $cn->{KIND} =~ /\$/ or not $first and not $cn->{KIND} =~ /\$/) {
      $str = $cn->{NAME};
      $quotedstr = quotemeta $str;
      if ((not $str =~ /^_/) and ($line =~ /$quotedstr/i)) {
        $response = $cn->{TEXT};
        $response =~ s/ \CRLF /\n/g;
        ($script, $args) = split(/ /, $cn->{TYPE}, 2);
        $args =~ s/\[\[TemplatesFolder\]\]/$templatesfolder/g;
        $args =~ s/\[\[WeblogFolder\]\]/$weblogfolder/g;
        if (length($script)) {
          if (($script =~ /\_Perl(\.pl)?$/) or ($script =~ /\_Python(\.py)?$/) or ($script =~ /\_Ruby(\.rb)?$/)) { # customize here for ruby / python etc ...
            $responded = &processscript($script);
            last;
          }
        } else {
          if (length($response) != 0) {
            $foundresponse = $response;
          }
          if (not defined($cn->{CHILD})) {
            DebugPrint($prestr . $foundresponse);
            $res = 1;
            last;
          } else {
            $cn = $cn->{CHILD};
            next;
          }
        }
      }
    }
    if (not defined($cn->{NEXT})) {
      last;
    }
    $cn = $cn->{NEXT};
  }
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
