# File: Aozora2Html_Perl.pl
# Date            Author        number of nodes
# 2002/8/2        Walking Lint  111
# 2002/8/1        Walking Lint  89

=pod

=head1 NAME

Aozora2Html_Perl.pl - t@C -> html

=head1 DESCRIPTION

ex. perl.exe Aozora2Html_Perl.pl D:\tmp\gubijinsou_ruby.txt

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
$opt = shift;
if ($opt eq '-i') {
  $aozora_file = shift;
  $opt_i = 1;
} else {
  $aozora_file = $opt;
}
$height = '300px';
$base_file = $aozora_file;
$base_file =~ s/\.txt$/\.html/;
$css = 'HTMLTate.css';
open IN, $aozora_file || die("Can't open $from_file: $!\n");
open OUT, ">$base_file";
$first = 1;
$second = 0;
$sub_file_index = 0;
$generating_sub_file = 0;
$sub_file = '';
$epilogue = 0;
$found_space = 0;
$line_counter = 0;
while (<IN>) {
  $tmp = $_;
  if ($first) {
    $first = 0;
    $second = 1;
    $title = $_;
    chop $title;
  } elsif ($second) {
    $second = 0;
    $author = $_;
    chop $author;
    print OUT <<"END";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>$title - $author</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="$css" />
</head>
<body background="back.jpg">
<div style="direction:ltr; writing-mode:tb-rl; height:$height">
<h1>$title<br>$author</h1>
END
  } else {
    $_ =~ s/s/i/g;
    $_ =~ s/t/j/g;
    if (/^{/) {
      $generating_sub_file = 0;
      $epilogue = 1;
    }
    if ((not defined($opt_i)) and (not $epilogue) and ($found_space and ($_ =~ /^([ ]{4,}|[@]{8,})/) or &check_section($_))) { # this is hack ...
      $_ =~ /^[ @]*(.+)/;
      $sub_title = $1;
      if (length($sub_file) != 0) {
        print OUT2 <<"END";
</div>
</body>
</html>
END
        close OUT2;
        print STDERR "generated $sub_file\n";
      }
      $generating_sub_file = 1;
      $sub_file_index++;
      $sub_file = $base_file;
      $sub_file =~ s/\.html$//;
      $sub_file = $sub_file . $sub_file_index . '.html';
      open OUT2, ">$sub_file";
      print OUT2 <<"END";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>$title - $sub_title</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="$css" />
</head>
<body background="back.jpg">
<div style="direction:ltr; writing-mode:tb-rl; height:$height">
<h2>$sub_title</h2>
END
      $base_sub_file = basename($sub_file);
      print OUT <<"END";
<h2><a href="$base_sub_file">$sub_title</a></h2>
END
    } elsif ($generating_sub_file) {
      $_ =~ s/^/<p>/;
      $_ =~ s/$/<\/p>/;
      print OUT2 $_;
    } else {
      $_ =~ s/$/<br>/;
      if (/-----/) {
        $line_counter++;
      }
      if (($line_counter >= 2) and (not $epilogue)) {
        $_ =~ s/^/<p>/;
        $_ =~ s/$/<\/p>/;
      }
      $_ =~ s/-----(-)+/<hr>/;
      $_ =~ s/http:\/\/[0-9a-zA-Z\.\/]+/<a href="$&">$&<\/a>/;
      print OUT $_;
    }
  }
  chop $tmp;
  $tmp =~ s/[ @]+//;
  if (length($tmp) == 0) {
    $found_space = 1;
  } else {
    $found_space = 0;
  }
}
if (length($sub_file) != 0) {
  print OUT2 <<"END";
</div>
</body>
</html>
END
  close OUT2;
  print STDERR "generated $sub_file\n";
}
close IN;
print OUT <<"END";
</div>
</body>
</html>
END
close OUT;
print STDERR "generated $base_file\n";
sub check_section {
  my($line) = @_;
  if (($line =~ /^[ @]*/) or ($line =~ /^[ @]*/) or ($line =~ /^[ @]*O/) or ($line =~ /^[ @]*l/) or ($line =~ /^[ @]*/)) {
    return 1;
  } elsif (($line =~ /^[ @]*Z/) or ($line =~ /^[ @]*掵/) or ($line =~ /^[ @]*攪/) or ($line =~ /^[ @]*/)) {
    return 1;
  } elsif (($line =~ /^[ @]*\/)) {
    return 1;
  } else {
    return 0;
  }
}
