root () //  %% File: CVTree_Ruby.rb CRLF Date            Author        number of nodes CRLF 2002/12/7       Walking Lint  232 CRLF 2002/11/23      Walking Lint  232 CRLF 2002/11/16      Walking Lint  203 CRLF 2002/11/5       Walking Lint  204 CRLF 2002/11/1       Walking Lint  202 CRLF 2002/10/30      Walking Lint  196 CRLF 2002/10/30      Walking Lint  218 (CVTree_Ruby.CVTree_Ruby) CRLF 2002/10/23      Walking Lint  218 (CVTree.CVTree_Ruby) CRLF 2002/10/16      Walking Lint  155 CRLF 2002/10/15      Walking Lint  144 CRLF 2002/10/8       Walking Lint  137 CRLF 2002/10/1       Walking Lint  135 CRLF 2002/9/30       Walking Lint  128 CRLF 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Ruby.CVTree) CRLF 2002/9/28       Walking Lint  182 CRLF 2002/9/22       Walking Lint  178 CRLF 2002/7/16       Walking Lint  143 (GenCategorizedText_Ruby.ExtractCategorizedText_Ruby) CRLF 2002/7/15       Walking Lint  126 CRLF 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Ruby.GenCategorizedText_Ruby) CRLF 2002/6/7        Walking Lint  136 CRLF 2002/6/4        Walking Lint  131 CRLF 2002/4/21       Walking Lint  120 CRLF 2002/4/12       Walking Lint  112 CRLF 2002/4/4        Walking Lint  85
	_doc ()
		NAME () //  %% CVTree_Ruby.rb - package for CV tree
		DESCRIPTION () //  %% ex. root = {}; CRLF     initnode(root'); CRLF     gentree(root, './CVTree.pat'); CRLF     printtree(root, '  ');
		AUTHOR () //  %% Walking Lint
	addchildnode ()
		pn (in) &
		name (in) &
		kind (in) &
		type (in) &
		text (in) &
		_note () // commented out (2002/11/16)
			Trace () // "addchildnode(#{pn}, #{name}, #{kind}, #{type}, ...)"
		_note () // commented out (2002/11/16)
			Trace () // "addchildnode(#{name}, #{kind}, #{type}, ...)"
		if () // pn['CHILD'] != nil
			cn (out) //   pn['CHILD']
			while () // cn['NEXT'] != nil
				cn (out) //   cn['NEXT']
			return () // addnode(cn, name, kind, type, text)
		else ()
			pn (out) // ['CHILD']  {}
			initnode () // pn['CHILD'], name, kind, type, text
			pn (out) // ['CHILD']['PARENT']  pn
			return () // pn['CHILD']
	addnode ()
		nd (in) &
		name (in) &
		kind (in) &
		type (in) &
		text (in) &
		_note () // commented out (2002/11/16)
			Trace () // "addnode(#{name}, #{kind}, #{type}, ...)"
		prevnextnode (out) //   nd['NEXT']
		nd (out) // ['NEXT']  {}
		initnode () // nd['NEXT'], name, kind, type, text
		nd (out) // ['NEXT']['PREV']  nd
		nd (out) // ['NEXT']['PARENT']  nd['PARENT']
		nd (out) // ['NEXT']['NEXT']  prevnextnode
		if () // prevnextnode != nil
			prevnextnode (out) // ['PREV']  nd
		return () // nd['NEXT']
	delnode ()
		nd (in) &
		if () // nd['PREV'] != nil
			nd (out) // ['PREV']['NEXT']  nd['NEXT']
			if () // nd['NEXT'] != nil
				nd (out) // ['NEXT']['PREV']  nd['PREV']
		else ()
			if () // nd['PARENT'] != nil
				nd (out) // ['PARENT']['CHILD']  nd['NEXT']
		nd (out) // ['PARENT']  nil
		nd (out) // ['PREV']  nil
		nd (out) // ['NEXT']  nil
	extractparams ()
		line (in) &
		found_text (out) //   0
		pre, post (out) //   line.split(/\(\) \+|\(\) \-|\(\)|\(in\)|\(out\)|\(inout\)/, 2)
		pre (inout) // =~ /^([\t]*)(.+)/
		if () // $1 == nil
			level (out) //   0
		else ()
			level (out) //   $1.length %% think later ...
		name (out) //   $2
		kind, post (out) //   post.split(/\/\/ /, 2)
		line =~ /( \(\) \+| \(\) \-| \(\)| \(in\)| \(out\)| \(inout\))/ (out)
		kind (out) //   $1 + ' ' + kind
		if () // post =~ /\%\% /
			_note () // commented out (2002/11/5)
				post (inout) // =~ /(.*)\%\% (.+)/;
				type (out) //   $1
				text (out) //   $2
			type, text (out) //   post.split(/\%\% /, 2)
		else () //  %% not actually ...
			type (out) //   post
			text (out) //   ''
		type (inout) // .gsub!(/[ ]+$/, '') unless type == nil
		name (inout) // .gsub!(/[ ]+$/, '') unless name == nil
		return () // [level, name, kind, type, text]
	gentree ()
		nd (in) &
		from_file (in) &
		_note () // commented out (2002/9/30)
			Trace () // "enter gentree($nd, $from_file)"
		_note () // commented out (2002/11/16)
			commentouted (out) //   false
			commentout_tabs (out) //   ''
		_note () // commented out (2002/9/30)
			DebugPrint () // "from_file = $from_file"
		if () // from_file.length != 0
			infile (out) //   open(from_file, "r")
		else ()
			infile (out) //   $stdin
		_ () //  %% gen tree from fn ...
		prevlevel (out) //   0
		cur (out) //   nd
		first (out) //   true
		while () // line = infile.gets
			line.chop! ()
			_note () // commented out (2002/11/16)
				if () // commentouted
					if () // line =~ /^commentout_tabs/
						next ()
					else ()
						commentouted (out) //   false
				if () // line =~ /^([\t]+)_note /
					commentouted (out) //   true
					commentout_tabs (out) //   $1 + "\t"
				else ()
			if () // line =~ /^\t/
				level, name, kind, type, text (out) //   extractparams(line)
				_ () //  %% construct tree here ...
				if () // prevlevel < level
					cur (out) //   addchildnode(cur, name, kind, type, text)
				elsif () // prevlevel == level
					cur (out) //   addnode(cur, name, kind, type, text)
				else ()
					until () // prevlevel == level
						cur (out) //   cur['PARENT']
						prevlevel (inout) // -= 1
					cur (out) //   addnode(cur, name, kind, type, text)
				prevlevel (out) //   level
			elsif () // first
				first (out) //   false
				level, name, kind, type, text (out) //   extractparams(line)
				nd['TEXT'] (out) //   text
			else ()
				_ () //  %% do nothing ...
		if () // from_file.length != 0
			infile.close ()
	initnode ()
		nd (in) &
		name (in) &
		kind (in) &
		type (in) &
		text (in) &
		nd['NAME'] (out) //   name
		nd['KIND'] (out) //   kind
		nd['TYPE'] (out) //   type
		nd['TEXT'] (out) //   text
		nd['PARENT'] (out) //   nil
		nd['CHILD'] (out) //   nil
		nd['PREV'] (out) //   nil
		nd['NEXT'] (out) //   nil
	insnode ()
		nd (in) &
		name (in) &
		kind (in) &
		type (in) &
		text (in) &
		prevprevnode (out) //   nd['PREV']
		nd (out) // ['PREV']  {}
		initnode () // nd['PREV'], name, kind, type, text
		nd (out) // ['PREV']['NEXT']  nd
		nd (out) // ['PREV']['PARENT']  nd['PARENT']
		nd (out) // ['PREV']['PREV']  prevprevnode
		if () // prevprevnode != nil
			prevprevnode (out) // ['NEXT']  nd['PREV']
		else ()
			nd (out) // ['PARENT']['CHILD']  nd['PREV']
		return () // nd['PREV']
	printnode ()
		nd (in) &
		ind (in) &
		$stderr.print () // "#{ind}NAME: #{nd['NAME']} KIND: #{nd['KIND']} "
		$stderr.print () // "TYPE: #{nd['TYPE']}\n"
	printtree ()
		nd (in) &
		ind (in) &
		sep (in) &
		printnode () // nd, ind
		if () // nd['CHILD'] != nil
			printtree () // nd['CHILD'], ind + sep, sep
		if () // nd['NEXT'] != nil
			printtree () // nd['NEXT'], ind, sep
	savenode ()
		nd (in) &
		ind (in) &
		outfile (in) &
		if () // nd['KIND'] == nil
			kind (out) //   ' ()'
		else ()
			kind (out) //   nd['KIND']
		kind (inout) // .gsub!(/[ ]+$/, '')
		type (out) //   ''
		if () // (nd['TYPE'] != nil) or (nd['TEXT'] != nil)
			type (out) //   " \/\/ "
			if () // nd['TYPE'] != nil
				type (inout) // += nd['TYPE']
		text (out) //   ''
		if () // nd['TEXT'] != nil
			text (out) //   " \%\% " + nd['TEXT']
		outfile.printf () // "%s%s%s%s%s\n", ind, nd['NAME'], kind, type, text
	savetree ()
		nd (in) &
		to_file (in) &
		_note () // commented out (2002/10/23)
			Trace () // "enter savetree($nd->{NAME})"
		_note () // commented out (2002/11/1)
			outfile (out) //   open (to_file + "tmp", "w")
		sep (out) //   "\t"
		if () // to_file.length != 0
			outfile (out) //   open (to_file, "w")
		else ()
			outfile (out) //   $stdout
		savenode () // nd, '', outfile
		if () // nd['CHILD'] != nil
			savetreebody () // nd['CHILD'], sep, sep, outfile
		if () // to_file.length != 0
			outfile.close ()
	savetreebody ()
		nd (in) &
		ind (in) &
		sep (in) &
		outfile (in) &
		_note () // commented out (2002/10/23)
			Trace () // "enter savetreebody($nd->{NAME})"
		savenode () // nd, ind, outfile
		if () // nd['CHILD'] != nil
			savetreebody () // nd['CHILD'], ind + sep, sep, outfile
		if () // nd['NEXT'] != nil
			savetreebody () // nd['NEXT'], ind, sep, outfile
	DebugPrint ()
		str (in) &
		$stderr.print () // "#{str}\n"
	Trace ()
		str (in) &
		$stderr.print () // "#{str}\n"
	if () // __FILE__ == $0
		root (out) //   {}
		initnode () // root, 'root', '', '', ''
		gentree () // root, './Memo.pat'
		printtree () // root, '', '  '
