root () //  %% File: Calendar_Perl.pl CRLF Date            Author        number of nodes CRLF 2003/3/23       Walking Lint  120 CRLF 2003/2/25       Walking Lint  119 CRLF 2002/12/25      Walking Lint  110 CRLF 2002/12/9       Walking Lint  110 CRLF 2002/12/7       Walking Lint  81 CRLF 2002/11/20      Walking Lint  36
	_doc ()
		NAME () //  %% Calendar_Perl.pl - generate calendar
		DESCRIPTION () //  %% ex1. perl.exe Calendar_Perl.pl 0 1 CRLF ex2. perl.exe Calendar_Perl.pl 0 2003 1
		AUTHOR () //  %% [[Author]]
	use () // Time::localtime
	_note () // commented out (2002/12/7)
	$verbose (out) //   0
	$perl (out) //   $ENV{PERL}
	$perl (inout) // =~ s/"//g
	$templatesfolder (out) //   $ENV{TEMPLATESFOLDER}
	$templatesfolder (inout) // =~ s/"//g
	if () // @ARGV == 3
		$verbose (out) //   shift %% this is hack ...
		$textmode (out) //   1
		$year (out) //   shift
		$month (out) //   shift
		$today (out) //   99 %% hack
	elsif () // @ARGV == 2
		$verbose (out) //   shift %% this is hack ...
		_note () // commented out (2002/12/9)
			DebugPrint () // "verbose = $verbose"
		$textmode (out) //   shift
		_note () // commented out (2002/12/9)
			DebugPrint () // "textmode = $textmode"
		$tm (out) //   localtime
		$year (out) //   $tm->year + 1900
		$month (out) //   $tm->mon + 1
		$today (out) //   $tm->mday
	else () //  %% @ARGV == 0 or 1
		$textmode (out) //   shift
		$tm (out) //   localtime
		$year (out) //   $tm->year + 1900
		$month (out) //   $tm->mon + 1
		$today (out) //   $tm->mday
	$memo (out) //   ''
	$from_file (out) //   $templatesfolder . '\Memo.pat'
	@dates (out) //   ()
	if () // $textmode and -e $from_file
		$/ (out) //   undef
		open () // IN, $from_file || die("Can't open $from_file: $!\n")
		$memo (out) //   <IN>
		$memo (inout) // =~ s/root \(\) .*//
		close () // IN
	$lastday (out) //   (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)[$month - 1] + ($month == 2 && ($year % 4 == 0 && $year % 100 != 0 || $year % 400 == 0))
	if () // $textmode
		_note () // commented out (2002/12/26)
			printf () // " ----- $year/$month -----\n\n Sn Mn Tu Wd Th Fr St\n"
		printf () // " --------- $year/$month ---------\n\n Sn  Mn  Tu  Wd  Th  Fr  St\n"
	else ()
		<<END (in) //  %% <table bgcolor="white"> CRLF <tr> CRLF <td colspan="7" align="center"> CRLF $year/$month CRLF </td> CRLF </tr> CRLF <tr align="center"> CRLF <td>Sn</td><td>Mn</td><td>Tu</td><td>Wd</td><td>Th</td><td>Fr</td><td>St</td> CRLF </tr> CRLF <tr align="right">
		print ()
	$count (out) //   1
	foreach () // $_ (&yobi($year, $month), 1 .. $lastday)
		if () // $textmode
			$datepattern (out) //   sprintf("%d\/(%d|%02d)\/(%d|%02d)([^0-9]|\$)", $year, $month, $month, $_, $_)
			$date (out) //   sprintf("%d\/%02d\/%02d", $year, $month, $_)
			_note () // commented out (2002/12/7)
				DebugPrint () // "datepattern = $datepattern"
			$datestr (out) //   $_
			if () // $_ == $today
				_note () // commented out (2002/12/7)
					$day (out) //   sprintf("%3s", '*' . $datestr)
				$datestr (out) //   '*' . $datestr
			if () // $memo =~ /$datepattern/
				_note () // commented out (2002/12/26)
					DebugPrint () // "memo = $memo"
				$datestr (out) //   $datestr . '+'
				push () // @dates, $date
			else ()
				$datestr (out) //   $datestr . ' '
			_note () // commented out (2002/12/7)
				else ()
					$day (out) //   sprintf(" %2d", $datestr)
			_note () // commented out (2002/12/26)
				$day (out) //   sprintf("%3s", $datestr)
			$day (out) //   sprintf("%4s", $datestr)
		else ()
			$day (out) //   "<td>$_</td>"
			if () // $count % 7 == 1
				$day (out) //   "<td><font color=\"red\">$_</font></td>"
			elsif () // $count % 7 == 0
				$day (out) //   "<td><font color=\"blue\">$_</font></td>"
		print () // $day
		if () // $count % 7 == 0
			if () // $textmode
				print () // "\n"
			else ()
				<<EMD (in) //  %% </tr> CRLF <tr align="right">
				print ()
		$count (inout) // ++
	if () // $textmode
		print () // "\n\n"
		if () // $verbose
			foreach () // $date (@dates)
				$line (out) //   ''
				@lines (out) //   ()
				_note () // commented out (2002/12/9)
					open () // IN, '"' . $perl . '" "' . $templatesfolder . '\AI_Perl.pl" "' . $date . '̗\" |' or die "cannot execute script"
				open () // IN, '"' . $perl . '" "' . $templatesfolder . '\ViewMemo_Perl.pl" "' . $date . '" |' or die "cannot execute script"
				@lines (out) //   <IN>
				$line (inout) // .= join('', @lines)
				close () // IN
				print () // $line
	else ()
		<<END (in) //  %% </tr> CRLF </table>
		print ()
	yobi ()
		$year (in) &
		$month (in) &
		if () // $month == 1 || $month == 2
			$year (inout) // --
			$month (inout) // += 12
		$cnt (out) //   int($year + int($year / 4) - int($year / 100) + int($year / 400) +int((13 * $month + 8) / 5) + 1) % 7
		@ret (out) //   ()
		foreach () // (1..$cnt)
			push () // @ret, ''
		return () // @ret
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
