# File: CapitalizeWords_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 21
# 2003/8/6        Walking@Lint 15
# 2003/7/18       Walking Lint  14
# 2003/7/18       Walking Lint  13 (CapitalizeWord_Perl->CapitalizeWords_Perl)
# 2003/7/18       Walking Lint  18
# 2003/7/18       Walking Lint  18 (2OneLine_Perl->CapitalizeWord_Perl)
# 2003/7/17       Walking Lint  18
# 2003/7/16       Walking Lint  18
# 2003/6/15       Walking Lint  14
# 2003/6/8        Walking Lint  13
# 2003/5/26       Walking Lint  9
# 2003/5/26

=pod

=head1 NAME

CapitalizeWords_Perl.pl - capitalize words

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use locale;
$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  $_ =~ s/(\w+)/\u\L$1/g;
  print $_;
  if ($breaklater) {
    last;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
