# File: CommentOutLines_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 34
# 2003/8/6        Walking@Lint 28
# 2002/10/15      Walking Lint  26
# 2002/10/15      Walking Lint  26 (2Strong_Perl->CommentOutLines_Perl)
# 2002/10/1       Walking Lint  9
# 2002/8/16       Walking Lint  48 (Csv2Label_Perl->2Strong_Perl)
# 2002/8/16       Walking Lint  43 (Csv2TackSheet_Perl->Csv2Label_Perl)
# 2002/8/16       Walking Lint  21 (Csv2HtmlTagsPages_Perl->Csv2TackSheet_Perl)
# 2002/6/14       Walking Lint  10 (CSV2Table_Perl->Csv2HtmlTagsPages_Perl)
# 2002/4/20       Walking Lint  10

=pod

=head1 NAME

CommentOutLines_Perl.pl

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use Time::localtime;
$tm = localtime;
$commentoutstr = '_note () // commented out (' . sprintf("%04d/%02d/%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday) . ')';
$first = 1;
$pendingline = '';
$breaklater = 0;
sub while {
  sub if {
    break;
  sub elsif {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  $_ =~ /^(\t)(.+)/;
  sub if {
    $first = 0;
    sub if {
      $line .= $1 . $commentoutstr . "\n\t" . $_;
    sub else {
      $line .= $commentoutstr . "\n";
      $pendingline = $_;
    }
  sub else {
    sub if {
      $line .= "\t" . $1 . $pendingline; # not actually ...
      $pendingline = '';
    }
    $line .= "\t" . $_;
  }
  sub if {
    break;
  }
}
sub if {
  $line .= "\t" . $pendingline; # not actually ...
}
print "$line";
root () //  %% File: CountChars_Perl.pl
Date            Author        number of nodes
2003/8/8        Walking@Lint 33
2003/5/14       Walking Lint  31
2003/5/14       Walking Lint  15 (wc_Perl->CountChars_Perl)
2003/3/19       Walking Lint  15
2002/4/21       Walking Lint  6 (WordCount_Perl->wc_Perl)
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - count chars
		DESCRIPTION () //  %% activate as filter
		AUTHOR () //  %% [[Author]]
	$use_tk (out) //   shift
	$han (out) //   0
	$zen (out) //   0
	$total (out) //   0
	while () // <STDIN>
		if () // $_ =~ /^__EOF__$/
			break ()
		$zen (inout) // += ($_ =~ tr/\xa1-\xfe/\xa1-\xfe/)
		$han (inout) // += ($_ =~ tr/\x21-\x7e/\x21-\x7e/)
		$total (inout) // += length($_)
		print () // $_
	$han (inout) // -=  $zen
	$else (out) //   $total - $zen - $han
	if () // $use_tk
		use () // Tk
		$mw (out) //   new MainWindow
		$lab (out) //   $mw->Label(-anchor => "w", -text => "zenkaku = $zen\nhankaku(\\x2a - \\x7e) = $han\nhankaku(else) = $else\n----------------------------\ntotal = $total") %% anchor is not functioning ??
		$lab (out) // ->pack()
		MainLoop ()
	else ()
		DebugPrint () // ""
		DebugPrint () // "zenkaku = $zen"
		DebugPrint () // "hankaku(\\x2a - \\x7e) = $han"
		DebugPrint () // "hankaku(else) = $else"
		DebugPrint () // "----------------------------"
		DebugPrint () // "total = $total"
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
root () //  %% File: CountChars_Perl.pl
Date            Author        number of nodes
2003/8/8        Walking@Lint 33
2003/5/14       Walking Lint  31
2003/5/14       Walking Lint  15 (wc_Perl->CountChars_Perl)
2003/3/19       Walking Lint  15
2002/4/21       Walking Lint  6 (WordCount_Perl->wc_Perl)
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - count chars
		DESCRIPTION () //  %% activate as filter
		AUTHOR () //  %% [[Author]]
	$use_tk (out) //   shift
	$han (out) //   0
	$zen (out) //   0
	$total (out) //   0
	while () // <STDIN>
		if () // $_ =~ /^__EOF__$/
			break ()
		$zen (inout) // += ($_ =~ tr/\xa1-\xfe/\xa1-\xfe/)
		$han (inout) // += ($_ =~ tr/\x21-\x7e/\x21-\x7e/)
		$total (inout) // += length($_)
		print () // $_
	$han (inout) // -=  $zen
	$else (out) //   $total - $zen - $han
	if () // $use_tk
		use () // Tk
		$mw (out) //   new MainWindow
		$lab (out) //   $mw->Label(-anchor => "w", -text => "zenkaku = $zen\nhankaku(\\x2a - \\x7e) = $han\nhankaku(else) = $else\n----------------------------\ntotal = $total") %% anchor is not functioning ??
		$lab (out) // ->pack()
		MainLoop ()
	else ()
		DebugPrint () // ""
		DebugPrint () // "zenkaku = $zen"
		DebugPrint () // "hankaku(\\x2a - \\x7e) = $han"
		DebugPrint () // "hankaku(else) = $else"
		DebugPrint () // "----------------------------"
		DebugPrint () // "total = $total"
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
root () //  %% File: CountChars_Perl.pl
Date            Author        number of nodes
2003/8/8        Walking@Lint 33
2003/5/14       Walking Lint  31
2003/5/14       Walking Lint  15 (wc_Perl->CountChars_Perl)
2003/3/19       Walking Lint  15
2002/4/21       Walking Lint  6 (WordCount_Perl->wc_Perl)
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - count chars
		DESCRIPTION () //  %% activate as filter
		AUTHOR () //  %% [[Author]]
	$use_tk (out) //   shift
	$han (out) //   0
	$zen (out) //   0
	$total (out) //   0
	while () // <STDIN>
		if () // $_ =~ /^__EOF__$/
			break ()
		$zen (inout) // += ($_ =~ tr/\xa1-\xfe/\xa1-\xfe/)
		$han (inout) // += ($_ =~ tr/\x21-\x7e/\x21-\x7e/)
		$total (inout) // += length($_)
		print () // $_
	$han (inout) // -=  $zen
	$else (out) //   $total - $zen - $han
	if () // $use_tk
		use () // Tk
		$mw (out) //   new MainWindow
		$lab (out) //   $mw->Label(-anchor => "w", -text => "zenkaku = $zen\nhankaku(\\x2a - \\x7e) = $han\nhankaku(else) = $else\n----------------------------\ntotal = $total") %% anchor is not functioning ??
		$lab (out) // ->pack()
		MainLoop ()
	else ()
		DebugPrint () // ""
		DebugPrint () // "zenkaku = $zen"
		DebugPrint () // "hankaku(\\x2a - \\x7e) = $han"
		DebugPrint () // "hankaku(else) = $else"
		DebugPrint () // "----------------------------"
		DebugPrint () // "total = $total"
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
root () //  %% File: CountChars_Perl.pl
Date            Author        number of nodes
2003/8/8        Walking@Lint 33
2003/5/14       Walking Lint  31
2003/5/14       Walking Lint  15 (wc_Perl->CountChars_Perl)
2003/3/19       Walking Lint  15
2002/4/21       Walking Lint  6 (WordCount_Perl->wc_Perl)
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - count chars
		DESCRIPTION () //  %% activate as filter
		AUTHOR () //  %% [[Author]]
	$use_tk (out) //   shift
	$han (out) //   0
	$zen (out) //   0
	$total (out) //   0
	while () // <STDIN>
		if () // $_ =~ /^__EOF__$/
			break ()
		$zen (inout) // += ($_ =~ tr/\xa1-\xfe/\xa1-\xfe/)
		$han (inout) // += ($_ =~ tr/\x21-\x7e/\x21-\x7e/)
		$total (inout) // += length($_)
		print () // $_
	$han (inout) // -=  $zen
	$else (out) //   $total - $zen - $han
	if () // $use_tk
		use () // Tk
		$mw (out) //   new MainWindow
		$lab (out) //   $mw->Label(-anchor => "w", -text => "zenkaku = $zen\nhankaku(\\x2a - \\x7e) = $han\nhankaku(else) = $else\n----------------------------\ntotal = $total") %% anchor is not functioning ??
		$lab (out) // ->pack()
		MainLoop ()
	else ()
		DebugPrint () // ""
		DebugPrint () // "zenkaku = $zen"
		DebugPrint () // "hankaku(\\x2a - \\x7e) = $han"
		DebugPrint () // "hankaku(else) = $else"
		DebugPrint () // "----------------------------"
		DebugPrint () // "total = $total"
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
