root () //  %% File: CopyFilesToUpload_Perl.pl CRLF Date            Author        number of nodes CRLF 2003/8/27       Walking@Lint 95 CRLF 2003/8/8        Walking@Lint 95 CRLF 2003/8/4        Walking@Lint 95 CRLF 2003/7/20       Walking Lint  92 CRLF 2003/5/15       Walking Lint  88 CRLF 2003/5/14       Walking Lint  86 CRLF 2003/5/4        Walking Lint  77 CRLF 2003/3/18       Walking Lint  74 CRLF 2003/3/16       Walking Lint  72 CRLF 2002/11/29      Walking Lint  72 CRLF 2002/11/27      Walking Lint  70 CRLF 2002/11/23      Walking Lint  70 CRLF 2002/11/6       Walking Lint  61 CRLF 2002/10/31      Walking Lint  61 CRLF 2002/10/11      Walking Lint  59 CRLF 2002/9/18       Walking Lint  49 CRLF 2002/9/7        Walking Lint  49 CRLF 2002/7/23       Walking Lint  9 (CheckModifiedTime_Perl->CopyFilesToUpload_Perl) CRLF 2002/6/4        Walking Lint  6 (Time_Perl->CheckModifiedTime_Perl) CRLF 2002/3/3        Walking Lint  3 (Time_Perl->NewFile) CRLF 2002/2/19       Walking Lint  3 CRLF 2002/2/17       Walking Lint  3
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - copy files generated after ftpx's last activation time
		DESCRIPTION () //  %% uncheck ftpx's "View > Options > Paths > Clean up temporary directory on shutdown" and execute ftpx once CRLF (the files in the temporary directory is used to determine last activated time) CRLF  CRLF ex1. perl.exe CopyFilesToUpload_Perl.pl "[[WeblogFolder]]" "[[WeblogFolder]]\upload" CRLF  CRLF ex2. perl.exe CopyFilesToUpload_Perl.pl "[[CurrentFolder]]" "[[CurrentFolder]]\upload"
		AUTHOR () //  %% [[Author]]
	use () // File::Basename
	use () // Win32::File
	use () // File::Copy
	use () // Time::localtime
	use () // Win32::Registry
	$from_dir (out) //   shift
	DebugPrint () // "from_dir = $from_dir"
	$to_dir (out) //   shift
	DebugPrint () // "to_dir = $to_dir"
	if () // not -e $to_dir
		mkdir () // $to_dir, 0700 or die("Cannot make $to_dir: $!")
		DebugPrint () // "generated $to_dir"
	$HKEY_CURRENT_USER (out) // ->Open("SOFTWARE\\FTP Explorer\\FTP Explorer\\Settings", $ref) or die "cannot open registry: $!"
	$ref (out) // ->GetValues(\%values)
	$ref (out) // ->Close()
	$ref_ftpx_tmp_dir (out) //   $values{'TmpPath'}
	$ftpx_tmp_dir (out) //   $$ref_ftpx_tmp_dir[2]
	$ftpx_tmp_dir (inout) // =~ s/\\$//
	if () // length($ftpx_tmp_dir) == 0
		$ftpx_tmp_dir (out) //   $ENV{FTPTMPDIR} %% this is needed for XP ???
		$ftpx_tmp_dir (inout) // =~ s/"//g
	_note () // commented out (2003/8/8)
		$ftpx_tmp_dir (out) //   $to_dir %% this may be hack ... think later ...
	DebugPrint () // "ftpx_tmp_dir = " . $ftpx_tmp_dir
	_ () //  %% get ftpx's last activation time
		if () // not -e $ftpx_tmp_dir
			mkdir () // $ftpx_tmp_dir, 0700 or die("Cannot make $ftpx_tmp_dir: $!")
		opendir () // DIR, $ftpx_tmp_dir or die "opendir $ftpx_tmp_dir failed: $!"
		_note () // commented out (2002/9/7)
			@files (out) //   readdir DIR
		@files (out) //   grep /\.tmp$/i, readdir DIR
		closedir () // DIR
		$last_time (out) //   0
		foreach () // $from_file (@files)
			$from_file (out) //   $ftpx_tmp_dir . "\\" . basename($from_file)
			@stat (out) //   stat($from_file)
			if () // $stat[9] > $last_time
				$last_time (out) //   $stat[9]
		foreach () // $from_file (@files)
			$from_file (out) //   $ftpx_tmp_dir . "\\" . basename($from_file)
			@stat (out) //   stat($from_file)
			if () // $stat[9] != $last_time
				unlink () // $from_file
		_note () // commented out (2002/11/23)
			DebugPrint () // "last_time = $last_time"
		DebugPrint () // "last_time = " . &gendate($last_time)
	_ () //  %% clear upload dir
		opendir () // DIR, $to_dir or die "opendir $to_dir failed: $!"
		@files (out) //   readdir DIR
		closedir () // DIR
		foreach () // $from_file (@files)
			$from_file (out) //   $to_dir . "\\" . basename($from_file)
			unlink () // $from_file
	_ () //  %% copy files modified after ftpx's last activation
		opendir () // DIR, $from_dir or die "opendir $from_dir failed: $!"
		@files (out) //   grep /\.(class|css|gif|html|jpg|mpg|pat|svg|txt|wrl|xml|zip)$/i, readdir DIR
		%dates (out) //   ()
		closedir () // DIR
		foreach () // $from_file (@files)
			$from_file (out) //   $from_dir . "\\" . basename($from_file)
			@stat (out) //   stat($from_file)
			_note () // commented out (2002/11/29)
				if () // $from_file =~ /Completions/
					DebugPrint () // "from_file = $from_file"
					DebugPrint () // "stat[7] = " . &gendate($stat[7])
					DebugPrint () // "stat[8] = " . &gendate($stat[8]) %% access date
					DebugPrint () // "stat[9] = " . &gendate($stat[9]) %% modified time
					DebugPrint () // "stat[10] = " . &gendate($stat[10]) %% created time
			if () // (($stat[9] > $last_time) or ($stat[10] > $last_time)) and not (basename($from_file) eq 'copyright.html') and not (basename($from_file) eq 'menu.html')
				$to_file (out) //   $to_dir . "\\" . basename($from_file)
				copy () // $from_file, $to_file
				$dates{$to_file} (out) //   &gendate($stat[9])
		$first (out) //   1
		foreach () // $key (sort {$dates{$a} cmp $dates{$b}} keys %dates)
			if () // $first
				$first (out) //   0
				DebugPrint () // ''
			DebugPrint () // "copied to $key - $dates{$key}"
	gendate ()
		$time (in) &
		$tm (out) //   localtime($time)
		$year (out) //   $tm->year + 1900
		$month (out) //   $tm->mon + 1
		$day (out) //   $tm->mday
		$hour (out) //   $tm->hour
		$min (out) //   $tm->min
		$sec (out) //   $tm->sec
		return () // sprintf("$year/%02d/%02d $hour:$min:$sec", $month, $day)
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
