# File: CopyNewFiles_Perl.pl
# Date            Author        number of nodes
# 2002/7/30       Walking Lint  24
# 2002/7/30       Walking Lint  35 (DeleteWidthOfTable_Perl->CopyNewFiles_Perl)
# 2002/7/30       Walking Lint  50 (ExtractImageAndMapLine_Perl->DeleteWidthOfTable_Perl)
# 2002/7/19       Walking Lint  18 (DropArchiveAndReadOnlyAttributesOfHtmlFiles_Perl->ExtractImageAndMapLine_Perl)
# 2002/7/19       Walking Lint  18 (SetFileAttr_Perl->DropArchiveAndReadOnlyAttributesOfHtmlFiles_Perl)
# 2002/7/18       Walking Lint  18 (PDFRef2ActiveXRef_Perl->SetFileAttr_Perl)
# 2001/8/15       Walking Lint  17 (Filter3_Perl->NewFile)

=pod

=head1 NAME

CopyNewFiles_Perl.pl - copy Nxx.html files from from_dir to to_dir

=head1 DESCRIPTION

ex. perl.exe CopyNewFiles_Perl.pl D:/SSG_j F:/SSG_j

=head1 AUTHOR

Walking Lint

=cut

use Cwd;
use File::Find;
use File::Basename;
use Win32::File;
use File::Copy;
$from_dir = shift;
$to_dir = shift;
find(\&check_file, $from_dir);
sub check_file {
  $file_to_check = $_;
  if (($file_to_check =~ /.html$/) and ($file_to_check =~ /^(C|N)/)) {
    $to_file = cwd . '/' . $file_to_check;
    $to_file =~ s/D:/F:/; # think later ...
    print STDERR $to_file . "\n";
    copy($file_to_check, $to_file);
  }
}
