# File: CountFiles_Perl.pl
# Date            Author        number of nodes
# 2003/2/13       Walking Lint  39
# 2002/8/21       Walking Lint  34
# 
# File: CountFiles_Perl.pl 
# Date            Author        number of nodes 
# 2002/8/21       Walking Lint  21 
# 2001/8/15       Walking Lint  17 (Filter3_Perl->CountFiles_Perl)

=pod

=head1 NAME

CountFiles_Perl.pl - wfBNg Y/ύXN Ƃ̃t@C𐔂

=head1 DESCRIPTION

ex. perl.exe CountFiles_Perl.pl F:\SSG_e

=head1 AUTHOR

Walking Lint

=cut

use Cwd;
use File::Basename;
use File::Find;
use File::stat;
use Time::localtime;
$dir = shift;
find(\&check_file, "$dir");
sub check_file {
  if (/\.([^\.]+)$/ and (not /^N/) and (not /^C/)) {
    $file = cwd . "/$_";
    $tm = localtime (stat ($file)->mtime);
    my $key = $1 . '_' . sprintf("%04d%02d", $tm->year +1900, $tm->mon +1);
    $sfxs{$key}++;
    if ($key eq html_200202) {
      $dir = &mydirname($file);
      $dirs{$dir}++;
    }
  }
}
foreach $key (sort keys %sfxs) {
  ($sfx, $mt) = split(/_/,  $key);
  print "number of $sfx (modified in $mt) is $sfxs{$key}\n";
}
foreach $key (sort keys %dirs) {
  ($sfx, $mt) = split(/_/,  $key);
  print "number of $sfx (modified in $mt) is $sfxs{$key}\n";
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
