# File: CsvWriter_Perl.pl
# Date            Author        number of nodes
# 2002/11/10      Walking Lint  33
# 2002/11/9       Walking Lint  29
# 2002/6/4        Walking Lint  29 (CSVWriter_Perl->CsvWriter_Perl)
# 2002/3/10       Walking Lint  20

=pod

=head1 NAME

CsvWriter_Perl.pl - csv writer

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
open IN, $from_file || die("Can't open $from_file: $!\n");
open OUT, ">$to_file";
$_ = <IN>;
@lines = ();
$incss = 0;
while (<IN>) {
  chop;
  if ($incss) {
    if ($_ =~ /\t/ and not $_ =~ /\t\t/) {
      $incss = 0;
    } else {
      next;
    }
  } elsif ($_ =~ /\t_part \(\) \/\/ \.css/) {
    $incss = 1;
    next;
  }
  if ($_ =~/\t\t/) {
    $_ =~ s/\t\t//;
    $_ =~ s/ \(\)$//;
    push @lines, $_;
  } elsif (@lines > 0) {
    print OUT join(',', @lines) . "\n";
    @lines = ();
  }
}
if (@lines > 0) {
  print OUT join(',', @lines) . "\n";
}
close IN;
close OUT;
