# File: DebugPrintForPerl_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 33
# 2003/8/6        Walking@Lint 27
# 2003/6/21       Walking Lint  25
# 2003/6/21       Walking Lint  25 (GenDebugPrintForPerl_Perl->DebugPrintForPerl_Perl)
# 2003/6/21       Walking Lint  18
# 2003/6/20       Walking Lint  14
# 2003/6/20       Walking Lint  14 (2OneLine_Perl->GenDebugPrintForPerl_Perl)
# 2003/6/15       Walking Lint  14
# 2003/6/8        Walking Lint  13
# 2003/5/26       Walking Lint  9
# 2003/5/26
$varnames = shift;
if (defined($varnames)) {
  @varnames = split(/,[ ]*/, $varnames);
  $first = 1;
  foreach $varname (@varnames) {
    if ($first) {
      $first = 0;
    } else {
      print "\n";
    }
    print 'DebugPrint("' . $varname . ' = " . $' . $varname . ');';
  }
} else {
  $inline = 0;
  $breaklater = 0;
  while (<STDIN>) {
    if ($_ =~ /^__EOF__[\n\r]*$/) {
      last;
    } elsif ($_ =~ /__EOF__[\n\r]*$/) {
      $_ =~ s/__EOF__[\n\r]*$//;
      $breaklater = 1;
    }
    if (not $_ =~ /[\n]+$/) {
      $inline = 1;
      print $_ . "\n";
    } else {
      print $_;
    }
    if ($_ =~ /^([ \t]*)\$([a-zA-Z0-9]+)[ \t]*(\=|[\+\-\*\/\.]\=|\+\+|\-\-)/) {
      print $1 . 'DebugPrint("' . $2 . ' = " . $' . $2 . ');';
    }
    if (not $inline) {
      print "\n";
    }
    if ($breaklater) {
      last;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
