# File: DeleteSpaceLine_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 25
# 2003/8/4        Walking@Lint 19
# 2002/11/29      Walking Lint  8
# 2002/9/2        Walking Lint  8 (DeleteSpaceLineFromRef_Perl->DeleteSpaceLine_Perl)
# 2002/6/12       Walking Lint  7

=pod

=head1 NAME

DeleteSpaceLine_Perl.pl - delete space line

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  chop $_;
  DebugPrint("in = " . $_);
  if (length($_) != 0) {
    print $_ . "\n";
  }
  if ($breaklater) {
    last;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
