# File: DisableOpeningWindow_Perl.pl
# Date            Author        number of nodes
# 2003/9/8        Walking@Lint 23
# 2003/9/4        Walking Lint  22
# 2003/9/4        Walking Lint  23 (DeleteSpaceLine_Perl->DisableOpeningWindow_Perl)
# 2003/8/31       Walking@Lint 25
# 2003/8/4        Walking@Lint 19
# 2002/11/29      Walking Lint  8
# 2002/9/2        Walking Lint  8 (DeleteSpaceLineFromRef_Perl->DeleteSpaceLine_Perl)
# 2002/6/12       Walking Lint  7

=pod

=head1 NAME

DisableOpeningWindow_Perl.pl - delete space line

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  $_ =~ s/target=[_a-z\"]+/target=_self/ig;
  $_ =~ s/http:\/\/a\.hatena\.ne\.jp\/go\?//ig;
  $_ =~ s/[0-9]{14}\"/\"/ig;
  $_ =~ s/onclick=\"[^\"]*\"/target=_self/ig;
  $_ =~ s/charset=(euc-jp|utf-8)/charset=Shift_JIS/ig;
  $_ =~ s/<base target=[_a-z\"]+>//ig;
  print $_;
  if ($breaklater) {
    last;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
