# File: ExtractMissingFTerms_Perl.pl
# Date            Author        number of nodes
# 2005/3/29       Walking Lint  26
$fterms = <STDIN>;
$fterms =~ s/[\r\n]+$//;
@fterms = split(/\t/, $fterms);
$defs = <STDIN>;
$defs =~ s/[\r\n]+$//;
@defs = split(/\t/, $defs);
$first = 1;
foreach $fterm (@fterms) {
  $def = shift @defs;
  if (length($fterm) != 0) {
    if (length($def) == 0) {
      if ($fterm =~ /([0-9])\.00E\+([0-9]+)/) {
        $str = '0' x (9 - length($fterm));
        $fterm = $1 . 'E' . $str . $2;
      }
      if ($first == 1) {
        $first = 0;
        print "$fterm";
      } else {
        print "\t$fterm";
      }
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
