# File: FromBase64_Perl.pl
# Date            Author        number of nodes
# 2003/12/25      Walking Lint  36
# 2003/12/25      Walking Lint  21 (FromUTF8_Perl->FromBase64_Perl)
# 2003/12/25      Walking Lint  21
# 2003/6/2        Walking Lint  21
# 2003/6/2        Walking Lint  12 (BreakLines_Perl->FromUTF8_Perl)
# 2003/4/9        Walking Lint  105

=pod

=head1 NAME

FromBase64_Perl.pl - from base64

=head1 DESCRIPTION

activate as filter or program

=head1 AUTHOR

Walking Lint

=cut

use MIME::Base64;
$from_file = shift;
if (defined($from_file)) {
  $to_file = shift;
  if (not defined($to_file)) {
    $to_file = 'decoded';
  }
  open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
  open IN, $from_file or die("Cannot open $from_file: $!\n");
  while (<IN>) {
    print OUT decode_base64($_);
  }
  close IN;
  close OUT;
  DebugPrint("generated $to_file");
} else { # actually this does not work correctly ... user upper case ...
  while (<STDIN>) {
    print decode_base64($_);
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
