# File: GenCategorizedLink_Ruby.rb
# Date            Author        number of nodes
# 2002/11/20      Walking Lint  230
# 2002/11/16      Walking Lint  155 (GenCategorizedLink_Ruby->GenCategorizedLink_Ruby)
# 2002/11/16      Walking Lint  167 (GenCategorizedLink_Perl->GenCategorizedLink_Ruby)
# 2002/11/16      Walking Lint  178 (GenCategorizedLink_Ruby->GenCategorizedLink_Perl)
# 2002/10/11      Walking Lint  178
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkNew_Ruby.GenCategorizedLink_Ruby)
# 2002/9/21       Walking Lint  109 (GenCategorizedLink_Ruby.GenCategorizedLinkNew_Ruby)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=begin

= NAME

GenCategorizedLink_Ruby.rb - generate CategorizedLink.html

= DESCRIPTION

activate as filter

= AUTHOR

Walking Lint

=end

require 'CVTree_Ruby.rb'
def extractdata(nd, titles, url, urls, dates)
  def if
    return
  end
  def if
    date = $1
    tn = nd['CHILD']
    def while
      tmp_category = tn['NAME']
      if(tmp_category == '_֌W')    # this is hack ... think later ...
      def elsif
        category = tmp_category
        category.gsub!(/֌W$/, '')
        category.gsub!(/$/, '')
        category.gsub!(/[ ]+$/, '')
      end
      line = tn['TEXT']
      def if
        tcn = tn['CHILD']
        def while
          def if
            line += tcn['TEXT']
          end
          def if
            break
          end
          tcn = tcn['NEXT']
        end
      end
      lines = line.split('CRLF')    # this is hack ...
      def for
        def if
          titlewithcategory = category + '_' + $1
          titles.push(titlewithcategory)
          url[titlewithcategory] = $2
          urls[titlewithcategory] = $2
          dates[titlewithcategory] = date
        end
      end
      def if
        break
      end
      tn = tn['NEXT']
    end
  def elsif
    cn = nd['CHILD']
    def while
      extractdata(cn, titles, url, urls, dates)
      def if
        break
      end
      cn = cn['NEXT']
    end
  end
end
tm = Time.now.localtime
dateandtime = "%04d/%02d/%02d %02d:%02d:%02d" % [tm.year, tm.mon, tm.mday, tm.hour, tm.min, tm.sec]
dir = 'D:/HP'
DebugPrint("dir = #{dir}")
ParentTitle = 'My Two Cents'
DebugPrint("ParentTitle = #{ParentTitle}")
ParentURL = 'index.html'
DebugPrint("ParentURL = #{ParentURL}")
CSSTemplate = '3ColumnWithStyleSheet.css'
DebugPrint("CSSTemplate = #{CSSTemplate}")
copyright_file = dir + '/copyright.html'
infile = open(copyright_file, "r")
Copyright = ''  # Capitalization is needed ... somehow ...
def while
  Copyright = Copyright + $_
end
infile.close
DebugPrint("Copyright = #{Copyright}")
files = Dir.entries(dir).grep(/^200[0-9]+.pat$/)
to_url = 'CategorizedLink.html'
to_file = dir + '/' + to_url
outfile = open(to_file, "w")
urlcount = {}
titles = []
url = {}
urls = {}
dates = {}
categories = {}
categorycount2 = {}
def for
  from_file = dir + "/" + from_file
  infile = open(from_file)
  root = {}
  initnode(root, 'root', '', '', '')
  gentree(root, from_file)
  category = '̑'
  extractdata(root, titles, url, urls, dates)
  infile.close
end
Title = 'Categorized Links'
outfile.print(<<END)
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>#{Title}</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="#{CSSTemplate}" />
</head>
<body>
<table class="navi"><tr><td class="path"><a href="#{ParentURL}">#{ParentTitle}</a> > #{Title}</td></tr></table>
<h3>#{Title}</h3>
END
print <<END
<h5><a href="#{to_url}">#{Title}:</a></h5>
END
sortedtitles = titles.sort {|a, b| a.downcase <=> b.downcase}
i = 1
prevcategory = ''
first = true
count = 1
def for
  (category, truetitle) = title.split(/_/)
  if(category == '̑')
  def else
    def unless
      DebugPrint("category = #{category}")
      def if
        first = false
      def else
        outfile.print(<<END)
</ol>
END
      end
      outfile.print(<<END)
<a name="#{count}"></a><h4>#{category}</h4>
<ol>
END
      print <<END
<div><a href="#{to_url}##{count}">#{category}</a></div>
END
      count += 1
    end
    def if
      urlcount[url[title]] = 1  # to make non-nil
      (year, month, day) = dates[title].split('/')
      def if
        month.gsub!(/^[0]*/, '')
        month = "%02d" % [month]
        ref = year + month + '.html' + '#' + day
        date_str = ' <a href="' + ref + '">(' + dates[title] + ')</a>'
      def else
        date_str = ' (' + dates[title] + ')'
      end
      outfile.print(<<END)
<li><a href="#{urls[title]}">#{truetitle}#{date_str}</a></li>
END
    end
    prevcategory = category
  end
end
def for
  (category, truetitle) = title.split(/_/)
  def if
    def unless
      DebugPrint("category = #{category}")
      def if
        first = false
      def else
        outfile.print(<<END)
</ol>
END
      end
      outfile.print(<<END)
<a name="#{count}"></a><h4>#{category}</h4>
<ol>
END
      print <<END
<div><a href="#{to_url}##{count}">#{category}</a></div>
END
      count += 1
    end
    def if
      urlcount[url[title]] = 1  # to make non-nil
      (year, month, day) = dates[title].split('/')
      def if
        month.gsub!(/^[0]*/, '')
        month = "%02d" % [month]
        ref = year + month + '.html' + '#' + day
        date_str = ' <a href="' + ref + '">(' + dates[title] + ')</a>'
      def else
        date_str = ' (' + dates[title] + ')'
      end
      outfile.print(<<END)
<li><a href="#{urls[title]}">#{truetitle}#{date_str}</a></li>
END
    end
    prevcategory = category
  end
end
def if
  def if
    first = false
  def else
    outfile.print(<<END)
</ol>
END
  end
  outfile.print(<<END)
#{Copyright}
</body>
</html>
END
end
print <<END
<small><div class="lastupdate">(#{dateandtime})</div></small>
END
outfile.close
DebugPrint("generated #{to_file}")
