# File: GenGIF_Perl.pl
# Date            Author        number of nodes
# 2002/11/24      Walking Lint  19

=pod

=head1 NAME

GenGIF_Perl.pl - generate GIF file

=head1 DESCRIPTION

ex. perl.exe GenGIF_Perl.pl 600 2 #203868 ZannahBar.gif

=head1 AUTHOR

Walking Lint

=cut

use GD;
$width = shift;
$height = shift;
$hex = shift;
$hex =~ /#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})/;
$r = hex($1);
$g = hex($2);
$b = hex($3);
$to_file = shift;
$image = new GD::Image($width, $height);
$back = $image->colorAllocate($r, $g, $b);
$image->fill(1, 1, $back);
open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
print OUT $image->gif;
close OUT;
