# File: GenLinkLog_Perl.pl
# Date            Author        number of nodes
# 2002/11/19      Walking Lint  61
# 2002/3/22       Walking Lint  56
# 2002/3/17       Walking Lint  56 (GenLink->GenLinkLog_Perl)
# 2002/3/17       Walking Lint  56 (GenLinkLog->GenLink)
# 2002/3/17       Walking Lint  50 (GenCategorizedLink->GenLinkLog)
# 2002/3/15       Walking Lint  50
$dir = 'E:';
opendir DIR, $dir or die "opendir() failed: $!";
@files = grep !/^\.\.?$/, readdir DIR;
@files = grep /^200[0-9]+.pat$/, @files;
closedir DIR;
$to_file = 'E:\LinkLog.pat';
open OUT, ">$to_file";
@titles = [];
@urls = [];
@dates = [];
foreach $from_file (@files) {
  DebugPrint("from_file = $from_file");
  open IN, $from_file || die("Can't open $from_file: $!\n");
  $category = '̑ ';
  while (<IN>) {
    if ($_ =~ /\t(200[0-9\/]+)/) {
      $date = $1;
    }
    if ($_ =~ /\t[lL]inks: ()/) { # this may be hack ...
      last;
    }
    @lines = split('CRLF', $_); # this is hack ...
    foreach $line (@lines) {
      if ($line =~ /\[\[([^\]]+)!([^\]!]+)\]\]/) {
        $titlewithcategory = $category . '_' . $1;
        push @titles, $titlewithcategory;
        $url{$titlewithcategory} = $2;
        $urls{$titlewithcategory} = $2;
        $dates{$titlewithcategory} = $date;
      }
    }
  }
  close IN;
}
print OUT <<EOD;
root () //  \%\% Categorized Link
	_part () // StyledDiary.css
EOD
@sortedtitles = sort {lc($a) cmp lc($b)} @titles;
foreach $title (@sortedtitles) {
  ($category, $truetitle) = split(/ _/, $title);
  unless ($urlcount{$url{$title}}++ or ($urls{$title} eq '') or not ($urls{$title} =~ /http:/)) {
    $outline = "\t" . $truetitle . ' (' . $dates{$title} . ") () //  \%\% " . $urls{$title} . "\n";
    print OUT $outline;
  }
}
close OUT;
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
