root () //  %% File: GenToDo_Perl.pl CRLF Date            Author        number of nodes CRLF 2003/3/23       Walking Lint  128 CRLF 2002/12/13      Walking Lint  126 CRLF 2002/11/19      Walking Lint  93 CRLF 2002/10/16      Walking Lint  86 (GenToDoList_Perl->GenToDo_Perl) CRLF 2002/10/15      Walking Lint  115 (GenToDoList_Perl->GenToDoList_Perl) CRLF 2002/10/15      Walking Lint  81 (GenToDoList_Perl->GenToDoList_Perl) CRLF 2002/9/21       Walking Lint  168 CRLF 2002/8/31       Walking Lint  156
	_doc ()
		NAME () //  %% GenToDo_Perl.pl - generate ToDo
		DESCRIPTION () //  %% ex. perl.exe GenToDo_Perl.pl CRLF  CRLF meaning of flags in kind CRLF  CRLF ! - exclude
		AUTHOR () //  %% [[Author]]
	use () // lib '.'
	use () // CVTree_Perl
	use () // Time::localtime
	$tm (out) //   localtime
	$dateandtime (out) //   sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec)
	_ () //  %% set parameters
		_note () // commented out (2002/10/15)
			$todo_file (out) //   shift
		$templatesfolder (out) //   $ENV{TEMPLATESFOLDER}
		$templatesfolder (inout) // =~ s/"//g
		$todo_body (out) //   'Memo.pat'
		$todo_file (out) //   $templatesfolder . "\\" . $todo_body
		DebugPrint () // "todo_file = $todo_file"
		_note () // commented out (2002/10/15)
			$todo (out) //   shift
		$weblogfolder (out) //   $ENV{WEBLOGFOLDER}
		$weblogfolder (inout) // =~ s/"//g
		$todo (out) //   $weblogfolder . '\ToDo.html'
		DebugPrint () // "todo = $todo"
		_note () // commented out (2002/10/15)
			$ParentTitle (out) //   shift
		$ParentTitle (out) //   'Revenge of My Two Cents'
		DebugPrint () // "ParentTitle = $ParentTitle"
		_note () // commented out (2002/10/15)
			$ParentURL (out) //   shift
		$ParentURL (out) //   'index.html'
		DebugPrint () // "ParentURL = $ParentURL"
		_note () // commented out (2002/10/15)
			$link_file (out) //   shift
		_note () // commented out (2002/10/15)
			$link_file (out) //   '3ColumnWithStyleSheet.css'
		$link_file_body (out) //   'link.css'
		DebugPrint () // "link_file_body = $link_file_body"
		$link_file (out) //   $todo
		$link_file (inout) // =~ s/[^\\]+$/$link_file_body/
		DebugPrint () // "link_file = $link_file"
		$src_link_file (out) //   $templatesfolder . "\\" . $link_file_body
		if () // not -e $link_file and -e $src_link_file
			copy () // $src_link_file, $link_file
			DebugPrint () // "copied $src_link_file to $link_file"
		_note () // commented out (2002/10/15)
			$copyright_file (out) //   shift
		$copyright_file (out) //   'E:\copyright.html'
		open () // IN, $copyright_file || die("Cannot open $copyright_file: $!\n")
		@copyrights (out) //   <IN>
		close () // IN
		$copyright (out) //   join('', @copyrights)
		DebugPrint () // "copyright = $copyright"
		$Title (out) //   'items to be done'
	$root (out) // my  {}
	&initnode () // $root, 'root', '', '', ''
	&gentree () // $root, $todo_file
	my $first (out) //   1
	open () // OUT, ">$todo"
	<<END (in) //  %% <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN"> CRLF <html> CRLF <head> CRLF <title>$Title</title> CRLF <meta http-equiv="content-type" content="text/html;charset=Shift_JIS" /> CRLF <meta http-equiv="content-style-type" content="text/css" /> CRLF <link rel="stylesheet" type="text/css" href="$link_file_body" /> CRLF </head> CRLF <body> CRLF <table class="navi"><tr><td class="path"><a href="$ParentURL">$ParentTitle</a> > $Title</td></tr></table> CRLF <div class="lastupdate">Last update: $dateandtime</div>
	print () // OUT
	<<END (in) //  %% <a href="ToDo.html">$Title</a><small> CRLF <div class="lastupdate">($dateandtime)</div></small>
	print ()
	$counter (out) //   1
	&gentodo () // $root, 1
	<<END (in) //  %% </body> CRLF </html>
	print () // OUT
	close () // OUT
	DebugPrint () // "generated $todo"
	_note () // commented out (2002/8/31)
		&printtree () // $root, '  '
	gentodo ()
		$nd (in) &
		$level (in) &
		if () // defined($nd->{CHILD})
			_note () // commented out (2002/12/13)
				<<END (in) //  %% <ol>
				print () // OUT
			$cn (out) // my  $nd->{CHILD}
			while () // 1
				if () // $cn->{NAME} =~ /^_/
					if () // $cn->{NAME} eq '_mheader'
						$mail_file_body (out) //   $todo_body
						$mail_file_body (inout) // =~ s/\.pat//
						$mail_file_body (inout) // .= $counter . '.html'
						$counter (inout) // ++
						$mail_file (out) //   $weblogfolder . "\\" . $mail_file_body
						$mail_body (out) //   $cn->{TEXT}
						$mail_body (inout) // =~ s/ \CRLF /\n/g
						$mail_body (inout) // =~ /(.*)/
						$mail_head (out) //   $1
						open () // OUT2, ">$mail_file" or die("Cannot open $mail_file: $!\n")
						print () // OUT2 '<pre>' . $mail_body . '</pre>'
						close () // OUT2
						<<END (in) //  %% <h$level><a href="$mail_file_body">$mail_head</a></h$level>
						print () // OUT
					else ()
						_ () //  %% skip
				else ()
					$text (out) //   $cn->{TEXT}
					$text (inout) // =~ s/( \CRLF )+/ /g
					if () // length($text) != 0
						$text (out) //   ' - ' . $text
					else ()
						$text (out) //   ''
					if () // $cn->{KIND} =~ /\(\) \+/
						_note () // commented out (2002/12/13)
							<<END (in) //  %% <li><strike>$cn->{NAME}$text</strike></li>
						<<END (in) //  %% <h$level><img src="CheckedNode.jpg"/> $cn->{NAME}$text</h$level>
						print () // OUT
					else ()
						_note () // commented out (2002/12/13)
							<<END (in) //  %% <li>$cn->{NAME}$text</li>
						<<END (in) //  %% <h$level><img src="NotCheckedNode.jpg"/> $cn->{NAME}$text</h$level>
						print () // OUT
					if () // defined($cn->{CHILD})
						&gentodo () // $cn, $level + 1
				if () // not defined($cn->{NEXT})
					last ()
				$cn (out) //   $cn->{NEXT}
			_note () // commented out (2002/12/13)
				<<END (in) //  %% </ol>
				print () // OUT
	DebugPrint ()
		$str (in) &
		print () // STDERR $str . "\n"
	Trace ()
		$str (in) &
		print () // STDERR $str . "\n"
