# File: GenWeblogs_Ruby.rb
# Date            Author        number of nodes
# 2002/11/25      Walking Lint  90
# 2002/11/16      Walking Lint  88
# 2002/11/16      Walking Lint  91 (GenWeblogs_Perl->GenWeblogs_Ruby)
# 2002/11/16      Walking Lint  91 (GenWeblogs_Ruby->GenWeblogs_Perl)
# 2002/11/7       Walking Lint  92
# 2002/11/6       Walking Lint  89
# 2002/10/15      Walking Lint  81
# 2002/9/21       Walking Lint  168
# 2002/8/31       Walking Lint  156

=begin

= NAME

GenWeblogs_Ruby.rb - generate Weblogs section and Weblogs.html

= DESCRIPTION

ex. _text () // GenWeblogs_Ruby

meaning of flags in kind

! - exclude

= AUTHOR

Walking Lint

=end

require 'CVTree_Ruby.rb'
def genlinks(nd, to_file)
  def if
    first = true
    cn = nd['CHILD']
    def while
      def if
        # skip
      def else
        def if
          first = false
          outfile = open(to_file, "w")
          outfile.print(<<END)
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>#{Title}</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="3ColumnWithStyleSheet.css" />
</head>
<body>
<table class="navi"><tr><td class="path"><a href="#{ParentURL}">#{ParentTitle}</a> > #{Title}</td></tr></table>
<h3>Weblogs</h3>
<p>
<ol>
END
          outfile.print(<<END)
<h5><a href="Weblogs.html">Weblogs:</a></h5>
END
        end
        rsslink = ''
        type = cn['TYPE']
        def if
          def if    # not actually ... but this is assumed ...
            rsslink = ' <a href="' + $1 + '"><img src="tinyxml.jpg" alt="RSS link" title="RSS link"></a>'
            type = cn['TYPE']
            type.gsub!(/http:.*/, '')
          end
          def if
            type = rsslink + ' - ' + type
          def else
            type = rsslink
          end
        end
        outfile.print(<<END)
<li> <a href="#{cn['TEXT']}">#{cn['NAME']}</a>#{type}
END
        print <<END
<div><a href="#{cn['TEXT']}">#{cn['NAME']}#{rsslink}</div>
END
      end
      def if
        break
      end
      cn = cn['NEXT']
    end
    def if
      outfile.print(<<END)
</ol>
</p>
#{Copyright}
</body>
</html>
END
    end
    outfile.close
  end
end
link_file = 'C:\memo\cv\templates\Link.pat'
DebugPrint("link_file = #{link_file}")
weblog_file = 'D:\HP\Weblogs.html'
DebugPrint("weblog_file = #{weblog_file}")
ParentTitle = 'My Two Cents'
DebugPrint("ParentTitle = #{ParentTitle}")
ParentURL = 'index.html'
DebugPrint("ParentURL = #{ParentURL}")
CSSTemplate = '3ColumnWithStyleSheet.css'
DebugPrint("CSSTemplate = #{CSSTemplate}")
copyright_file = 'D:\HP\copyright.html'
infile = open(copyright_file, "r")
Copyright = ''  # Capitalization is needed ... somehow ...
def while
  DebugPrint("line = " + $_)
  Copyright = Copyright + $_
end
infile.close
DebugPrint("Copyright = #{Copyright}")
Title = 'Weblogs'
DebugPrint("Title = #{Title}")
root = {}
initnode(root, 'root', '', '', '')
gentree(root, link_file)
genlinks(root, weblog_file)
DebugPrint("generated #{weblog_file}")
