# File: GetWeb2_Perl.pl
# Date            Author        number of nodes
# 2005/7/30       Walking Lint  60
# 2005/7/30       Walking Lint  60 (GetWeb_Perl->GetWeb2_Perl)
# 2004/4/14       Walking Lint  60
# 2002/11/27      Walking Lint  44
# 2002/11/22      Walking Lint  43
# 2002/11/19      Walking Lint  31
# 2002/10/23      Walking Lint  22 (GetWeb2_Perl->GetWeb_Perl)
# 2002/4/21       Walking Lint  9
# 2002/4/21       Walking Lint  7 (GetWeb2->GetWeb2_Perl)
# 2002/4/21       Walking Lint  7 (GetWeb->GetWeb2)

=pod

=head1 NAME

GetWeb2_Perl.pl - get Web from URL

=head1 DESCRIPTION

ex. perl.exe GetWeb2_Perl.pl http://member.nifty.ne.jp/WalkingLint/index.html 1 1

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use Win32::Registry;
use Win32::Clipboard;
use Jcode;
$HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
$ref->GetValues(\%values);
$refproxyoverride = $values{'ProxyOverride'};
$refproxyserver = $values{'ProxyServer'};
$ref->Close();
$proxyoverride = $$refproxyoverride[2];
$proxyoverride =~ s/\*//g;
$proxyoverride =~ s/;?<local>//g;
$proxyoverride =~ s/;/\|/g; # not actually ...
$proxyoverride = quotemeta $proxyoverride;
$proxyoverride =~ s/\\\|/\|/g; # hack ...
$proxyoverride = '(' . $proxyoverride . ')';
$proxyserver = $$refproxyserver[2];
$url = shift;
$webagent = new LWP::UserAgent;
unless ($url =~ /$proxyoverride/) {
  $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
}
$toclipboard = shift;
$tosjis = shift;
$request = HTTP::Request->new('GET' => $url);
my $response = $webagent->request($request);
if ($response->is_success) {
  $doc = $response->content;
  $doc =~ s/[\n\r]+/\n/g; # not sure if needed ...
  if ($tosjis) {
    Jcode::convert(\$doc, 'sjis');
  }
  if ($toclipboard) {
    $clipboard = Win32::Clipboard();
    $clipboard->Set($doc . "\n");
  } else {
    print $doc . "\n";
  }
} else {
  DebugPrint("Cannot download $url");
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
