# File: GoogleCount_Perl.pl
# Date            Author        number of nodes
# 2003/9/1        Walking Lint  40
# 2003/8/30       Walking@Lint 40
# 2003/8/30       Walking@Lint 40 (GetGoogleCount_Perl->GoogleCount_Perl)
# 2003/8/30       Walking@Lint 40
# 2003/8/30       Walking@Lint 39 (63_1->GetGoogleCount_Perl)
# 2003/8/23

=pod

=head1 NAME

GoogleCount_Perl.pl - get estimated total results count of Google search

=head1 DESCRIPTION

activate as filter2 or program

=head1 AUTHOR

Walking Lint

=cut

my $google_key = $ENV{GoogleWebAPILicenseKey};
$google_key =~ s/"//g;
# Location of the GoogleSearch WSDL file
my $templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
my $google_wdsl = $templatesfolder . '\GoogleSearch.wsdl'; # http://api.google.com/GoogleSearch.wsdl
use SOAP::Lite;
my $query = shift;
# Create a new Google SOAP request
my $google_search = SOAP::Lite->service("file:$google_wdsl");
if (length($query) != 0) {
  $full_query = '"' . $_ . '"';
  # Query Google
  my $result = $google_search -> doGoogleSearch( $google_key, $full_query, 0, 10, "false", "",  "false", "", "latin1", "latin1" );
  # Output
  DebugPrint($full_query . ":\t" . $result->{estimatedTotalResultsCount});
} else {
  while (<STDIN>) {
    $_ =~ s/[\n\r]*$//;
    $full_query = '"' . $_ . '"';
    # Query Google
    my $result = $google_search -> doGoogleSearch( $google_key, $full_query, 0, 10, "false", "",  "false", "", "latin1", "latin1" );
    # Output
    DebugPrint($full_query . ":\t" . $result->{estimatedTotalResultsCount});
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
