# File: Html2Txt_Perl.pl
# Date            Author        number of nodes
# 2002/10/11      Walking Lint  26
# 
# File: Html2Txt_Perl.pl

=pod

=head1 NAME

Html2Txt_Perl.pl - html 2 text converter

=head1 DESCRIPTION

ex. perl.exe Html2Txt_Perl.pl "C:\memo\cv\templates\Html2Txt_Perl.html"

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use HTML::Parse;
use HTML::FormatText;
$from_file = shift;
DebugPrint("from_file = $from_file");
unless ($from_file =~ /\.s?htm/i) {
  $from_file =~ s/\.[a-zA-Z0-9]+$/.html/; # this is hack ...
}
DebugPrint("from_file = $from_file");
unless (-e $from_file) {
  print STDERR "$from_file does not exists.";
  exit;
}
$to_file = $from_file;
$to_file =~ s/\.[a-zA-Z0-9]+$/.txt/;
$html = parse_htmlfile($from_file);
$formatter = new HTML::FormatText(leftmargin => 0, rightmargin => 70);
open OUT, ">$to_file" or die "Cannot open $to_file.";
print OUT $formatter->format($html);
close OUT;
DebugPrint("generated $to_file");
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
