# File: IPC2Outline_Perl.pl
# Date            Author        number of nodes
# 2004/7/7        Walking Lint  14
# 2004/7/7        Walking Lint  39 (Src2Html_Perl->IPC2Outline_Perl)
# 2003/8/6        Walking@Lint 39
# 2002/7/19       Walking Lint  39
# 2002/7/16       Walking Lint  33
# 2002/7/15       Walking Lint  30
# 2002/4/21       Walking Lint  8 (strings_Perl->Src2Html_Perl)
# 2002/4/21       Walking Lint  6 (WordCount_Perl->strings_Perl)
while (<STDIN>) {
  $_ =~ s/^[E \t]*//;
  $_ =~ s/ bb[ ]*$//;
  if ($_ =~ /([0-9\/:]+) ((?:E)*)(.*)/) {
    $name = $1;
    $dots = $2;
    $text = $3;
    $level = length($dots) / 2;
    DebugPrint("level = $level");
    $indent = "\t" x $level;
    print $indent . $name . ' () // %' . '% ' . $text . "\n";
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
