# File: Log_Perl.pl
# Date            Author        number of nodes
# 2003/3/23       Walking Lint  27
# 2002/11/21      Walking Lint  26
# 2002/11/18      Walking Lint  25
# 2002/11/5       Walking Lint  32 (Log_Perl->Log_Perl)
# 2002/11/2       Walking Lint  32 (Log_Perl->Log_Perl)
# 2002/11/2       Walking Lint  59 (LoopUpInThesaurus_Perl->Log_Perl)
# 2002/9/10       Walking Lint  59 (Zips2Adrs_Perl->LoopUpInThesaurus_Perl)
# 2002/9/5        Walking Lint  58
# 2002/9/5        Walking Lint  58 (zips2adrs_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  66 (Zips2Adrs_Perl->zips2adrs_Perl)
# 2002/8/16       Walking Lint  57 (zip2adr_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  35 (zup2adr_Perl->zip2adr_Perl)
# 2002/7/15       Walking Lint  19 (grep_Perl->zup2adr_Perl)
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

Log_Perl.pl - grep Thesaurus.pat

=head1 DESCRIPTION

perl.exe Log_Perl.pl thesaurus

=head1 AUTHOR

Walking Lint

=cut

$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
$from_file = $templatesfolder . '\Weblog.pat';
$word = shift;
open IN, $from_file or die("Cannot open $from_file: $!\n");
while (<IN>) {
  $_ =~ /^(\t*)([^\(]+)/;
  $level = length($1);
  $name = $2;
  $name =~ s/( )+$//;
  $path{$level} = $name;
  if (/$word/) { # /$word2/
    foreach $i (1..$level - 1) {
      if (length($path{$i}) != 0) {
        print "$path{$i} > ";
      }
    }
    chop;
    $_ =~ s/^\t+//;
    ($link, $url) = split(' \(\) \/\/[ ]+\%\%[ ]+', $_);
    print $link . ' (' . $url . ")\n";
  }
}
close IN;
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
