root () //  %% File: MergeTemplates_Perl.txt (Plain) (HTML) (Original) CRLF Date            Author        number of nodes CRLF 2003/2/23       Walking Lint  125 CRLF 2002/11/29      Walking Lint  56 (CopyFilesToUpdate_Perl->MergeTemplates_Perl) CRLF 2002/11/27      Walking Lint  54 CRLF 2002/11/6       Walking Lint  54 CRLF 2002/10/31      Walking Lint  58 (CopyFilesToUpdate_Perl->CopyFilesToUpdate_Perl) CRLF 2002/10/4       Walking Lint  56 CRLF 2002/9/26       Walking Lint  46 CRLF 2002/9/25       Walking Lint  46 (CopyFilesToUpdate_Perl->CopyFilesToUpdate_Perl) CRLF 2002/9/9        Walking Lint  49 (CopyFilesToUpdate_Perl->CopyFilesToUpdate_Perl) CRLF 2002/9/7        Walking Lint  49 CRLF 2002/7/23       Walking Lint  9 (CheckModifiedTime_Perl->CopyFilesToUpdate_Perl) CRLF 2002/6/4        Walking Lint  6 (Time_Perl->CheckModifiedTime_Perl) CRLF 2002/3/3        Walking Lint  3 (Time_Perl->NewFile) CRLF 2002/2/19       Walking Lint  3 CRLF 2002/2/17       Walking Lint  3
	_doc ()
		NAME () //  %% MergeTemplates_Perl.pl - merge templates
		DESCRIPTION () // %% ex. perl.exe MergeTemplates_Perl.pl "C:\My Documents\templates"
		AUTHOR () //  %% [[Author]]
	use () // File::Basename
	use () // Win32::File
	use () // File::Copy
	use () // Time::localtime
	$from_dir (out) //   shift
	$from_dir (inout) // =~ s/\\$//
	$templates_folder (out) //   'C:\memo\cv\templates'
	$diff1_dir (out) //   $templates_folder . "\\diff1"
	$diff2_dir (out) //   $templates_folder . "\\diff2"
	DebugPrint () // "from_dir = $from_dir"
	$do_update (out) //   shift
	DebugPrint () // "do_update = $do_update"
	$do_copy (out) //   shift
	DebugPrint () // "do_copy = $do_copy"
	if () // not defined($from_dir)
		exit ()
	_ () //  %% clear diff1 diff2 folder
		if () // not -e $diff1_dir
			mkdir () // $diff1_dir, 0700 or die("Cannot make $diff1_dir: $!")
		else ()
			opendir () // DIR, $diff1_dir or die "opendir $diff1_dir failed: $!"
			@files (out) //   readdir DIR
			closedir () // DIR
			foreach () // $file (@files)
				$file (out) //   $to_dir . "\\" . basename($file)
				unlink () // $file
		if () // not -e $diff2_dir
			mkdir () // $diff2_dir, 0700 or die("Cannot make $diff2_dir: $!")
		else ()
			opendir () // DIR, $diff2_dir or die "opendir $diff2_dir failed: $!"
			@files (out) //   readdir DIR
			closedir () // DIR
			foreach () // $file (@files)
				$file (out) //   $to_dir . "\\" . basename($file)
				unlink () // $file
	opendir () // DIR, $templates_folder or die "opendir $templates_folder failed: $!"
	@current_files (out) //   grep /\.(pat)$/i, readdir DIR
	closedir () // DIR
	opendir () // DIR, $from_dir or die "opendir $from_dir failed: $!"
	@check_files (out) //   grep /\.(pat)$/i, readdir DIR
	closedir () // DIR
	%current_files (out) //   ()
	%check_files (out) //   ()
	%existing_files (out)
	foreach () // $file (@current_files)
		if () // ($file eq 'AutoBackup.pat') or ($file eq 'Log.pat') or ($file eq 'WebLog.pat')
			next ()
		$current_file (out) //   $templates_folder . "\\" . basename($file)
		_note () // commented out (2003/2/23)
			DebugPrint () // "current_file = $current_file"
		$current_files (out) // {$file}  $current_file
		$existing_files (inout) // {$file}  ++
	foreach () // $file (@check_files)
		if () // ($file eq 'AutoBackup.pat') or ($file eq 'Log.pat') or ($file eq 'WebLog.pat')
			next ()
		$check_file (out) //   $from_dir . "\\" . basename($file)
		_note () // commented out (2003/2/23)
			DebugPrint () // "check_file = $check_file"
		$check_files (out) // {$file}  $check_file
		$existing_files (inout) // {$file}  ++
	foreach () // $key (sort keys %existing_files)
		if () // defined($current_files{$key}) and defined($check_files{$key})
			$from_file (out) //   $current_files{$key}
			open () // IN, $from_file or die("Cannot open $from_file: $!\n")
			$log (out) //   <IN>
			$log (inout) // =~ s/( \CRLF |\n)+$//
			close () // IN
			@history1 (out) //   split(/ \CRLF /, $log)
			shift () // @history1
			shift () // @history1
			@history1 (out) //   reverse @history1
			$numofhistory1 (out) //   $#history1
			$from_file (out) //   $check_files{$key}
			open () // IN, $from_file or die("Cannot open $from_file: $!\n")
			$log (out) //   <IN>
			$log (inout) // =~ s/( \CRLF |\n)+$//
			close () // IN
			@history2 (out) //   split(/ \CRLF /, $log)
			shift () // @history2
			shift () // @history2
			@history2 (out) //   reverse @history2
			$numofhistory2 (out) //   $#history2
			$skip (out) //   0
			if () // $numofhistory1 == $numofhistory2
				for () // $i = 0; $i <= $#history1; $i++
					if () // $history1[$i] != $history2[$i]
						DebugPrint () // "need to check $key"
						copy () // $current_files{$key}, $diff1_dir . "\\" . $key
						copy () // $check_files{$key}, $diff2_dir . "\\" . $key
						break ()
			elsif () // $numofhistory1 < $numofhistory2
				for () // $i = 0; $i <= $#history1; $i++
					if () // $history1[$i] != $history2[$i]
						$skip (out) //   1
						DebugPrint () // "need to check $key"
						copy () // $current_files{$key}, $diff1_dir . "\\" . $key
						copy () // $check_files{$key}, $diff2_dir . "\\" . $key
						break ()
					if () // not ($skip == 1)
						if () // $do_update
							copy () // $check_files{$key}, $current_files{$key}
							DebugPrint () // "updated $key"
						else ()
							DebugPrint () // "need to update $key"
			else ()
				for () // $i = 0; $i <= $#history1; $i++
					if () // $history1[$i] != $history2[$i]
						DebugPrint () // "need to check $key"
						copy () // $current_files{$key}, $diff1_dir . "\\" . $key
						copy () // $check_files{$key}, $diff2_dir . "\\" . $key
						break ()
		if () // not defined($current_files{$key}) and defined($check_files{$key})
			if () // $do_copy
				copy () // $check_files{$key}, $current_files{$key}
				DebugPrint () // "copied $key"
			else ()
				DebugPrint () // "need to copy $key"
	exit ()
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
