# File: OpmlReader_Python.py
# Date            Author        number of nodes
# 2003/3/3        Walking Lint  109
# 2002/11/12      Walking Lint  101
# 2002/11/12      Walking Lint  86 (XmlReader_Python->OpmlReader_Python)
# 2002/11/10      Walking Lint  72
# 2002/11/10      Walking Lint  13 (dom_from_xml_file->XmlReader_Python)
from xml.dom import ext
from xml.dom import Node
from xml.dom.ext.reader import PyExpat
from CVTree_Python import *
def DebugPrint(str):
    sys.stderr.write(str + "\n")
def gentreefromdombody(nd, domnd):
    global rootnd
    domcn = domnd.firstChild
    while domcn != None:
      name = domcn.nodeName
      if (domcn.attributes != None): # and (domcn.nodeType == Node.ELEMENT_NODE)
        items = []
        for key in domcn.attributes.keys():
          items.append(domcn.attributes[key].nodeName + '="' + domcn.attributes[key].nodeValue + '"')
        type = string.join(items, " ")
      else:
        type = ''
      if name == '#comment':
        name = '_'
      elif name == '#document':
        name = '?xml'
      elif name == 'body':
        name = 'root'
      elif name == '#text':
        name = '_text'
      if name == '_text':
        text = domcn.nodeValue
        text = re.sub("[ \t\n]+$", '', text)
        text = re.sub("^[ \t\n]+", '', text)
        if len(text) != 0:
          text = re.sub("\n", " " + "CRLF ", text)
          nd['TEXT'] = text # think later ...
      else:
        text = ''
        if domcn.nodeValue != None:
          text = domcn.nodeValue
          text = re.sub("[ \t\n]+$", '', text)
          text = re.sub("^[ \t\n]+", '', text)
          text = re.sub("\n", " " + "CRLF ", text)
        if name == 'outline':
          for key in domcn.attributes.keys():
            if domcn.attributes[key].nodeName == 'text':
              tmp = domcn.attributes[key].nodeValue
              break
          if domcn.firstChild != None:
            cn = addchildnode(nd, tmp, '', '', '')
          else:
            cn = addchildnode(nd, '_text', '', '', tmp)
        else:
          cn = addchildnode(nd, name, '', type, text)
        gentreefromdombody(cn, domcn)
      if domcn.nodeType == 10:
        delnd = cn
      if name == 'root':
        rootnd = cn
      domcn = domcn.nextSibling
def gentreefromdom(nd, domnd):
    name = domnd.nodeName
    if name == '#document':
      name = '?xml'
    if (domnd.attributes != None): # and (domnd.nodeType == Node.ELEMENT_NODE)
      items = []
      for key in domnd.attributes.keys():
        items.append(domnd.attributes[key].nodeName + '="' + domnd.attributes[key].nodeValue + '"')
      type = string.join(items, " ")
    else:
      type = ''
    text = ''
    if domnd.nodeValue != None:
      text = domcn.nodeValue
    cn = addchildnode(nd, name, '', type, text)
    gentreefromdombody(cn, domnd)
import sys
infile = sys.argv[1]
outfile = infile
outfile = re.sub("\..+$", ".pat", outfile)
reader = PyExpat.Reader()
dom = reader.fromUri(infile)
# generate .pat here ... think later ...
root = {}
rootnd = root
delnd = {}
initnode(root, 'root', '', '', '')
gentreefromdom(root, dom)
savetree(rootnd, outfile)
reader.releaseNode(dom)
