root () //  %% File: PatentMapWriter_Perl.pl CRLF Date            Author        number of nodes CRLF 2006/11/10      Walking Lint  225 CRLF 2006/3/24       Walking Lint  217 CRLF 2006/3/20       Walking Lint  216 CRLF 2005/3/24       Walking Lint  194 CRLF 2005/3/23       Walking Lint  194 CRLF 2005/3/18       Walking Lint  193 CRLF 2005/3/15       Walking Lint  194 CRLF 2005/3/11       Walking Lint  192 CRLF 2005/3/10       Walking Lint  188 CRLF 2005/3/8        Walking Lint  165 CRLF 2005/3/7        Walking Lint  132 CRLF 2005/3/5        Walking Lint  123 CRLF 2005/3/5        Walking Lint  42 (IniWriter_Perl->PatentMapWriter_Perl) CRLF 2005/2/2        Walking Lint  42 CRLF 2003/10/20      Walking Lint  42 CRLF 2003/9/2        Walking Lint  44 CRLF 2003/3/6        Walking Lint  126 CRLF 2003/3/3        Walking Lint  120 CRLF 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl) CRLF 2002/11/25      Walking Lint  215 CRLF 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile) CRLF 2002/11/18      Walking Lint  212 CRLF 2002/11/15      Walking Lint  212 CRLF 2002/11/5       Walking Lint  212 CRLF 2002/11/1       Walking Lint  205 CRLF 2002/10/31      Walking Lint  184 CRLF 2002/10/28      Walking Lint  161 CRLF 2002/10/22      Walking Lint  138 CRLF 2002/10/18      Walking Lint  136 CRLF 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl) CRLF 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl) CRLF 2002/10/10      Walking Lint  178 CRLF 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl) CRLF 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl) CRLF 2002/9/3        Walking Lint  149 CRLF 2002/7/4        Walking Lint  141 CRLF 2002/6/7        Walking Lint  136 CRLF 2002/6/4        Walking Lint  131 CRLF 2002/4/21       Walking Lint  120 CRLF 2002/4/12       Walking Lint  112 CRLF 2002/4/4        Walking Lint  85
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - patent map writer
		DESCRIPTION () //  %% activate as plug-in ex. .tsv () // %% PatentMapWriter_Perl
		AUTHOR () //  %% [[Author]]
	use () // lib '.'
	use () // CVTree_Perl
	use () // File::Basename
	use () // Time::localtime
	$with_co (out) //   shift
	_note () // commented out (2005/3/8)
		DebugPrint () // "with_co = $with_co"
	$is_US (out) //   shift
	_note () // commented out (2005/3/8)
		DebugPrint () // "is_US = $is_US"
	$to_file (out) //   shift
	$from_file (out) //   $to_file
	$from_file (inout) // =~ s/\..+/.pat/
	if () // $is_US == 1
		$FTermList (out) //   $ENV{TEMPLATESFOLDER} . "\\PatentClassList.txt"
	else ()
		$FTermList (out) //   $ENV{TEMPLATESFOLDER} . "\\FTermList.txt"
	_note () // commented out (2005/3/5)
		DebugPrint () // "FTermList = $FTermList"
	if () // -e $FTermList
		$FTermListExisted (out) //   1
		open () // IN, $FTermList or die("Cannot open $FTermList $!\n")
		@pairs (out) //   <IN>
		foreach () // $pair (@pairs)
			$pair (inout) // =~ s/[\r\n]+$//
			($code, $def) (out) //   split(/\t/, $pair)
			$ftermdef (out) // {$code}  $def
			_note () // commented out (2005/3/5)
				DebugPrint () // "ftermdef{code} = $ftermdef{$code}"
		close () // IN
	_note () // commented out (2005/3/5)
		DebugPrint () // "FTermList = $FTermList"
	$root (out) // my  {}
	&initnode () // $root, 'root', '', '', ''
	&gentree () // $root, $from_file
	if () // length($to_file) != 0
		open () // OUT, ">$to_file"
		$outfilehandle (out) //   'OUT'
	else ()
		$outfilehandle (out) //   'STDOUT'
	&setmap () // $root
	&genpatmap () // $root
	if () // length($to_file) != 0
		close () // OUT
		DebugPrint () // "generated $to_file"
	setmap ()
		$nd (in) &
		_note () // commented out (2002/11/1)
			Trace () // "enter setmap($nd->{NAME})"
		if () // defined($nd->{CHILD})
			$cn (out) // my  $nd->{CHILD}
			while () // 1
				_note () // commented out (2006/11/10)
					if () // ($is_US == 0) and ($cn->{NAME} eq 's') or ($is_US == 1) and ($cn->{NAME} eq 'United States Patent')
				if () // ($is_US == 0) and ($cn->{NAME} eq 's') or ($is_US == 1) and ($cn->{NAME} =~ /^Patent\/Publication Number/) %% for MicroPatentReader
					$text (out) //   $cn->{TEXT}
					_note () // commented out (2006/3/20)
						if () // $is_US == 1
							($company, $name, $dummy, $dummy, $dummy, $dummy, $file) (out) //   split(/\t/, $text) %% customize here as needed ...
						else ()
					($company, $name, $dummy, $dummy, $file, $dummy) (out) //   split(/\t/, $text)
					_note () // commented out (2006/11/10)
						DebugPrint () // "(company, name, dummy, dummy, file, dummy) = ($company, $name, $dummy, $dummy, $file, $dummy)"
					if () // $cn->{KIND} =~ /!/
						$cn->{TEXT} (inout) // =~ s/$company/$company */ %% this is hack ...
					$file (inout) // =~ s/\.txt$//
					$ccn (out) // my  $cn->{CHILD}
					$found_fterm (out) //   ''
					$found_fterm2 (out) //   ''
					while () // 1
						_note () // commented out (2006/11/10)
							DebugPrint () // "ccn->{NAME} = $ccn->{NAME}"
						_note () // commented out (2005/3/10)
							if () // ($is_US == 0) and ($ccn->{NAME} =~ /^(|㗝l|Ql|ol^ҁieiXj|)$/)
						if () // ($is_US == 0) and ($ccn->{NAME} =~ /^(|㗝l|ol||lĎ|Ql)/)
							_note () // commented out (2005/3/11)
								DebugPrint () // "ccn->{NAME} = $ccn->{NAME}"
							$cccn (out) // my  $ccn->{CHILD}
							while () // 1
								if () // $cccn->{NAME} eq 'e^[iQlj' %% try this ...
									$found_fterm (out) //   $cccn->{TEXT}
									_note () // commented out (2005/3/11)
										DebugPrint () // "found_fterm = $found_fterm"
								elsif () // $cccn->{NAME} eq 'e^[ieiXj'
									$found_fterm2 (out) //   $cccn->{TEXT}
									_note () // commented out (2005/3/11)
										DebugPrint () // "found_fterm2 = $found_fterm2"
									_note () // commented out (2005/3/10)
										@items (out) //   split(/\t/, $cccn->{TEXT})
										%found_pcs (out) //   ()
										$cnt (out) // my  0
										foreach () // $item (@items)
											if () // $cnt % 2 == 0
												$found_pcs (inout) // {$item}  ++
											$cnt (inout) // ++
										foreach () // $pc (keys %found_pcs)
											$fterms (inout) // {$pc}  ++
											$index (out) //   $pc . '_' . $file
											$map (inout) // {$index}  ++
								if () // not defined($cccn->{NEXT})
									last ()
								$cccn (out) //   $cccn->{NEXT}
						_note () // commented out (2006/3/20)
							elsif () // ($is_US == 1) and ($ccn->{NAME} eq 'Current U.S. Class')
								@items (out) //   split(/; /, $ccn->{TEXT})
								%found_pcs (out) //   ()
								foreach () // $item (@items)
									($pc, $pc2) (out) //   split(/\//, $item)
									$found_pcs (inout) // {$pc}  ++
								foreach () // $pc (keys %found_pcs)
									$fterms (inout) // {$pc}  ++
									$index (out) //   $pc . '_' . $file
									$map (inout) // {$index}  ++
						elsif () // ($is_US == 1) and ($ccn->{NAME} eq 'CLASSIFICATION') %% for MicroPatentReader
							$cccn (out) // my  $ccn->{CHILD}
							while () // 1
								if () // ($cccn->{NAME} eq 'U.S. Class') or ($cccn->{NAME} eq 'US Class')
									$item (out) //   $cccn->{TEXT}
									$item (inout) // =~ /([0-9][0-9][0-9])([0-9][0-9][0-9])/
									$pc (out) //   $1
									_note () // commented out (2006/11/10)
										DebugPrint () // "pc = $pc"
									$pc (inout) // =~ s/^[0]+//
									$fterms (inout) // {$pc}  ++
									$index (out) //   $pc . '_' . $file
									$map (inout) // {$index}  ++
									break ()
								if () // not defined($cccn->{NEXT})
									last ()
								$cccn (out) //   $cccn->{NEXT}
						if () // not defined($ccn->{NEXT})
							last ()
						$ccn (out) //   $ccn->{NEXT}
					if () // length($found_fterm2) != 0
						$found_fterm (out) //   $found_fterm2
					if () // length($found_fterm) != 0
						@items (out) //   split(/\t/, $found_fterm)
						%found_pcs (out) //   ()
						$cnt (out) // my  0
						foreach () // $item (@items)
							if () // $cnt % 2 == 0
								$found_pcs (inout) // {$item}  ++
							$cnt (inout) // ++
						foreach () // $pc (keys %found_pcs)
							$fterms (inout) // {$pc}  ++
							$index (out) //   $pc . '_' . $file
							$map (inout) // {$index}  ++
				if () // not defined($cn->{NEXT})
					last ()
				$cn (out) //   $cn->{NEXT}
	genpatmap ()
		$nd (in) &
		_note () // commented out (2002/11/1)
			Trace () // "enter genpatmap($nd->{NAME})"
		print () // $outfilehandle "\t"
		if () // $with_co
			print () // $outfilehandle "\t"
		foreach () // $fterm (sort {$fterms{$b} <=> $fterms{$a}} keys %fterms)
			print () // $outfilehandle "\t" . $fterm
			$index (out) //   $fterm . '_' . $file
		print () // $outfilehandle "\n"
		if () // $FTermListExisted
			if () // $with_co
				print () // $outfilehandle "\t"
			print () // $outfilehandle "\t"
			foreach () // $fterm (sort {$fterms{$b} <=> $fterms{$a}} keys %fterms)
				_note () // commented out (2005/3/8)
					DebugPrint () // "ftermdef{fterm} = $ftermdef{$fterm}"
				print () // $outfilehandle "\t" . $ftermdef{$fterm}
			print () // $outfilehandle "\n"
		if () // $with_co
			if () // $is_US == 0
				print () // $outfilehandle "Ж\t"
			else ()
				print () // $outfilehandle "Corp.\t"
		if () // $is_US == 0
			print () // $outfilehandle "\t"
		else ()
			print () // $outfilehandle "Name\t"
		foreach () // $fterm (sort {$fterms{$b} <=> $fterms{$a}} keys %fterms)
			if () // $is_US == 0
				print () // $outfilehandle "\t" . $fterms{$fterm} . ''
			else ()
				print () // $outfilehandle "\t" . $fterms{$fterm}
			$index (out) //   $fterm . '_' . $file
		print () // $outfilehandle "\n"
		if () // defined($nd->{CHILD})
			$cn (out) // my  $nd->{CHILD}
			while () // 1
				_note () // commented out (2006/11/10)
					if () // ($is_US == 0) and ($cn->{NAME} eq 's') or ($is_US == 1) and ($cn->{NAME} eq 'United States Patent')
				if () // ($is_US == 0) and ($cn->{NAME} eq 's') or ($is_US == 1) and ($cn->{NAME} =~ /^Patent\/Publication Number/) %% for MicroPatentReader
					$text (out) //   $cn->{TEXT}
					($company, $name, $dummy, $dummy, $file, $dummy) (out) //   split(/\t/, $text)
					_note () // commented out (2006/3/20)
						DebugPrint () // "(company, name, dummy, dummy, file, dummy) = ($company, $name, $dummy, $dummy, $file, $dummy)"
					$file (inout) // =~ s/\.txt$//
					if () // ($is_US == 0) or ($file =~ /^[0-9,A-Z\(\)]+$/) %% actually not sure ...
						_note () // commented out (2006/3/20)
							DebugPrint () // "file = $file"
						if () // $with_co
							print () // $outfilehandle $company, "\t"
						print () // $outfilehandle $name . "\t" . $file
						foreach () // $fterm (sort {$fterms{$b} <=> $fterms{$a}} keys %fterms)
							print () // $outfilehandle "\t"
							$index (out) //   $fterm . '_' . $file
							if () // defined($map{$index})
								if () // $is_US == 0
									print () // $outfilehandle ""
								else ()
									print () // $outfilehandle "1"
						print () // $outfilehandle "\n"
				if () // not defined($cn->{NEXT})
					last ()
				$cn (out) //   $cn->{NEXT}
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
	Trace ()
		$str (in) &
		print () // STDERR "$str\n"
