# File: PathWithText_Perl.pl
# Date            Author        number of nodes
# 2004/11/27      Walking Lint  45
use CVTree_Perl;
$from_file = shift;
# by using [[CurrentIndex]] you can get current absolute index of selected node
# [[CurrentMarkIndex]] which returns current absolute index of marked node is also implemented so you can use it for processing region
$from_index = shift;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
$index = 0;
&genpath($root);
sub genpath {
  my($nd) = @_;
  if ($index == $from_index) {
    &genpathbody($nd);
  }
  $index++;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      &genpath($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub genpathbody {
  my($nd) = @_;
  $path = '';
  while ($nd != $root) {
    if (length($path) == 0) {
      $path = $nd->{TEXT};
    } else {
      if (length($nd->{TEXT}) != 0) {
      }
      $path = $nd->{TEXT} . ' / ' . $path;
    }
    $nd = $nd->{PARENT};
  }
  $path =~ s/[ ]+CRLF[ ]+/ /g;
  DebugPrint($path);
  exit;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
  sub Trace {
    my($str) = @_;
    print STDERR "$str\n";
  }
}
