# File: PrevMonth_Perl.pl
# Date            Author        number of nodes
# 2002/12/7       Walking Lint  13
# 2002/12/7       Walking Lint  13 (NextMonth_Perl->PrevMonth_Perl)
# 2002/10/8       Walking Lint  7 (NextMonth_Perl->NextMonth_Perl)
# 2002/10/2       Walking Lint  7 (NextMonth_Perl->NextMonth_Perl)
# 2002/10/2       Walking Lint  39 (RefFromClipboard_Perl->NextMonth_Perl)
# 2002/9/29       Walking Lint  28 (SplitLine_Perl->RefFromClipboard_Perl)
# 2002/7/4        Walking Lint  13 (EncloseLinesWithTag_Perl->SplitLine_Perl)
# 2002/7/4        Walking Lint  7 (DeleteNotMatchedLine_Perl->EncloseLinesWithTag_Perl)
# 2002/6/14       Walking Lint  6
# 2002/4/24       Walking Lint  4
# 2002/4/20       Walking Lint  4 (DeleteMatchedLine_Perl->DeleteNotMatchedLine_Perl)

=pod

=head1 NAME

PrevMonth_Perl.pl - get last day of prev month

=head1 DESCRIPTION

ex. perl.exe PrevMonth_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use Time::localtime;
$tm = localtime;
$year = $tm->year + 1900;
$month = $tm->mon;
if ($month == 0) {
  $month = 12;
  $year--;
}
$lastday = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)[$month - 1] + ($month == 2 && ($year % 4 == 0 && $year % 100 != 0 || $year % 400 == 0));
printf "%04d/%02d/%02d", $year, $month, $lastday;
