# File: Primes_Ruby.rb
# Date            Author        number of nodes
# 2002/3/10       Walking Lint  24
# 2002/1/13       Walking Lint  22
class Primes
  List = [2]
  def [](n)
    List[n]
  end
  def succ
    n = List[-1] + 1
    n += 1 while List.find{|k| n % k == 0}
    List << n
    n
  end
  def each
    def do
      yield(succ)
    end
  end
end
primes = Primes.new
primes.each(x) do 
  break if x > 1000
  p(x)
end
