# File: RSS_Perl.pl
# Date            Author        number of nodes
# 2002/8/26       Walking Lint  12
use warnings;
use strict;
use XML::RSSLite;
my @results = ();
open FH, "scriptingNews2.xml" or die "Can't open file: $!";
undef $/;
my $content = <FH>;
close FH;
parseXML(\results, \$content);
print "=== Channel ===\n", "Title: $results{'title'}\n", "Desc:  $results{'description'}\n", "Link:  $results{'link'}\n";
foreach $item (@{$results{'items'}}) {
  print "  --- Item ---\n", "  Title: $item->{'title'}\n", "  Desc:  $item->{'description'}\n", "  Link:  $item->{'link'}\n\n";
}
