# File: Ref2Text_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 21
# 2002/9/12       Walking Lint  13
# 2002/9/12       Walking Lint  4 (URLRef2Text_Perl->Ref2Text_Perl)
# 2002/9/6        Walking Lint  38 (sed_Perl->URLRef2Text_Perl)
# 2002/7/16       Walking Lint  29
# 2002/7/15       Walking Lint  19 (grep_Perl->sed_Perl)
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5
$indent = '  ';
$inref = 0;
$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  if ($inref) {
    if (/^<\/div>/) {
      $inref = 0;
    } else {
      print $indent . $_;
    }
  } else {
    if (/^<div class="ref">/) {
      $inref = 1;
    } else {
      print $_;
    }
  }
  if ($breaklater) {
    last;
  }
}
