# File: STReader_Perl.pl
# Date            Author        number of nodes
# 2002/6/4        Walking Lint  39
# 2002/6/4        Walking Lint  31 (GenWebLog_Perl->STReader_Perl)
# 2002/6/4        Walking Lint  17 (GenLink_Perl->GenWebLog_Perl)
# 2002/4/5        Walking Lint  37 (dump_Perl->GenLink_Perl)
# 2002/4/4        Walking Lint  34
$from_file = shift;
$to_file = $from_file;
$to_file =~ s/\..+/\.pat/;
open IN, $from_file || die("Can't open $from_file: $!\n");
open OUT, ">$to_file";
print OUT "root ()\n";
$firstline = 1;
$secondline = 0;
$level = 1;
$nodename = '';
@textlines = ();
while (<IN>) {
  chop;
  if (/^\t[ ]*$/) {
    print OUT "\t" x $level . $nodename . " () // \%\% " . join(' CR' . 'LF ', @textlines) . "\n";
    $level++;
    $firstline = 1;
    @textlines = ();
  } elsif (/^([ ]+)$/) {
    print OUT "\t" x $level . $nodename . " () // \%\% " . join(' CR' . 'LF ', @textlines) . "\n";
    $level -= length($1) - 1;
    $firstline = 1;
    @textlines = ();
  } else {
    if ($firstline) {
      $firstline = 0;
      $secondline = 1;
      $nodename = $_;
    } else {
      if ($secondline) {
        $secondline = 0;
        unless (length($_) == 0) {
          push @textlines, $_;
        }
      } else {
        push @textlines, $_;
      }
    }
  }
}
close IN;
close OUT;
