# File: SetFileAttr_Perl.pl
# Date            Author        number of nodes
# 2002/7/19       Walking Lint  18
# 2002/7/18       Walking Lint  18 (PDFRef2ActiveXRef_Perl->SetFileAttr_Perl)
# 2001/8/15       Walking Lint  17 (Filter3_Perl->NewFile)

=pod

=head1 NAME

SetFileAttr_Perl.pl - set file attribute

=head1 DESCRIPTION

SetFileAttr files

=head1 AUTHOR

<a href="http://member.nifty.ne.jp/WalkingLint/">Walking Lint</a>

=cut

use Cwd;
use File::Find;
use File::Basename;
use Win32::File;
$dir = shift;
find(\&check_file, $dir);
sub check_file {
  $file_to_check = $_;
  if ($file_to_check =~ /.html$/) { # currently this may be better...
    $from_file = cwd . "/$_";
    # [[Perl for Win32 - System Module Extensions!http://www.intermedia.net/support/Perl/Perl-Win32/win32mod.html#File]] Q
    Win32::File::GetAttributes($from_file, $attr);
    Win32::File::SetAttributes($from_file, (($attr & ~Win32::File::READONLY) & ~Win32::File::ARCHIVE));
  }
}
print STDERR "dropped ARCHIVE/READONLY attributes of html files under $dir";
