# File: SortPlainPart_Perl.pl
# Date            Author        number of nodes
# 2005/8/8        Walking Lint  24
# 2005/8/8        Walking Lint  18 (sort_plain_part_Perl->SortPlainPart_Perl)
# 2005/8/8        Walking Lint  18
# 2005/8/8        Walking Lint  18 (sort_Perl->sort_plain_part_Perl)
# 2005/6/25       Walking Lint  18
# 2005/3/16       Walking Lint  17
# 2003/8/30       Walking@Lint 22
# 2003/8/6        Walking@Lint 15
# 2003/5/10       Walking Lint  9
# 2002/11/6       Walking Lint  7
# 2002/11/4       Walking Lint  3
# 2002/2/3        Walking Lint  3 (Sort2_Perl->sort_Perl)

=pod

=head1 NAME

SortPlainPart_Perl.pl - sort lines with uniq function with plain part

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use encoding 'SJIS';
@unsorted = ();
while (<STDIN>) {
  $_ =~ s/[\n\r]*$//;
  push @unsorted, $_;
}
@sorted = sort {&plain($a) cmp &plain($b)} @unsorted;
%seen = ();
foreach $item (@sorted) {
  if (length($item) > 0) {
    print $item . "\n" unless $seen{$item}++;
  }
}
sub plain {
  my($str) = @_;
  $str =~ s/<[^>]*?>//g;
  $str =~ s/\[\[[^\]]*?\]\]//g;
  return $str;
}
