# File: Statistic_Perl.pl
# Date            Author        number of nodes
# 2003/8/30       Walking@Lint 27
# 2003/8/6        Walking@Lint 21
# 2003/4/9        Walking Lint  15
# 2003/4/9        Walking Lint  15 (InfoText_Perl->Statistic_Perl)
# 2003/1/14       Walking Lint  15
# 2003/1/14       Walking Lint  15 (Info_Perl->InfoText_Perl)
# 2002/11/28      Walking Lint  15
# 2002/11/22      Walking Lint  15 (Count_Perl->Info_Perl)
# 2002/10/21      Walking Lint  11 (ShowInfo_Perl->Count_Perl)
# 2002/9/23       Walking Lint  11 (ShowInfo_Perl->ShowInfo_Perl)
# 2002/9/6        Walking Lint  19 (RGBView_Perl->ShowInfo_Perl)
# 2002/7/9        Walking Lint  26 (RGBEdit_Perl->RGBView_Perl)
# 2002/3/26       Walking Lint  16

=pod

=head1 NAME

Statistic_Perl.pl - count lines/words/chars

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

@texts = ();
while (<STDIN>) {
  push @texts, $_;
}
$text = join('', @texts);
@words = split(/[\t\n ]+/, $text);
$newlines = $text;
$newlines =~ s/[^\n]+//g;
print STDERR "\n" . @texts . "\tlines\n";
print STDERR @words . "\twords\n";
print STDERR (length($text) - length($newlines)) . "\tchars\n";
print STDERR (length($text)) . "\tchars(including \\n)\n";
print STDERR (length($text) + length($newlines)) . "\tchars(including \\n and estimated \\r)\n"; # estimation ...
