# File: SundayInNextWeek_Perl.pl
# Date            Author        number of nodes
# 2002/12/26      Walking Lint  40
# 2002/11/21      Walking Lint  33
# 2002/11/21      Walking Lint  33 (SaturdayInNextWeek_Perl->SundayInNextWeek_Perl)
# 2002/11/21      Walking Lint  33 (FridayInNextWeek_Perl->SaturdayInNextWeek_Perl)
# 2002/11/21      Walking Lint  33 (ThursdayInNextWeek_Perl->FridayInNextWeek_Perl)
# 2002/11/21      Walking Lint  33 (WednesdayInNextWeek_Perl->ThursdayInNextWeek_Perl)
# 2002/11/21      Walking Lint  33 (TuesdayInNextWeek_Perl->WednesdayInNextWeek_Perl)
# 2002/11/21      Walking Lint  33 (MondayInNextWeek_Perl->TuesdayInNextWeek_Perl)
# 2002/11/21      Walking Lint  33 (NextWeek_Perl->MondayInNextWeek_Perl)
# 2002/11/21      Walking Lint  25 (ThisWeek_Perl->NextWeek_Perl)
# 2002/11/19      Walking Lint  25
# 2002/10/18      Walking Lint  25 (ThisWeek_Perl->ThisWeek_Perl)
# 2002/10/18      Walking Lint  29 (ThisWeek_Perl->ThisWeek_Perl)
# 2002/10/18      Walking Lint  29 (ThisMonth_Perl->ThisWeek_Perl)
# 2002/10/16      Walking Lint  19 (ThisMonth_Perl->ThisMonth_Perl)
# 2002/10/16      Walking Lint  19 (ThisWeek_Perl->ThisMonth_Perl)
# 2002/10/8       Walking Lint  7 (NextWeek_Perl->ThisWeek_Perl)
# 2002/10/8       Walking Lint  7 (ThisWeek_Perl->NextWeek_Perl)
# 2002/10/8       Walking Lint  7 (ThisWeek_Perl->ThisWeek_Perl)
# 2002/10/2       Walking Lint  7 (ThisWeek_Perl->ThisWeek_Perl)
# 2002/10/2       Walking Lint  39 (RefFromClipboard_Perl->ThisWeek_Perl)
# 2002/9/29       Walking Lint  28 (SplitLine_Perl->RefFromClipboard_Perl)
# 2002/7/4        Walking Lint  13 (EncloseLinesWithTag_Perl->SplitLine_Perl)
# 2002/7/4        Walking Lint  7 (DeleteNotMatchedLine_Perl->EncloseLinesWithTag_Perl)
# 2002/6/14       Walking Lint  6
# 2002/4/24       Walking Lint  4
# 2002/4/20       Walking Lint  4 (DeleteMatchedLine_Perl->DeleteNotMatchedLine_Perl)

=pod

=head1 NAME

SundayInNextWeek_Perl.pl

=head1 DESCRIPTION

ex. perl.exe SundayInNextWeek_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use Time::localtime;
$time = time;
$nextweek = 0;
$time += 60 * 60 * 24;
while (1) {
  $yobi = &yobi($time);
  if ($yobi == 1) {
    $nextweek = 1;
  }
  if ($nextweek and ($yobi == 0)) {
    $possiblelastday = $day;
    $possiblelastmonth = $month;
    $possiblelastyear = $year;
    last;
  }
  $time += 60 * 60 * 24;
}
printf "%04d/%02d/%02d", $possiblelastyear, $possiblelastmonth, $possiblelastday;
# [[Re: Getting Day of Week for a specific date!http://granite.unh.edu/pasnews/msg00674.html]]
sub day_of_week {
  my($y, $m, $d) = @_;
  @t = (0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4);
  $y -= ($m < 3);
  return ($y + int($y / 4) - int($y / 100) + int($y / 400) +$t[$m - 1] + $d) % 7;
}
sub yobi {
  my($time) = @_;
  my $tm = localtime($time);
  $year = $tm->year + 1900;
  $month = $tm->mon + 1;
  $day = $tm->mday;
  return &day_of_week($year, $month, $day);
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
