# File: Text2Html_Perl.pl
# Date            Author        number of nodes
# 2004/8/5        Walking Lint  109
# 2004/8/5        Walking Lint  337 (2Hatena_Perl->Text2Html_Perl)
# 2004/7/30       Walking Lint  337
# 2004/7/28       Walking Lint  335
# 2004/7/23       Walking Lint  334
# 2004/6/18       Walking Lint  332
# 2004/6/15       Walking Lint  332
# 2004/6/13       Walking Lint  331
# 2004/6/13       Walking Lint  364 (2Haneta_Perl->2Hatena_Perl)
# 2004/6/13       Walking Lint  186
# 2004/6/13       Walking Lint  186 (2Hatena_Perl->2Haneta_Perl)
# 2004/4/9        Walking Lint  186
# 2004/4/3        Walking Lint  186
# 2004/4/2        Walking Lint  176
# 2004/3/27       Walking Lint  172
# 2004/3/23       Walking Lint  170
# 2003/12/4       Walking@Lint 169
# 2003/11/24      Walking@Lint 168
# 2003/11/19      Walking@Lint 164
# 2003/11/17      Walking Lint  162
# 2003/11/14      Walking@Lint 161
# 2003/11/5       Walking@Lint 161
# 2003/11/5       Walking Lint  159
# 2003/10/17      Walking@Lint 159
# 2003/10/15      Walking@Lint 148
# 2003/10/10      Walking@Lint 147
# 2003/10/9       Walking@Lint 144
# 2003/10/6       Walking@Lint 142
# 2003/10/5       Walking@Lint 131
# 2003/10/4       Walking@Lint 130
# 2003/10/3       Walking@Lint 128
# 2003/10/1       Walking@Lint 93
# 2003/10/1       Walking Lint  92
# 2003/10/1       Walking Lint  80 (TextWithStructureWriter_Perl->2Hatena_Perl)
# 2003/10/1       Walking Lint  80
# 2003/5/8        Walking Lint  74
# 2003/5/8        Walking Lint  60 (2PowerPoint_Perl->TextWithStructureWriter_Perl)
# 2003/2/12       Walking Lint  60
# 2002/11/10      Walking Lint  33 (2PowerPoint_Perl->2PowerPoint_Perl)
# 2002/11/9       Walking Lint  29
# 2002/6/4        Walking Lint  29 (CSVWriter_Perl->2PowerPoint_Perl)
# 2002/3/10       Walking Lint  20
$outfilehandle = 'STDOUT';
$in_pre = 0;
$in_ul = 0;
$in_ol = 0;
$found_space = 1;
$text = '';
while (<STDIN>) {
  $line = $_;
  $line =~ s/[\r\n]+$//;
  if ($in_pre) {
    if (($line =~ /<\/pre>/) or ($line =~ /<\/div>/)) {
      $in_pre = 0;
      $line =~ s/<\/div>/<\/pre>/; # hack ...
    }
    $text .= "\n" . $line;
  } else {
    if ($line =~ /^- /) {
      $line =~ s/^-/<li>/;
      if ($in_ul == 0) {
        $in_ul = 1;
        $text .=  "<ul>" . $line;
      } else {
        $text .=  "\n" . $line;
      }
      $found_space = 1;
    } elsif ($line =~ /^\+ /) {
      $line =~ s/^\+/<li>/;
      if ($in_ol == 0) {
        $in_ol = 1;
        $text .=  "<ol>" . $line;
      } else {
        $text .=  "\n" . $line;
      }
      $found_space = 1;
    } elsif (($line =~ /^E/) and not ($line =~ /^EE/)) {
      $line =~ s/^E/<li> /;
      $text .=  "\n" . $line;
      $found_space = 1;
    } elsif (($line =~ /^/) and not ($line =~ /^/)) {
      $line =~ s/^/<li> /;
      $text .=  "\n" . $line;
      $found_space = 1;
    } else {
      if ($in_ul and (length($line) == 0)) {
        $in_ul = 0;
        $text .=  "</ul>\n";
      } elsif ($in_ol and (length($line) == 0)) {
        $in_ol = 0;
        $text .=  "</ol>\n";
      }
      if (($line =~ /<pre>/) or ($line =~ /<div class="code">/)) {
        $in_pre = 1;
        $line =~ s/<div class="code">/<pre>/;
      }
      if (length($line) == 0) {
        $text .= "\n\n";
        $found_space = 1;
      } else {
        if ($line =~ /<\/div>/) {
          if ($in_ul) {
            $text .= "</ul>" . $line;
            $in_ul = 0;
          } elsif ($in_ol) {
            $text .= "</ol>" . $line;
            $in_ol = 0;
          } else {
            $text .= "\n" . $line;
          }
          $found_space = 0;
        } elsif ($found_space) {
          $text .= $line;
          $found_space = 0;
        } else {
          $text .= " " . $line;
        }
      }
    }
  }
}
if ($in_ul) {
  $text .=  "</ul>";
}
$text =~ s/<div class="ref">/BEGREF/g; # this is hack ...
$text =~ s/<\/div>/ENDREF/g; # this is hack ...
$text =~ s/\t/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/g; # this is hack ...
$text =~ s/\[\[([^!]*!.*?)\]\]/BEGQUOTE$1ENDQUOTE/g; # not actually but for simplicity ... think later ...
$text =~ s/BEGQUOTE([^!]*?)ENDQUOTE/[[$1]]/g; # not actually but for simplicity ... think later ...
$text =~ s/BEGQUOTE(.*?)!([^!]*)ENDQUOTE/<a href=$2>$1<\/a>/g; # not actually but for simplicity ... think later ...
$text =~ s/BEGREF[ \n]*/\n<blockquote>/g; # hack ... think later ...
$text =~ s/BEGREF-/\n<blockquote>-/g; # hack ... think later ...
$text =~ s/ ENDREF/<\/blockquote>\n/g; # hack ... think later ...
$text =~ s/\n*ENDREF/<\/blockquote>\n/g; # hack ... think later ...
$text =~ s/<br[ ]*\/>/<br>/g; # hack ... think later ...
$text =~ s/\n\n\n*/\n\n/g; # hack ... think later ...
$text =~ s/\n\n(<[uo]l>)/\n$1/g; # hack ... think later ...
print $outfilehandle $text;
$count += length($text);
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
