# File: TextWithChapters2Pat_Perl.pl
# Date            Author        number of nodes
# 2002/8/17       Walking Lint  39
# 2002/8/17       Walking Lint  2 (Gutenberg2Pat_Perl->TextWithChapters2Pat_Perl)

=pod

=head1 NAME

TextWithChapters2Pat_Perl.pl - eLXg͕ .pat 

=head1 DESCRIPTION

ex. perl.exe TextWithChapters2Pat_Perl.pl E:\TEXTS\ETEXT95\Study10.txt C:\MEMO\CV\gutenberg\StudyOfStarlet.pat "^CHAPTER "

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
$from_file = shift;
$to_file = shift;
$separator = shift;
print STDERR '/' . $separator . "/\n";
$basename = basename($to_file);
$basename =~ s/\.[a-zA-Z0-9]+$//;
open IN, $from_file || die("Can't open $from_file: $!\n");
open OUT, ">$to_file";
print OUT <<END;
root ()
	$basename ()
END
$line = '';
$first = 1;
while (<IN>) {
  chop $_;
  if (/$separator/) {
    print OUT <<END;
\t\t_text () //  %% $line
END
    $line = $_;
  } else {
    if ($first) {
      $first = 0;
      $line = $_;
    } else {
      $line = $line . " \CRLF " . $_;
    }
  }
}
print OUT <<END;
\t\t_text () //  %% $line
END
$line = $_;
close IN;
close OUT;
