# File: TimeClient_Perl.pl
# Date            Author        number of nodes
# 2002/11/4       Walking Lint  16
# 2002/10/14      Walking Lint  12
# 2002/10/14      Walking Lint  21 (AutoBackup->TimeClient_Perl)
# 2002/10/14      Walking Lint  21 (TimeClient_Perl->AutoBackup)
use IO::Socket;

=pod

=head1 NAME

TimeClient_Perl.pl - Client which ask ServerTime

=head1 DESCRIPTION

ex. perl.exe TimeClient_Perl.pl localhost

=head1 AUTHOR

Walking Lint

=cut

$hostname = shift;
DebugPrint("hostname = $hostname");
$client_sock = new IO::Socket::INET (PeerAddr => $hostname, PeerPort => 2345, Proto => 'tcp');
unless ($client_sock) {
  die "Cannot connect to server $hostname: $!";
}
$time = <$client_sock>;
print "Server time is $time\n";
$client_sock->close();
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
