root () //  %% File: ToDo_Perl.pl CRLF Date            Author        number of nodes CRLF 2003/3/30       Walking Lint  110 CRLF 2003/3/29       Walking Lint  108 CRLF 2003/3/8        Walking Lint  104 CRLF 2003/3/7        Walking Lint  104 CRLF 2003/3/5        Walking Lint  112 CRLF 2002/12/13      Walking Lint  126 (GenToDo_Perl->ToDo_Perl) CRLF 2002/11/19      Walking Lint  93 CRLF 2002/10/16      Walking Lint  86 (GenToDoList_Perl->GenToDo_Perl) CRLF 2002/10/15      Walking Lint  115 (GenToDoList_Perl->GenToDoList_Perl) CRLF 2002/10/15      Walking Lint  81 (GenToDoList_Perl->GenToDoList_Perl) CRLF 2002/9/21       Walking Lint  168 CRLF 2002/8/31       Walking Lint  156
	_doc ()
		NAME () //  %% ToDo_Perl.pl - generate ToDo
		DESCRIPTION () //  %% ex. perl.exe ToDo_Perl.pl
		AUTHOR () //  %% [[Author]]
	use () // lib '.'
	use () // CVTree_Perl
	use () // Time::localtime
	use () // File::Copy
	use () // Win32::File
	$templatesfolder (out) //   $ENV{TEMPLATESFOLDER}
	$templatesfolder (inout) // =~ s/"//g
	$todo_body (out) //   'Memo2.pat'
	$todo_file (out) //   $templatesfolder . "\\" . $todo_body
	$tofile (out) //   $todo_file
	$tofile (inout) // =~ s/\.pat$/.html/
	DebugPrint () // "todo_file = $todo_file"
	$weblogfolder (out) //   $ENV{WEBLOGFOLDER}
	$weblogfolder (inout) // =~ s/"//g
	$todo (out) //   $weblogfolder . '\ToDo.html'
	DebugPrint () // "todo = $todo"
	$Title (out) //   'items to be done'
	$skip_generating_file (out) //   shift
	if () // defined($skip_generating_file) and not ($skip_generating_file =~ /\.pat$/) %% generate file if activated from file menu
		if () // -e $todo
			@stat (out) //   stat($todo)
			$tm (out) //   localtime($stat[9])
			$dateandtime (out) //   sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec)
			<<END (in) //  %% <a href="ToDo.html">$Title</a><small> CRLF <div class="lastupdate">($dateandtime)</div></small>
			print ()
		else ()
			<<END (in) //  %% <a href="ToDo.html">$Title</a>
			print ()
		exit ()
	_ () //  %% set other parameters
		$ParentTitle (out) //   'Revenge of My Two Cents'
		DebugPrint () // "ParentTitle = $ParentTitle"
		$ParentURL (out) //   'index.html'
		DebugPrint () // "ParentURL = $ParentURL"
		$link_file_body (out) //   '2ColumnForSubPage.css'
		$copyright_file (out) //   $weblogfolder . '\copyright.html'
		open () // IN, $copyright_file || die("Cannot open $copyright_file: $!\n")
		@copyrights (out) //   <IN>
		close () // IN
		$copyright (out) //   join('', @copyrights)
		DebugPrint () // "copyright = $copyright"
	$tm (out) //   localtime
	$dateandtime (out) //   sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec)
	<<END (in) //  %% <a href="ToDo.html">$Title</a><small> CRLF <div class="lastupdate">($dateandtime)</div></small>
	print ()
	$root (out) // my  {}
	&initnode () // $root, 'root', '', '', ''
	&gentree () // $root, $todo_file
	my $first (out) //   1
	open () // OUT, ">$todo"
	_note () // commented out (2003/3/7)
		<<END (in) //  %% <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN"> CRLF <html> CRLF <head> CRLF <title>$Title</title> CRLF <meta http-equiv="content-type" content="text/html;charset=Shift_JIS" /> CRLF <meta http-equiv="content-style-type" content="text/css" /> CRLF <link rel="stylesheet" type="text/css" href="$link_file_body" /> CRLF </head> CRLF <body> CRLF <table class="navi"><tr><td class="path"><a href="$ParentURL">$ParentTitle</a> > $Title</td></tr></table> CRLF <div class="lastupdate">Last update: $dateandtime</div> CRLF <h3>items to be done</h3>
	<<END (in) //  %% <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN"> CRLF <html> CRLF <head> CRLF <title>$Title</title> CRLF <meta http-equiv="content-type" content="text/html;charset=Shift_JIS" /> CRLF <meta http-equiv="content-style-type" content="text/css" /> CRLF <link rel="stylesheet" type="text/css" href="$link_file_body" /> CRLF </head> CRLF <body> CRLF <table class="navi"><tr><td class="path"><a href="$ParentURL">$ParentTitle</a> > $Title</td></tr></table> CRLF <h3>items to be done</h3>
	print () // OUT
	$counter (out) //   1
	&gentodo () // $root, 1
	<<END (in) //  %% $copyright CRLF </body> CRLF </html>
	print () // OUT
	close () // OUT
	copy () // $todo, $tofile
	DebugPrint () // "generated $todo"
	DebugPrint () // "generated $tofile"
	_note () // commented out (2002/8/31)
		&printtree () // $root, '  '
	gentodo ()
		$nd (in) &
		$level (in) &
		if () // defined($nd->{CHILD})
			<<END (in) //  %% <ol>
			print () // OUT
			$cn (out) // my  $nd->{CHILD}
			while () // 1
				if () // ($cn->{NAME} eq '_note') or ($cn->{NAME} eq '_presave') or ($cn->{NAME} eq '_script')
				else ()
					$text (out) //   $cn->{TEXT}
					$text (inout) // =~ s/( \CRLF )+/ /g
					if () // length($text) != 0
						$text (out) //   ' - ' . $text
					else ()
						$text (out) //   ''
					$text (inout) // =~s/&/&amp;/g
					$text (inout) // =~s/</&lt;/g
					$text (inout) // =~s/>/&gt;/g
					if () // $cn->{KIND} =~ /\(\) \+/
						_note () // commented out (2003/3/5)
							<<END (in) //  %% <h$level><img src="CheckedNode.jpg"/> $cn->{NAME}$text</h$level>
						<<END (in) //  %% <li><strike>$cn->{NAME}$text</strike></li>
						print () // OUT
					else ()
						_note () // commented out (2003/3/5)
							<<END (in) //  %% <h$level><img src="NotCheckedNode.jpg"/> $cn->{NAME}$text</h$level>
						<<END (in) //  %% <li>$cn->{NAME}$text</li>
						print () // OUT
					if () // defined($cn->{CHILD})
						&gentodo () // $cn, $level + 1
				if () // not defined($cn->{NEXT})
					last ()
				$cn (out) //   $cn->{NEXT}
			<<END (in) //  %% </ol>
			print () // OUT
	DebugPrint ()
		$str (in) &
		print () // STDERR $str . "\n"
	Trace ()
		$str (in) &
		print () // STDERR $str . "\n"
