# File: UpdateScriptsForThisMonth_Perl.pl
# Date            Author        number of nodes
# 2002/10/18      Walking Lint  35
# 2002/10/18      Walking Lint  66 (GenIndexForThisMonth_Perl->UpdateScriptsForThisMonth_Perl)
# 2002/10/17      Walking Lint  66 (GenIndex_Perl->GenIndexForThisMonth_Perl)
# 2002/10/16      Walking Lint  64 (UpdateScriptsForThisMonth_Perl->GenIndex_Perl)
# 2002/10/11      Walking Lint  178 (UpdateScriptsForThisMonth_Perl->UpdateScriptsForThisMonth_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (UpdateScriptsForThisMonthNew_Perl->UpdateScriptsForThisMonth_Perl)
# 2002/9/21       Walking Lint  109 (UpdateScriptsForThisMonth_Perl->UpdateScriptsForThisMonthNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

UpdateScriptsForThisMonth_Perl.pl - update scripts for this month ... this is temporary hack ...

=head1 DESCRIPTION

ex. perl.exe UpdateScriptsForThisMonth_Perl.pl "F:\200208.pat"

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
$currentfile = shift;
DebugPrint("currentfile = $currentfile");
$basename = basename($currentfile);
$basename =~ s/\..*$//;
DebugPrint("basename = $basename");
$templatesdir = 'D:\common\cv\templates';
&updatescript($templatesdir . "\\" . 'GenIndexForThisMonth_Perl.pat', $basename);
&updatescript($templatesdir . "\\" . 'GenIndexForThisMonth_Perl.pl', $basename);
&updatescript($templatesdir . "\\" . 'GenRSSForThisMonth_Perl.pat', $basename);
&updatescript($templatesdir . "\\" . 'GenRSSForThisMonth_Perl.pl', $basename);
&updatescript($templatesdir . "\\" . 'GenRSSForThisMonth_Perl.pl', $basename);
sub updatescript {
  my($from_file) = @_;
  open IN, $from_file || die("Can't open $from_file: $!\n");
  my $line = '';
  while (<IN>) {
    if (/update here/) {
      $_ =~ s/20[0-9]{4}/$basename/;
    }
    $line .= $_;
  }
  close IN;
  open OUT, ">$from_file";
  print OUT $line;
  close OUT;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
