//
// File: Wing_C_LSL.lsl
// Date            Author        number of nodes
// 2007/9/29       walkinglint   24
// 2007/9/29       walkinglint   24 (Wing_C->Wing_C_LSL)
// 2007/9/9        walkinglint   24
// 2007/9/7        walkinglint   12
// 2007/9/7        walkinglint   32 (Wing_R->Wing_C)
// 2007/9/5        walkinglint   32
// 2007/9/5        walkinglint   15 (Wing->Wing_R)
// 2007/9/2        walkinglint   15
//
integer is_open = FALSE;
integer is_flying = FALSE;
integer wing_channel = 283;
string id_str;
default {
    state_entry() {
        llSetTimerEvent(1.0);
        id_str = llGetOwner();
    }
    timer() {
        integer status = llGetAgentInfo(llGetOwner());
        if (status & AGENT_FLYING) {
            if (is_flying == FALSE) {
                llSay(wing_channel, id_str + "visible");
                is_flying = TRUE;
            }
            if (is_open == FALSE) {
                is_open = TRUE;
                llSay(wing_channel, id_str + "open");
            } else {
                is_open = FALSE;
                llSay(wing_channel, id_str + "close");
            }
        } else {
            if (is_flying == TRUE) {
                llSay(wing_channel, id_str + "invisible");
                is_flying = FALSE;
            }
        }
    }
}
