//
// File: Wing_L_LSL.lsl
// Date            Author        number of nodes
// 2007/9/29       walkinglint   41
// 2007/9/29       walkinglint   41 (Wing_L->Wing_L_LSL)
// 2007/9/10       walkinglint   41
// 2007/9/9        walkinglint   34
// 2007/9/7        walkinglint   22
// 2007/9/7        walkinglint   18 (Wing_R->Wing_L)
// 2007/9/7        walkinglint   18
// 2007/9/5        walkinglint   32
// 2007/9/5        walkinglint   15 (Wing->Wing_R)
// 2007/9/2        walkinglint   15
//
rotation open_rot;
rotation close_rot;
integer is_open = FALSE;
integer wing_channel = 283;
string id_str;
string open_str;
string close_str;
string visible_str;
string invisible_str;
default {
    state_entry() {
        close_rot = llEuler2Rot(<199.25 * DEG_TO_RAD, 74.55 * DEG_TO_RAD, 157.30 * DEG_TO_RAD>);
        open_rot = llEuler2Rot(<107.45 * DEG_TO_RAD, 32.95 * DEG_TO_RAD, 257.45 * DEG_TO_RAD>);
        id_str = llGetOwner();
        open_str = id_str + "open";
        close_str = id_str + "close";
        visible_str = id_str + "visible";
        invisible_str = id_str + "invisible";
        llListen(wing_channel, "", "", "");
    }
    attach(key avid) {
        integer status = llGetAgentInfo(llGetOwner());
        if (status & AGENT_FLYING) {
            llSetLinkAlpha(LINK_SET, 1.0, ALL_SIDES);
        } else {
            llSetLinkAlpha(LINK_SET, 0.0, ALL_SIDES);
        }
    }
    listen(integer channel, string name, key id_str, string message) {
        if (message == open_str) {
            llSetLocalRot(open_rot);
        } else if (message == close_str) {
            llSetLocalRot(close_rot);
        } else if (message == visible_str) {
            llSetLinkAlpha(LINK_SET, 1.0, ALL_SIDES);
        } else if (message == invisible_str) {
            llSetLinkAlpha(LINK_SET, 0.0, ALL_SIDES);
        }
    }
}
