# File: XmlReader_Python.py
# Date            Author        number of nodes
# 2003/4/7        Walking Lint  115
# 2003/3/30       Walking Lint  87
# 2002/11/13      Walking Lint  90
# 2002/11/12      Walking Lint  86
# 2002/11/10      Walking Lint  72
# 2002/11/10      Walking Lint  13 (dom_from_xml_file->XmlReader_Python)

# NAME

# XmlReader_Python.pl - XML reader

# DESCRIPTION

# activate as plug-in or filter shift-jis is not supported ...

# AUTHOR

# Walking Lint

from xml.dom import ext
from xml.dom import Node
from xml.dom.ext.reader import PyExpat
from CVTree_Python import *
def DebugPrint(str):
  sys.stderr.write(str + "\n")
def gentreefromdombody(nd, domnd):
  domcn = domnd.firstChild
  while domcn != None:
    name = domcn.nodeName
    if (domcn.attributes != None): # and (domcn.nodeType == Node.ELEMENT_NODE)
      items = []
      for key in domcn.attributes.keys():
        items.append(domcn.attributes[key].nodeName + '="' + domcn.attributes[key].nodeValue + '"')
      type = string.join(items, " ")
    else:
      type = ''
    if name == '#comment':
      name = '_'
    elif name == '#document':
      name = '?xml'
    elif name == '#text':
      name = '_text'
    if name == '_text':
      text = domcn.nodeValue
      text = re.sub("[ \t\n]+$", '', text)
      text = re.sub("^[ \t\n]+", '', text)
      if len(text) != 0:
        text = re.sub("\n", " " + "CRLF ", text)
        nd['TEXT'] = text # think later ...
    else:
      text = ''
      if domcn.nodeValue != None:
        text = domcn.nodeValue
        text = re.sub("[ \t\n]+$", '', text)
        text = re.sub("^[ \t\n]+", '', text)
        text = re.sub("\n", " " + "CRLF ", text)
      cn = addchildnode(nd, name, '', type, text)
      gentreefromdombody(cn, domcn)
    if domcn.nodeType == 10:
      delnd = cn
    domcn = domcn.nextSibling
def gentreefromdom(nd, domnd):
  name = domnd.nodeName
  if name == '#document':
    name = '?xml'
  if (domnd.attributes != None): # and (domnd.nodeType == Node.ELEMENT_NODE)
    items = []
    for key in domnd.attributes.keys():
      items.append(domnd.attributes[key].nodeName + '="' + domnd.attributes[key].nodeValue + '"')
    type = string.join(items, " ")
  else:
    type = ''
  text = ''
  if domnd.nodeValue != None:
    text = domcn.nodeValue
  cn = addchildnode(nd, name, '', type, text)
  gentreefromdombody(cn, domnd)
import sys, os
used_as_plugin = 0
if len(sys.argv) > 1:
  used_as_plugin = 1
  infile = sys.argv[1]
  outfile = infile
  outfile = re.sub("\..+$", ".pat", outfile)
else:
  # lines from stdin to XmlReader_Python.tmp
  infile = os.environ['TEMPLATESFOLDER'] + '\XmlReader_Python.tmp'
  infile = infile.replace('"', '')
  outfile = '' # hack ???
  outfd = open(infile, 'w')
  for line in sys.stdin:
    outfd.write(line)
  outfd.close
reader = PyExpat.Reader()
dom = reader.fromUri(infile)
# generate .pat here ... think later ...
root = {}
delnd = {}
initnode(root, 'root', '', '', '')
gentreefromdom(root, dom)
delnd['PARENT']['CHILD'] = delnd['NEXT'] # this is hack ...
savetree(root, outfile)
reader.releaseNode(dom)
