root () //  %% File: bintree_Perl.pl CRLF Date            Author        number of nodes CRLF 2002/7/24       Walking Lint  73
	_ () // %% !/usr/bin/perl -w  CRLF bintree - binary tree demo program 
	use () // strict
	$root (out) // my
	$n (out) // my
	_ () // %% first generate 20 random inserts 
	while () // $n++ < 20
		insert () // $root, int (rand (1000))
	_ () // %% now dump out the tree all three ways 
	print () // "Pre order:  "
	pre_order () // $root
	print () // "\n"
	print () // "In order:   "
	in_order () // $root
	print () // "\n"
	print () // "Post order: "
	post_order () // $root
	print () // "\n"
	_ () // %% prompt until EOF 
	for () // print "Search? "; <>; print "Search? "
		chomp ()
		$found (out) // my  search($root, $_)
		if () // $found
			print () // "Found $_ at $found, $found->{VALUE}\n"
		else ()
			print () // "No $_ in tree\n"
	exit ()
	_ () // %% ######################################## 
	_ () // %%  insert given value into proper point of  CRLF provided tree.  If no tree provided,   CRLF use implicit pass by reference aspect of @_  CRLF to fill one in for our caller. 
	insert ()
		_text () //  %% my($tree, $value) = @_;
		unless () // $tree
			$tree (out) //   {}
			_ () // %% allocate new node 
			$tree->{VALUE} (out) //   $value
			$tree->{LEFT} (out) //   undef 
			$tree->{RIGHT} (out) //   undef 
			$_[0] (out) //   $tree %% $_[0] is reference param! 
			return ()
		if () // $tree->{VALUE} > $value
			insert () // $tree->{LEFT}, $value
		elsif () // $tree->{VALUE} < $value
			insert () // $tree->{RIGHT}, $value
		else ()
			warn () // "dup insert of $value\n"
		_ () // %% XXX: no dups 
	_ () // %% recurse on left child,   CRLF then show current value,   CRLF then recurse on right child. 
	in_order ()
		_text () // %% my($tree) = @_;
		return () //  unless $tree
		in_order () // $tree->{LEFT}
		print () // $tree->{VALUE}, " "
		in_order () // $tree->{RIGHT}
	_ () // %% show current value,   CRLF then recurse on left child,   CRLF then recurse on right child. 
	pre_order ()
		_text () // %% my($tree) = @_;
		return () //  unless $tree
		print () // $tree->{VALUE}, " "
		pre_order () // $tree->{LEFT}
		pre_order () // $tree->{RIGHT}
	_ () // %% recurse on left child,   CRLF then recurse on right child,  CRLF then show current value.  
	post_order ()
		_text () // %% my($tree) = @_;
		return () //  unless $tree
		post_order () // $tree->{LEFT}
		post_order () // $tree->{RIGHT}
		print () // $tree->{VALUE}, " "
	_ () // %% find out whether provided value is in the tree.  CRLF if so, return the node at which the value was found.  CRLF cut down search time by only looking in the correct  CRLF branch, based on current value. 
	search ()
		_text () //  %% my($tree, $value) = @_;
		return () //  unless $tree
		if () // $tree->{VALUE} == $value
			return () // $tree
		search () // $tree->{ ($value < $tree->{VALUE}) ? "LEFT" : "RIGHT"}, $value
