# File: char_Perl.pl
# Date            Author        number of nodes
# 2003/3/20       Walking Lint  27
# 2003/3/20       Walking Lint  4 (test->char_Perl)
sub getcondandstmt {
  my($str) = @_;
  @chars = split(//, $str);
  $pre = '';
  $post = '';
  $level = 0;
  foreach $char (@chars) {
    if ($char eq '(') {
      $level++;
      if ($level > 1) {
        $pre .= $char;
      }
    } elsif ($char eq ')') {
      $level--;
      if ($level == 0) {
        last;
      } else {
        $pre .= $char;
      }
    } else {
      $pre .= $char;
    }
  }
  $post = substr($str, length($pre) + 2);
  return ($pre, $post);
}
($pre, $post) = &getcondandstmt(shift);
print "pre = $pre\n";
print "post = $post\n";
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
