# File: diffExcel_Ruby.rb
# Date            Author        number of nodes
# 2003/5/22       Walking Lint  35
# 2002/9/17       Walking Lint  35
# 2002/9/13       Walking Lint  48 (sedWordWithExcelForDevTech_Ruby->diffExcel_Ruby)
# 2002/7/18       Walking Lint  40
# 2002/7/17       Walking Lint  42
# 2002/7/17       Walking Lint  32 (sedWordWithFilterFileForDevTech_Ruby->sedWordWithExcelForDevTech_Ruby)
# 2002/7/17       Walking Lint  31 (sedWordWithFilterFile_Ruby->sedWordWithFilterFileForDevTech_Ruby)
# 2002/7/17       Walking Lint  21 (sedWord_Ruby->sedWordWithFilterFile_Ruby)
# 2002/7/17       Walking Lint  29 (grepWord_Ruby->sedWord_Ruby)

=begin

= NAME

diffExcel_Ruby.rb - diff Excel files

= DESCRIPTION

ex. ruby diffExcel_Ruby.rb "F:\w\200210\Bo^̔僁[ꗗ\yʎ-2z.xls" "F:\w\200207\Bo^̔僁[ꗗ\yʎ-2z200207.xls"

= AUTHOR

Walking Lint

=end

require "win32ole"
def DebugPrint(str)
  $stderr.print(str + "\n")
end
excelfile, excelfile2 = ARGV
DebugPrint("excelfile = " + excelfile)
DebugPrint("excelfile2 = " + excelfile2)
excel = WIN32OLE.new('Excel.Application')
ebook = excel.workbooks.open(excelfile)
ebook2 = excel.workbooks.open(excelfile2)
area = ebook.activeSheet.usedRange
area2 = ebook2.activeSheet.usedRange
trans = {}
def begin
  def for
    row = area.rows(rowIndex)
    row2 = area2.rows(rowIndex)
    def for # should parameterize ... think later ...
      column = row.cells(1, columnIndex)
      column2 = row2.cells(1, columnIndex)
      def if
        print "#{('A'[0] + columnIndex - 1).chr}#{rowIndex + 1} - #{column2.value} -> #{column.value}\n"    # see [[Strings!http://pleac.sourceforge.net/pleac_ruby/strings.html]]
      end
    end
  end
ensure
  ebook.close
  ebook2.close
end
excel.quit
