# File: find_Perl.pl
# Date            Author        number of nodes
# 2002/12/20      Walking Lint  39
# 2002/12/20      Walking Lint  40 (findrecursively_Perl->find_Perl)
# 2002/12/8       Walking Lint  21 (find_Perl->findrecursively_Perl)
# 2002/8/13       Walking Lint  19
# 2002/7/15       Walking Lint  19
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (find2_Perl->find_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (find_Perl->find2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

find_Perl.pl - find files under the dir

=head1 DESCRIPTION

ex. perl.exe find_Perl.pl anydbm D:\Python22\pythoncb-examples

=head1 AUTHOR

Walking Lint

=cut

# changed not to use find module which seems sometimes not reliable ...
use File::Basename;
use Cwd;
$str = shift;
$from = shift;
if (-d $from) {
  $from =~ s/\\$//;
  $from .= '\*';
}
&finddirectory($str, $from);
sub finddirectory {
  my($str, $from) = @_;
  my @dirs = ();
  $dir = dirname($from);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  foreach $from_file (@from_files) {
    $from_file = $dir . "\\" . $from_file;
    if (-d $from_file) {
      push @dirs, $from_file;
    } else {
      if ($from_file =~ /$str/) {
        print "$from_file\n";
      }
    }
  }
  foreach $dir (@dirs) {
    &finddirectory($str, $dir . '\*');
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
