# File: find_Perl.pl
# Date            Author        number of nodes
# 2002/12/23      Walking Lint  22
# 2002/12/20      Walking Lint  21
# 2002/12/20      Walking Lint  21 (find2_Perl->find_Perl)
# 2002/12/20      Walking Lint  46 (ChangeURL_Perl->find2_Perl)
# 2002/12/6       Walking Lint  46
# 2001/8/15       Walking Lint  17 (Filter3_Perl->ChangeURL_Perl)

=pod

=head1 NAME

find_Perl.pl - change URL

=head1 DESCRIPTION

ex. perl.exe find_Perl.pl test D:\test

=head1 AUTHOR

Walking Lint

=cut

use strict;
use Cwd;
use File::Find;
my $str = shift;
DebugPrint("str = $str");
my $dir = shift;
DebugPrint("dir = $dir");
find(\&check_file, $dir);
sub check_file {
  my $file_to_check = $_;
  if ($file_to_check =~ /$str/) {
    my $file = cwd . "/$file_to_check";
    print "$file\n";
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
