//
// File: follower_pet_LSL.lsl
// Date            Author        number of nodes
// 2007/9/29       walkinglint   19
// 2007/9/29       walkinglint   19 (follower_pet->follower_pet_LSL)
// 2007/8/5        walkinglint   19
// 2007/8/3        Walking Lint  18
// 2007/8/3
//
//
// ================================ 
// Faily Script
// (C) 20070325 oitake
// ================================ ;
//
// http://oitake.jugem.jp/?eid=118
key owner;
default {
    state_entry() {
        owner = llGetOwner();
        llSetTimerEvent(1.0);
        llParticleSystem
        ([
            PSYS_PART_FLAGS,PSYS_PART_EMISSIVE_MASK | PSYS_PART_INTERP_COLOR_MASK | PSYS_PART_INTERP_SCALE_MASK | PSYS_PART_WIND_MASK,
            PSYS_PART_MAX_AGE,1.0,
            PSYS_PART_START_ALPHA,1.0,
            PSYS_PART_END_ALPHA,0.0,
            PSYS_PART_START_COLOR,<1.0,1.0,1.0>,
            PSYS_PART_END_COLOR,<1.0,1.0,0.0>,
            PSYS_PART_START_SCALE,<0.125,0.125,0.125>,
            PSYS_PART_END_SCALE,<0.0,0.0,0.0>,
            PSYS_SRC_PATTERN,PSYS_SRC_PATTERN_EXPLODE,
            PSYS_SRC_ACCEL,<0.0,0.0,-1.0>,
            PSYS_SRC_BURST_RATE,0.0,
            PSYS_SRC_BURST_PART_COUNT,1,
            PSYS_SRC_BURST_RADIUS,0.0,
            PSYS_SRC_BURST_SPEED_MIN,0.1,
            PSYS_SRC_BURST_SPEED_MAX,0.2,
            PSYS_SRC_MAX_AGE,0.0,
            PSYS_SRC_INNERANGLE,0.0,
            PSYS_SRC_OUTERANGLE,PI,
            PSYS_SRC_TEXTURE,"Kirameki"
        ]);
    }
    on_rez(integer param) {
        llResetScript();
    }
    timer() {
        llSensor("", owner, AGENT, 96.0, PI);
    }
    sensor(integer num_detected) {
        vector left = llRot2Left(llDetectedRot(0));
        llMoveToTarget(llDetectedPos(0) + left * 0.5 + <0.0, 0.0, 1.0>, 0.75);
    }
    no_sensor() {
        llDie();
    }
}
