# File: grepWord_Ruby.rb
# Date            Author        number of nodes
# 2002/8/22       Walking Lint  42
# 2002/7/17       Walking Lint  29

=begin

= NAME

grepWord_Ruby.rb - grep str in Word files

= DESCRIPTION

ex. D:\ruby\bin\ruby.exe grepWord_Ruby.rb r[ D:/common/cv/test/*.doc

= AUTHOR

Walking Lint

=end

require "win32ole"
def DebugPrint(str)
  $stderr.print(str + "\n")
end
str, files = ARGV   # maybe you should use / to separate path instead of \
pattern = /#{str}/is
dirname = File.dirname(files)
basename = File.basename(files)
DebugPrint("basename = " + basename)
Dir.chdir(dirname)
wd = WIN32OLE.new("Word.Application")
Dir.glob(basename) do |file| 
  doc = dirname + '/' + file
  wdoc = wd.Documents.open(doc)
  first = true
  count = 1
  def for(sentence, wdoc.sentences)
    txt = sentence.text
    def if
      def if
        first = false
      end
      txt.strip!
      print "#{doc}:#{count} #{txt}\n"
    end
    count = count + 1
  end
  wdoc.close
end
wd.Quit
