root () //  %% File: hilbert3d_LSL.lsl CRLF Date            Author        number of nodes CRLF 2007/9/29       walkinglint   231 CRLF 2007/9/29       walkinglint   231 (hilbert3d->hilbert3d_LSL) CRLF 2007/9/23       walkinglint   231 CRLF 2007/9/23       walkinglint   80 (hilbert->hilbert3d) CRLF 2007/9/18       walkinglint   80 CRLF 2007/9/17       walkinglint   86 CRLF 2007/9/13       walkinglint   73 CRLF 2007/9/13
	_ () //  %% Courbe de Hilbert 3d CRLF http://www.mathcurve.com/fractals/hilbert3d/hilbert3d.shtml
	i (out) // integer
	level (out) // integer  2
	dist0 (out) // float  1.6
	_note () // commented out (2007/9/13)
		dist0 (out) // integer  512
	dist (out) // float
	cur (out) // vector
	init_pos (out) // vector  <-0.6, 1.0, -0.6>
	_ () //  %% not actually hilbertD may be currect though
	_note () // commented out (2007/9/23)
		hilbertA ()
			level (in) & // integer
			if () // level > 0
				llOwnerSay () // "A" + " level = " + (string)level
				hilbertD () // level - 1
				lineRel () // <dist, 0, 0>
				hilbertH () // level - 1
				lineRel () // <0, dist, 0>
				hilbertD () // level - 1
				lineRel () // <-dist, 0, 0>
				hilbertH () // level - 1
	hilbertA ()
		level (in) & // integer
		if () // level > 0
			_note () // commented out (2007/9/23)
				llOwnerSay () // "A" + " level = " + (string)level
			lineRel () // <0, 0, dist>
			lineRel () // <dist, 0, 0>
			lineRel () // <0, 0, -dist>
			lineRel () // <0, dist, 0>
			lineRel () // <0, 0, dist>
			lineRel () // <-dist, 0, 0>
			lineRel () // <0, 0, -dist>
	_note () // commented out (2007/9/23)
		hilbertB ()
			level (in) & // integer
			if () // level > 0
				llOwnerSay () // "B" + " level = " + (string)level
				hilbertA () // level - 1
				lineRel () // <0, 0, dist>
				hilbertC () // level - 1
				lineRel () // <dist, 0, 0>
				hilbertA () // level - 1
				lineRel () // <0, 0, -dist>
				hilbertC () // level - 1
	hilbertB ()
		level (in) & // integer
		if () // level > 0
			_note () // commented out (2007/9/23)
				llOwnerSay () // "B" + " level = " + (string)level
			lineRel () // <0, dist, 0>
			lineRel () // <0, 0, dist>
			lineRel () // <0, -dist, 0>
			lineRel () // <dist, 0, 0>
			lineRel () // <0, dist, 0>
			lineRel () // <0, 0, -dist>
			lineRel () // <0, -dist, 0>
	_note () // commented out (2007/9/23)
		hilbertC ()
			level (in) & // integer
			if () // level > 0
				llOwnerSay () // "C" + " level = " + (string)level
				hilbertB () // level - 1
				lineRel () // <0, 0, -dist>
				hilbertF () // level - 1
				lineRel () // <0, -dist, 0>
				hilbertB () // level - 1
				lineRel () // <0, 0, dist>
				hilbertF () // level - 1
	hilbertC ()
		level (in) & // integer
		if () // level > 0
			_note () // commented out (2007/9/23)
				llOwnerSay () // "C" + " level = " + (string)level
			lineRel () // <dist, 0, 0>
			lineRel () // <0, 0, -dist>
			lineRel () // <-dist, 0, 0>
			lineRel () // <0, -dist, 0>
			lineRel () // <dist, 0, 0>
			lineRel () // <0, 0, dist>
			lineRel () // <-dist, 0, 0>
	_note () // commented out (2007/9/23)
		hilbertD ()
			level (in) & // integer
			if () // level > 0
				llOwnerSay () // "D"
				hilbertA () // level - 1
				lineRel () // <dist, 0, 0>
				hilbertC () // level - 1
				lineRel () // <0, 0, dist>
				hilbertE () // level - 1
				lineRel () // <-dist, 0, 0>
				hilbertG () // level - 1
	hilbertD ()
		level (in) & // integer
		if () // level > 0
			_note () // commented out (2007/9/23)
				llOwnerSay () // "D" + " level = " + (string)level
			hilbertA () // level - 1
			lineRel () // <0, dist, 0>
			hilbertB () // level - 1
			lineRel () // <dist, 0, 0>
			hilbertD () // level - 1
			lineRel () // <0, -dist, 0>
			hilbertC () // level - 1
			lineRel () // <0, 0, dist>
			hilbertA () // level - 1
			lineRel () // <0, dist, 0>
			hilbertD () // level - 1
			lineRel () // <-dist, 0, 0>
			hilbertF () // level - 1
			lineRel () // <0, -dist, 0>
			hilbertG () // level - 1
	_note () // commented out (2007/9/23)
		hilbertE ()
			level (in) & // integer
			if () // level > 0
				llOwnerSay () // "E" + " level = " + (string)level
				hilbertB () // level - 1
				lineRel () // <0, 0, dist>
				hilbertF () // level - 1
				lineRel () // <0, dist, 0>
				hilbertB () // level - 1
				lineRel () // <0, 0, -dist>
				hilbertF () // level - 1
	hilbertE ()
		level (in) & // integer
		if () // level > 0
			_note () // commented out (2007/9/23)
				llOwnerSay () // "E" + " level = " + (string)level
			lineRel () // <dist, 0, 0>
			lineRel () // <0, 0, dist>
			lineRel () // <-dist, 0, 0>
			lineRel () // <0, dist, 0>
			lineRel () // <dist, 0, 0>
			lineRel () // <0, 0, -dist>
			lineRel () // <-dist, 0, 0>
	_note () // commented out (2007/9/23)
		hilbertF ()
			level (in) & // integer
			if () // level > 0
				llOwnerSay () // "F" + " level = " + (string)level
				hilbertA () // level - 1
				lineRel () // <0, 0, -dist>
				hilbertC () // level - 1
				lineRel () // <-dist, 0, 0>
				hilbertA () // level - 1
				lineRel () // <0, 0, dist>
				hilbertC () // level - 1
	hilbertF ()
		level (in) & // integer
		if () // level > 0
			_note () // commented out (2007/9/23)
				llOwnerSay () // "F" + " level = " + (string)level
			lineRel () // <0, dist, 0>
			lineRel () // <0, 0, -dist>
			lineRel () // <0, -dist, 0>
			lineRel () // <-dist, 0, 0>
			lineRel () // <0, dist, 0>
			lineRel () // <0, 0, dist>
			lineRel () // <0, -dist, 0>
	_note () // commented out (2007/9/23)
		hilbertG ()
			level (in) & // integer
			if () // level > 0
				llOwnerSay () // "G" + " level = " + (string)level
				hilbertH () // level - 1
				lineRel () // <dist, 0, 0>
				hilbertD () // level - 1
				lineRel () // <0, -dist, 0>
				hilbertH () // level - 1
				lineRel () // <-dist, 0, 0>
				hilbertD () // level - 1
	hilbertG ()
		level (in) & // integer
		if () // level > 0
			_note () // commented out (2007/9/23)
				llOwnerSay () // "G" + " level = " + (string)level
			lineRel () // <0, 0, -dist>
			lineRel () // <dist, 0, 0>
			lineRel () // <0, 0, dist>
			lineRel () // <0, -dist, 0>
			lineRel () // <0, 0, -dist>
			lineRel () // <-dist, 0, 0>
			lineRel () // <0, 0, dist>
	_note () // commented out (2007/9/23)
		hilbertH ()
			level (in) & // integer
			if () // level > 0
				llOwnerSay () // "H" + " level = " + (string)level
				hilbertC () // level - 1
				lineRel () // <dist, 0, 0>
				hilbertA () // level - 1
				lineRel () // <0, 0, -dist>
				hilbertC () // level - 1
				lineRel () // <-dist, 0, 0>
				hilbertA () // level - 1
	goToXY ()
		new (in) & // vector
		cur (out) //   new
	lineRel ()
		delta (in) & // vector
		_note () // commented out (2007/9/23)
			llOwnerSay () // (string)delta.x + " " + (string)delta.y + " " + (string)delta.z
		llRezObject () // "phy_bar3d", llGetPos() + <cur.x, cur.z, cur.y> + <delta.x, delta.z, delta.y> / 2, ZERO_VECTOR, ZERO_ROTATION, (integer)(llFabs(delta.x * 10) * 10000) + (integer)(llFabs(delta.y * 10) * 100) + (integer)llFabs(delta.z * 10)
		llSleep () // 0.05
		cur (inout) // += delta
	default ()
		state_entry ()
			llSetTimerEvent () // 59
		on_rez ()
			param (in) & // integer
			_note () // commented out (2007/9/23)
				llOwnerSay () // "START on rez"
			dist (out) //   dist0
			for () // i = level; i > 0; i--
				dist (inout) // /= 2
			goToXY () // init_pos
			hilbertD () // level %% start recursion
		_note () // commented out (2007/9/23)
			state_entry ()
				llOwnerSay () // "START on state_entry"
				dist (out) //   dist0
				for () // i = level; i > 0; i--
					dist (inout) // /= 2
				goToXY () // init_pos
				hilbertD () // level %% start recursion
		timer ()
			goToXY () // init_pos
			hilbertD () // level %% start recursion
