# File: ls_Perl.pl
# Date            Author        number of nodes
# 2003/3/20       Walking Lint  34
# 2003/2/13       Walking Lint  22
# 2002/9/23       Walking Lint  16
# 2002/4/28       Walking Lint  2

=pod

=head1 NAME

ls_Perl.pl - ls

=head1 DESCRIPTION

ex. perl.exe ls_Perl.pl "C:\memo\cv\templates\*_VRML.pat"

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Cwd;
$from = shift;
$dir = dirname($from);
$dir2 = &mydirname($from);
chdir $dir;
$from = basename($from);
@from_files = eval('<' . $from . '>');
@found_files = ();
foreach $from_file (@from_files) {
  push @found_files, "$dir2\\$from_file";
}
foreach $file (sort {lc($a) cmp lc($b)} @found_files) {
  print "$file\n";
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
