# File: mv_Perl.pl
# Date            Author        number of nodes
# 2003/6/19       Walking Lint  29
# 2003/6/19       Walking Lint  76 (sed_Perl->mv_Perl)
# 2002/12/10      Walking Lint  76
# 2002/11/23      Walking Lint  68
# 2002/10/3       Walking Lint  38
# 2002/9/6        Walking Lint  38
# 2002/7/16       Walking Lint  29
# 2002/7/15       Walking Lint  19 (grep_Perl->sed_Perl)
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

mv_Perl.pl - mv files

=head1 DESCRIPTION

ex. perl.exe mv_Perl.pl .c.txt .c D:\tmp\*.txt

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Cwd;
$from_str = quotemeta shift;
DebugPrint("from_str = $from_str");
$to_str = shift;
DebugPrint("to_str = $to_str");
$from = shift;
DebugPrint("from = $from");
if (length($from) != 0) {
  $dir = dirname($from);
  DebugPrint("dir = " . $dir);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  foreach $from_file (@from_files) {
    DebugPrint("from_file = $from_file");
    $to_file = $from_file;
    $to_file =~ s/$from_str$/$to_str/;
    DebugPrint("to_file = " . $to_file);
    rename $dir . "\\" . $from_file, $dir . "\\" . $to_file;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
