root () //  %% File: orient_HTML.html CRLF Date            Author        number of nodes CRLF 2003/3/20       Walking Lint  188
	!DOCTYPE () // HTML PUBLIC "-//W3C//DTD HTML 3.2//EN"
	_ () //  %% last modified on Saturday, May 22, 1999 09:58 AM
	html ()
		head ()
			meta () // HTTP-EQUIV="Content-Type" CONTENT="text/html;CHARSET=iso-8859-1"
			script () // LANGUAGE="JavaScript"
				_ () //  %% JavaScript version of 29 Oct 1997 by Kevin Laurent, klaurent@usgs.gov, CRLF U.S. Geological Survey, Reston, VA, based on the C version by Stephen Chenney. CRLF The Chenney copyright header appears below.
				_ () //  %% orient.c: Code to convert a from/at/up cmaera model to the orientation CRLF model used by VRML. CRLF Copyright (C) 1995  Stephen Chenney (schenney@cs.berkeley.edu) CRLF ** CRLF This program is free software; you can redistribute it and/or modify CRLF it under the terms of the GNU General Public License as published by CRLF the Free Software Foundation; either version 2 of the License, or CRLF (at your option) any later version. CRLF ** CRLF This program is distributed in the hope that it will be useful, CRLF but WITHOUT ANY WARRANTY; without even the implied warranty of CRLF MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the CRLF GNU General Public License for more details. CRLF ** CRLF You should have received a copy of the GNU General Public License CRLF along with this program; if not, write to the Free Software CRLF Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
				_ () //  %% Written by Stephen Chenney, October 1995. CRLF schenney@cs.berkeley.edu
				_ () //  %% As is this program prompts for a from vector, an at vector and an up CRLF vector, then calculates the orientation required to align the default CRLF VRML camera with the given camera. CRLF ** CRLF As a standalone program it does fine. CRLF You are welcome to incorporate it into any other program you write, and CRLF to modify it as required. However, it would be good if you left it all CRLF in one file, and left the GNU header at the top. You probably shouldn't CRLF sell it either.
				rotAxis, rotAngle (out) // var
				vMod ()
					return () // Math.sqrt(this.x * this.x + this.y * this.y + this.z * this.z)
				vDot ()
					v2 (in) &
					return () // this.x * v2.x + this.y * v2.y + this.z * v2.z
				vAdd ()
					v2 (in) &
					r (out) // var
					r (out) //   new Vector ((this.x + v2.x), (this.y + v2.y), (this.z + v2.z))
					return () // r
				vSub ()
					v2 (in) &
					r (out) // var
					r (out) //   new Vector ((this.x - v2.x), (this.y - v2.y), (this.z - v2.z))
					return () // r
				vCross ()
					v2 (in) &
					r (out) // var
					r (out) //   new Vector ((this.y * v2.z - this.z * v2.y), (this.z * v2.x - this.x * v2.z), (this.x * v2.y - this.y * v2.x))
					_ () //  %% alert("r(in vCross): "+r.x+" "+r.y+" "+r.z); // ***DEBUG
					return () // r
				vScalarMul ()
					d (in) &
					r (out) // var
					r (out) //   new Vector ((this.x * d), (this.y * d), (this.z * d))
					return () // r
				vUnit ()
					t, r (out) // var
					t (out) //   1.0/this.vMod()
					r (out) //   this.vScalarMul (t)
					return () // r
				Vector ()
					x (in) &
					y (in) &
					z (in) &
					this.x (out) //   x
					this.y (out) //   y
					this.z (out) //   z
					this.vAdd (out) //   vAdd
					this.vSub (out) //   vSub
					this.vCross (out) //   vCross
					this.vScalarMul (out) //   vScalarMul
					this.vUnit (out) //   vUnit
					this.vMod (out) //   vMod
					this.vDot (out) //   vDot
				QQMul ()
					q2 (in) &
					r, tempV (out) // var
					_ () //  %% alert("q2: "+q2.vectPart.x+" "+q2.vectPart.y+" "+q2.vectPart.z+" "+q2.realPart); // ***DEBUG
					r (out) //   new Quaternion (this.vectPart.vCross(q2.vectPart), (this.realPart * q2.realPart - this.vectPart.vDot(q2.vectPart)))
					tempV (out) //   this.vectPart.vScalarMul(q2.realPart)
					r.vectPart (out) //   tempV.vAdd(r.vectPart)
					_ () //  %% alert(r.vectPart.x+" "+r.vectPart.y+" "+r.vectPart.z+" "+r.realPart); // ***DEBUG
					tempV (out) //   q2.vectPart.vScalarMul(this.realPart)
					r.vectPart (out) //   tempV.vAdd(r.vectPart)
					return () // r
				toAxisAngle ()
					halfAngle, sinHalfAngle (out) // var
					halfAngle (out) //   Math.acos(this.realPart)
					sinHalfAngle (out) //   Math.sin(halfAngle)
					rotAngle (out) //   halfAngle * 2.0
					if () // (sinHalfAngle < 1e-8) && (sinHalfAngle > -1e-8)
						rotAxis (out) //   new Vector(1.0,0.0,0.0)
					else ()
						sinHalfAngle (out) //   1/sinHalfAngle
						rotAxis (out) //   this.vectPart.vScalarMul(sinHalfAngle)
				Quaternion ()
					vectPart (in) &
					realPart (in) &
					this.vectPart (out) //   vectPart
					this.realPart (out) //   realPart
					this.QQMul (out) //   QQMul
					this.toAxisAngle (out) //   toAxisAngle
				buildRotateQuaternion ()
					axis (in) &
					cosAngle (in) &
					angle (out) // var  0.0, sinHalfAngle = 0.0, cosHalfAngle = 0.0, r
					if () // cosAngle > 1.0
						cosAngle (out) //   1.0
					if () // cosAngle < -1.0
						cosAngle (out) //   -1.0
					angle (out) //   Math.acos(cosAngle)
					sinHalfAngle (out) //   Math.sin(angle/2.0)
					cosHalfAngle (out) //   Math.cos(angle/2.0)
					r (out) //   new Quaternion (axis.vScalarMul(sinHalfAngle), cosHalfAngle)
					return () // r
				convertCameraModel ()
					pos (in) &
					at (in) &
					up (in) &
					resAxis (in) &
					resAngle (in) &
					n, tempD, tempV, v, normAxis, normQuat, invNormQuat, yQuat, newYQuat, newY, rotYQuat, rotQuat (out) // var
					n (out) //   at.vSub(pos)
					n (out) //   n.vUnit()
					up (out) //   up.vUnit()
					tempD (out) //   up.vDot(n)
					tempV (out) //   n.vScalarMul(tempD)
					v (out) //   up.vSub(tempV)
					v (out) //   v.vUnit()
					normAxis (out) //   new Vector(n.y, -n.x, 0)
					if () // normAxis.vDot(normAxis) < 1e-8
						if () // n.z > 0.0
							normQuat (out) //   new Quaternion(new Vector(0.0,1.0,0.0), 1.0)
						else ()
							normQuat (out) //   new Quaternion(new Vector(0.0,0.0,0.0), 1.0)
					else ()
						normAxis (out) //   normAxis.vUnit()
						normQuat (out) //   buildRotateQuaternion(normAxis, -n.z)
					invNormQuat (out) //   new Quaternion(normQuat.vectPart.vScalarMul(-1),normQuat.realPart)
					yQuat (out) //   new Quaternion(new Vector(0.0,1.0,0.0),0.0)
					newYQuat (out) //   normQuat.QQMul(yQuat)
					newYQuat (out) //   newYQuat.QQMul(invNormQuat)
					newY (out) //   newYQuat.vectPart
					tempV (out) //   newY.vCross(v)
					if () // tempV.vDot(tempV) < 1e-8
						tempV (out) //   new Vector(0.0, -v.z, v.y)
						if () // tempV.vDot(tempV) < 1e-8
							tempV (out) //   new Vector(v.z, 0.0, -v.x)
					tempV (out) //   tempV.vUnit()
					_ () //  %% alert(tempV.x+" "+tempV.y+" "+tempV.z); // ***DEBUG
					rotYQuat (out) //   buildRotateQuaternion(tempV, newY.vDot(v))
					rotQuat (out) //   rotYQuat.QQMul(normQuat)
					rotQuat (out) // .toAxisAngle();
				calcView ()
					form (in) &
					_ () //  %% document.write ("With camera at "+form.cameraX.value+", "); CRLF document.writeln (form.cameraY.value+", "+form.cameraZ.value+"<P>");
					pos, at, up (out) // var
					pos (out) //   new Vector (eval(form.cameraX.value),eval(form.cameraY.value), eval(form.cameraZ.value))
					at (out) //   new Vector (eval(form.lookX.value),eval(form.lookY.value), eval(form.lookZ.value))
					up (out) //   new Vector (eval(form.upX.value),eval(form.upY.value), eval(form.upZ.value))
					rotAxis (out) //   new Vector(0.0,0.0,0.0)
					convertCameraModel () // pos, at, up, rotAxis, rotAngle
					form.orientation.value (out) //   "orientation " + rotAxis.x + " " + rotAxis.y + " " + rotAxis.z + " " + rotAngle
			meta () // NAME="GENERATOR" Content="Visual Page 2.0 for Windows"
			meta () // NAME="Author" Content="Kelly Crispen"
			title () //  %% Calculating VRML Viewpoints
		body () // BGCOLOR="white"
			form () // METHOD="POST" ENCTYPE="application/x-www-form-urlencoded" NAME="parms"
				p () // ALIGN="CENTER"
					font () // SIZE="5" FACE="Arial, Helvetica" %% Kevin Laurent's
					code ()
						font () // SIZE="5" FACE="Arial, Helvetica" %% &lt;
					font () // SIZE="5" FACE="Courier New, Courier" %% klaurent@usgs.gov
					code ()
						font () // SIZE="5" FACE="Arial, Helvetica" %% &gt;
					br ()
					_text () // JavaScript version of Steve Chenney's Orient
				p () //  %% Camera Location: (where are you)
				br ()
				_text () //  %% X
				input () // TYPE="TEXT" NAME="cameraX" SIZE="10"
				_text () //  %% Y
				input () // TYPE="TEXT" NAME="cameraY" SIZE="10"
				_text () //  %% Z
				input () // TYPE="TEXT" NAME="cameraZ" SIZE="10"
				p () //  %% Look At Vector: (coordinates of the object you want to look at)
				br ()
				_text () //  %% X
				input () // TYPE="TEXT" NAME="lookX" SIZE="10"
				_text () //  %% Y
				input () // TYPE="TEXT" NAME="lookY" SIZE="10"
				_text () //  %% Z
				input () // TYPE="TEXT" NAME="lookZ" SIZE="10"
				p () //  %% Look Up Vector: (usually 0 1 0)
				br ()
				_text () //  %% X
				input () // TYPE="TEXT" NAME="upX" SIZE="10" VALUE="0"
				_text () //  %% Y
				input () // TYPE="TEXT" NAME="upY" SIZE="10" VALUE="1"
				_text () //  %% Z
				input () // TYPE="TEXT" NAME="upZ" SIZE="10" VALUE="0"
				p ()
					input () // TYPE="button" VALUE="Calc Viewpoint" ONCLICK="calcView(this.form)"
				p () //  %% Viewpoint Orientation (calculated):
				br ()
				input () // TYPE="TEXT" NAME="orientation" SIZE="85"
