//
// File: phy_bar3d_LSL.lsl
// Date            Author        number of nodes
// 2007/9/29       walkinglint   21
// 2007/9/29       walkinglint   21 (phy_bar3d->phy_bar3d_LSL)
// 2007/9/23       walkinglint   21
// 2007/9/23       walkinglint   21 (bar3d->phy_bar3d)
// 2007/9/23       walkinglint   18
// 2007/9/23       walkinglint   18 (bar->bar3d)
// 2007/9/20       walkinglint   16
// 2007/9/20       walkinglint   16 (phy_bar->bar)
// 2007/9/20       walkinglint   19
// 2007/9/20       walkinglint   19 (bar->phy_bar)
// 2007/9/20       walkinglint   19
// 2007/9/17       walkinglint   16
//
vector scale;
default {
    on_rez(integer param) {
        llSetTimerEvent(50);
        integer x = param / 10000;
        integer tmp = param % 10000;
        integer y = tmp / 100;
        integer z = tmp % 100;
        scale = llGetScale();
        if (x != 0) {
            scale.x = (float)x / 10 + scale.x;
        }
        if (y != 0) {
            scale.z = (float)y / 10 + scale.z;
        }
        if (z != 0) {
            scale.y = (float)z / 10 + scale.y;
        }
        llSetScale(scale);
    }
    timer() {
        llSetStatus(STATUS_PHYSICS, TRUE);
    }
}
