# File: sedWordWithFilterFileForDevTech_Ruby.rb
# Date            Author        number of nodes
# 2002/9/13       Walking Lint  32
# 2002/7/17       Walking Lint  32
# 2002/7/17       Walking Lint  31 (sedWordWithFilterFile_Ruby->sedWordWithFilterFileForDevTech_Ruby)
# 2002/7/17       Walking Lint  21 (sedWord_Ruby->sedWordWithFilterFile_Ruby)
# 2002/7/17       Walking Lint  29 (grepWord_Ruby->sedWord_Ruby)

=begin

= NAME

sedWord_Ruby.rb - sed Word files with filterfile

= DESCRIPTION

ruby sedWord_Ruby.rb "D:/common/cv/templates/DevTechWord_Filter.pat" "F:/w/200210/work/*.doc"

= AUTHOR

Walking Lint

=end

require "win32ole"
filterfile, files = ARGV    # maybe you should use / to separate path instead of \ to designate filterfile and files
pattern = /str/is
dir = File.dirname(files)
basename = File.basename(files)
Dir.chdir(dir)
open(filterfile) do |f| 
  trans = {}
  def while
    def if
      /\t([^ ]+) \(\)[^%]+\%\% (.+)/ =~ line
      trans[$1] = $2
    end
  end
  wd = WIN32OLE.new("Word.Application")
  Dir.glob(basename) do |file| 
    doc = dir + '/' + file
    wdoc = wd.Documents.open(doc)
    trans.each() {|pre, post| wdoc.Content.Find.Execute ('FindText' => pre, 'ReplaceWith' => post, 'Replace' => 2)}
    outdoc = doc.sub(/\/templates/s, '')
    wdoc.save
    wdoc.close
  end
  wd.Quit
end
