root () //  %% File: sierpinski_LSL.lsl CRLF Date            Author        number of nodes CRLF 2007/9/29       walkinglint   107 CRLF 2007/9/29       walkinglint   107 (sierpinski->sierpinski_LSL) CRLF 2007/9/24       walkinglint   107 CRLF 2007/9/24       walkinglint   80 (hilbert->sierpinski) CRLF 2007/9/18       walkinglint   80 CRLF 2007/9/17       walkinglint   86 CRLF 2007/9/13       walkinglint   73 CRLF 2007/9/13
	_ () //  %% http://en.wikipedia.org/wiki/Sierpi%C5%84ski_curve
	i (out) // integer
	level (out) // integer  3
	dist0 (out) // float  0.8
	_note () // commented out (2007/9/13)
		dist0 (out) // integer  512
	dist (out) // float
	cur (out) // vector
	x_pos (out) // float  -1.6
	y_pos (out) // float  1.0
	sierpA ()
		level (in) & // integer
		if () // level > 0
			sierpA () // level - 1
			lineRel () // dist, dist
			sierpB () // level - 1
			lineRel () // 2 * dist, 0
			sierpD () // level - 1
			lineRel () // dist, -dist
			sierpA () // level - 1
	sierpB ()
		level (in) & // integer
		if () // level > 0
			sierpB () // level - 1
			lineRel () // -dist, dist
			sierpC () // level - 1
			lineRel () // 0, 2 * dist
			sierpA () // level - 1
			lineRel () // dist, dist
			sierpB () // level - 1
	sierpC ()
		level (in) & // integer
		if () // level > 0
			sierpC () // level - 1
			lineRel () // -dist, -dist
			sierpD () // level - 1
			lineRel () // -2 * dist, 0
			sierpB () // level - 1
			lineRel () // -dist, dist
			sierpC () // level - 1
	sierpD ()
		level (in) & // integer
		if () // level > 0
			sierpD () // level - 1
			lineRel () // dist, -dist
			sierpA () // level - 1
			lineRel () // 0, -2 * dist
			sierpC () // level - 1
			lineRel () // -dist, -dist
			sierpD () // level - 1
	goToXY ()
		x (in) & // float
		y (in) & // float
		cur.x (out) //   x
		cur.y (out) //   y
	lineRel ()
		deltaX (in) & // float
		deltaY (in) & // float
		is_minus (out) // integer  0
		_note () // commented out (2007/9/24)
			llOwnerSay () // (string)deltaX + " " + (string)deltaY
		_note () // commented out (2007/9/13)
			drawLine () // cur.x, cur.y, cur.x + (float)deltaX, cur.y + (float)deltaY
		if () // deltaX * deltaY < 0
			is_minus (out) //   1
			_note () // commented out (2007/9/24)
				llOwnerSay () // "minus"
		else ()
			is_minus (out) //   0
			_note () // commented out (2007/9/24)
				llOwnerSay () // "plus"
		llRezObject () // "phy_sierp_bar", llGetPos() + <cur.x + deltaX / 2, 0.0, cur.y + deltaY / 2>, ZERO_VECTOR, ZERO_ROTATION, is_minus * 10000 + (integer)(llFabs(deltaX * 10) * 100) + (integer)llFabs(deltaY * 10)
		llSleep () // 0.01
		cur.x (inout) // += deltaX
		cur.y (inout) // += deltaY
	default ()
		state_entry ()
			_note () // commented out (2007/9/24)
				llSetTimerEvent () // 59
			llSetTimerEvent () // 120
		on_rez ()
			param (in) & // integer
			dist (out) //   dist0
			for () // i = level; i > 0; i--
				dist (inout) // /= 2
			goToXY () // x_pos, y_pos
			sierpA () // level %% start recursion
			lineRel () // dist, dist
			sierpB () // level %% start recursion
			lineRel () // -dist, dist
			sierpC () // level %% start recursion
			lineRel () // -dist, -dist
			sierpD () // level %% start recursion
			lineRel () // dist, -dist
		timer ()
			dist (out) //   dist0
			for () // i = level; i > 0; i--
				dist (inout) // /= 2
			goToXY () // x_pos, y_pos
			sierpA () // level %% start recursion
			lineRel () // dist, dist
			sierpB () // level %% start recursion
			lineRel () // -dist, dist
			sierpC () // level %% start recursion
			lineRel () // -dist, -dist
			sierpD () // level %% start recursion
			lineRel () // dist, -dist
