# File: splitcode_Perl.pl
# Date            Author        number of nodes
# 2003/7/15       Walking Lint  50
# 2003/7/14       Walking Lint  50

=pod

=head1 NAME

splitcode_Perl.pl - split cook book examples

=head1 DESCRIPTION

ex. perl.exe splitcode_Perl.pl D:\cookbook.examples\ch20\ch20.code

get cookbook examples at <a href="http://examples.oreilly.com/cookbook/">Index of /cookbook</a>

=head1 AUTHOR

Walking Lint

=cut

$from_file = shift;
$cnt = 1;
$to_file = $from_file;
$suffix = '_' . $cnt . '.pl';
$to_file =~ s/\.(code|txt|pl)$/$suffix/;
open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
open IN, $from_file or die("Cannot open $from_file: $!\n");
$in_title = 0;
while (<IN>) {
  if ($in_title) {
    if ($_ =~ /^#########/) {
      $in_title = 0;
    } else {
      DebugPrint("title = " . $_);
    }
    next;
  }
  if ($_ =~ /^#########/) {
    $in_title = 1;
    next;
  }
  if ($_ =~ /^(=|\}|\} )?------------/) { # actually not sure ...
    $cnt++;
    $suffix = '_' . $cnt . '.pl';
    $to_file = $from_file;
    $to_file =~ s/\.(code|txt)$/$suffix/;
    close OUT;
    open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
  } else {
    print OUT $_;
  }
}
close IN;
close OUT;
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
