//
// File: steambit_maid_for_sorority_LSL.lsl
// Date            Author        number of nodes
// 2007/9/29       walkinglint   70
// 2007/9/29       walkinglint   70 (steambit_maid_for_sorority->steambit_maid_for_sorority_LSL)
// 2007/9/22       walkinglint   70
// 2007/9/22       walkinglint   67 (steambit_maid->steambit_maid_for_sorority)
// 2007/9/22       walkinglint   67
// 2007/9/17       walkinglint   54
// 2007/9/17       walkinglint   19 (follower_pet->steambit_maid)
// 2007/8/5        walkinglint   19
// 2007/8/3        Walking Lint  18
// 2007/8/3
//
//
// ================================ 
// Faily Script
// (C) 20070325 oitake
// ================================ ;
//
// http://oitake.jugem.jp/?eid=118
key owner;
string notecard_name = "message_list";
list message_list;
integer irasshaimase_message_idx = 0;
integer message_idx;
integer read_line;
key query_id;
list name_list;
string owner_name;
integer i;
string name;
vector first_position;
default {
    state_entry() {
        message_list = [];
        if (llGetInventoryType(notecard_name) == INVENTORY_NOTECARD) {
            query_id = llGetNotecardLine(notecard_name, read_line);     // request first line
        } else {
            llOwnerSay("Notecard " + notecard_name + " is not found");
        }
        name_list = [];
        owner = llGetOwner();
        owner_name = llKey2Name(owner);
        name_list = llListInsertList(name_list, [owner_name], 0);
        llParticleSystem
        ([
            PSYS_PART_FLAGS,PSYS_PART_EMISSIVE_MASK | PSYS_PART_INTERP_COLOR_MASK | PSYS_PART_INTERP_SCALE_MASK | PSYS_PART_WIND_MASK,
            PSYS_PART_MAX_AGE,1.0,
            PSYS_PART_START_ALPHA,1.0,
            PSYS_PART_END_ALPHA,0.0,
            PSYS_PART_START_COLOR,<1.0,1.0,1.0>,
            PSYS_PART_END_COLOR,<1.0,1.0,0.0>,
            PSYS_PART_START_SCALE,<0.125,0.125,0.125>,
            PSYS_PART_END_SCALE,<0.0,0.0,0.0>,
            PSYS_SRC_PATTERN,PSYS_SRC_PATTERN_EXPLODE,
            PSYS_SRC_ACCEL,<0.0,0.0,-1.0>,
            PSYS_SRC_BURST_RATE,0.0,
            PSYS_SRC_BURST_PART_COUNT,1,
            PSYS_SRC_BURST_RADIUS,0.0,
            PSYS_SRC_BURST_SPEED_MIN,0.1,
            PSYS_SRC_BURST_SPEED_MAX,0.2,
            PSYS_SRC_MAX_AGE,0.0,
            PSYS_SRC_INNERANGLE,0.0,
            PSYS_SRC_OUTERANGLE,PI,
            PSYS_SRC_TEXTURE,"Kirameki"
        ]);
        llSensorRepeat("", NULL_KEY, AGENT, 7.0, PI, 2);
        llSetTimerEvent(5.0);   // customize time interval if set too long then bit may be lost following customer
    }
    on_rez(integer param) {
        llResetScript();
    }
    dataserver(key queryid, string data) {
        if (queryid == query_id) {
            if (data != EOF) {
                // process data
                if (llStringLength(data) != 0) {
                    message_list = llListInsertList(message_list, [data], llGetListLength(message_list));
                }
                read_line++;
                query_id = llGetNotecardLine(notecard_name, read_line);
            } else {
                llOwnerSay("Loading complete.");
            }
        }
    }
    sensor(integer num_detected) {
        vector left = llRot2Left(llDetectedRot(0));
        message_idx = irasshaimase_message_idx;
        for (i = 0; i < num_detected; i++) {
            name = llDetectedName(i);
            if (llListFindList(name_list, [name]) == -1) {
                llMoveToTarget(llDetectedPos(i) + left * 0.5 + <0.0, 0.0, 1.0>, 1.5);   // customize duration time with last paramete see http://rpgstats.com/wiki/index.php?title=LlMoveToTarget
                llSay(0, name + " " + llList2String(message_list, 0));
                name_list = llListInsertList(name_list, [name], llGetListLength(name_list));
            } else if (name == owner_name) {
                first_position = llDetectedPos(i) + left * 0.5 + <0.0, 0.0, 1.0>;
            }
        }
    }
    timer() {
        llMoveToTarget(first_position, 0.75);
    }
}
