//
// File: timer_LSL.lsl
// Date            Author        number of nodes
// 2007/3/28       Walking Lint  21
//
integer activated = FALSE;
integer counter;
default {
    touch_start(integer num_detected) {
        string nm;
        if (activated == TRUE) {
            llSay(0, "Self destruction sequence can not be cancelled");
        } else {
            nm = llKey2Name(llDetectedKey(num_detected));
            llSay(0, "Self destruction sequence has been initiated by " + nm);
            llSay(0, "Evacuate this area NOW in 10 second!!!");
            activated = TRUE;
            counter = 10;
            llSetTimerEvent(1.0);
        }
    }
    timer() {
        llSay(0, (string)counter);
        counter--;
        if (counter == 0) {
            llTriggerSound("wakyanko", 100);
            llSay(0, "nanchatte ^^;");
            activated = FALSE;
            llSetTimerEvent(0);
        }
    }
}
