root () //  %% File: AnalyzeLog_Perl.pl CRLF Date            Author        number of nodes CRLF 2002/10/19      Walking Lint  138 CRLF 2002/7/4        Walking Lint  135 CRLF 2002/4/4        Walking Lint  134 CRLF 2002/3/3        Walking Lint  130 CRLF 2002/3/2        Walking Lint  89 CRLF 2002/2/17       Walking Lint  89 CRLF 2002/2/16       Walking Lint  85
	use () // Time::Local
	$graphlength (out) //   30
	_note () // commented out (2002/4/4)
		$from_file (out) //   'Log.pat'
	$from_file (out) //   shift
	DebugPrint () // "from_file = $from_file"
	open () // IN, $from_file || die("Can't open $from_file: $!\n")
	$logintime (out) //   0
	$newfiletime (out) //   0
	$idledtime (out) //   0
	while () // <IN>
		$_ (in)
		if () // =~ /idled over ([0-9]+) minutes/
			$idledtime (out) //   $idledtime  + $1 * 60
			$idledtime{$year . '/' . $month . '/' . $mday} (out) //   $idledtime{$year . '/' . $month . '/' . $mday}  + $1 * 60
		$_ (in)
		elsif () // =~ /logged in/
			$idledtime (out) //   0
			$file (out) //   $1
			$_ (inout) // =~ /([0-9]+)\/([0-9]+)\/([0-9]+) ([0-9]+):([0-9]+):([0-9]+)/
			$year (out) //   $1
			$month (out) //   $2
			$mday (out) //   $3
			$hours (out) //   $4
			$min (out) //   $5
			$sec (out) //   $6
			$logintime (out) //   timelocal($sec, $min, $hours, $mday, $mon, $year)
			$logintime{$year . '/' . $month . '/' . $mday} (out) //   timelocal($sec, $min, $hours, $mday, $mon, $year)
		$_ (in)
		elsif () // =~ /logged out/
			$elapsedtimeofday{$year . '/' . $month . '/' . $mday} (out) //   $elapsedtimeofday{$year . '/' . $month . '/' . $mday} + timelocal($sec, $min, $hours, $mday, $mon, $year) - $logintime{$year . '/' . $month . '/' . $mday}
			$elapsedtimeofday{$year . '/' . $month . '/' . $mday} (inout) // -= $idledtime{$year . '/' . $month . '/' . $mday}
			$idledtime{$year . '/' . $month . '/' . $mday} (out) //   0
		$_ (in)
		elseif () // =~ /opened file \(([^\)]+)\)/
			$idledtime (out) //   0
			$file (out) //   $1
			$_ (inout) // =~ /([0-9]+)\/([0-9]+)\/([0-9]+) ([0-9]+):([0-9]+):([0-9]+)/
			$year (out) //   $1
			$month (out) //   $2
			$mday (out) //   $3
			$hours (out) //   $4
			$min (out) //   $5
			$sec (out) //   $6
			$openedtime{$file} (out) //   timelocal($sec, $min, $hours, $mday, $mon, $year)
		$_ (in)
		elseif () // =~ /new file/
			$idledtime (out) //   0
			$file (out) //   $1
			$_ (inout) // =~ /([0-9]+)\/([0-9]+)\/([0-9]+) ([0-9]+):([0-9]+):([0-9]+)/
			$year (out) //   $1
			$month (out) //   $2
			$mday (out) //   $3
			$hours (out) //   $4
			$min (out) //   $5
			$sec (out) //   $6
			$newfiletime (out) //   timelocal($sec, $min, $hours, $mday, $mon, $year)
		$_ (in)
		elseif () // =~ /saved file \(([^\)]+)\)/
			$file (out) //   $1
			$_ (inout) // =~ /([0-9]+)\/([0-9]+)\/([0-9]+) ([0-9]+):([0-9]+):([0-9]+)/
			$year (out) //   $1
			$month (out) //   $2
			$mday (out) //   $3
			$hours (out) //   $4
			$min (out) //   $5
			$sec (out) //   $6
			$savedtime{$file} (out) //   timelocal($sec, $min, $hours, $mday, $mon, $year)
			if () // defined($openedtime{$file}) and ($openedtime{$file} > $logintime) and ($openedtime{$file} > $newfiletime) and (($savedtime{$file} - $openedtime{$file} - $idledtime) > 0)
				$elapsedtime (out) // {$file}  $elapsedtime{$file} + $savedtime{$file} - $openedtime{$file} - $idledtime
			elseif () // ($newfiletime > $logintime) and (($savedtime{$file} - $newfiletime - $idledtime) > 0)
				$elapsedtime (out) // {$file}  $elapsedtime{$file} + $savedtime{$file} - $newfiletime - $idledtime
			elseif () // ($logintime > 0) and (($savedtime{$file} - $logintime - $idledtime) > 0)
				$elapsedtime (out) // {$file}  $elapsedtime{$file} + $savedtime{$file} - $logintime - $idledtime
			$openedtime{$file} (out) //   $savedtime{$file} %% this is needed ...
			$idledtime (out) //   0
		_note () // commented out (2002/3/3)
			else ()
				$idledtime (out) //   0
	close () // IN
	$max (out) //   0
	foreach () % // keys %elapsedtime
		$key (in) &
		$tmp (out) //   int($elapsedtime{$key})
		$tmp (in) // > $max
		if ()
			$max (out) //   $tmp
	_note () // commented out (2002/4/4)
		foreach () % // keys %elapsedtimeofday
			$key (in) &
			$tmp (out) //   int($elapsedtimeofday{$key})
			$tmp (in) // > $max
			if ()
				$max (out) //   $tmp
	$elemtime (out) //   $max / $graphlength
	foreach () % // sort {$elapsedtime{$b} <=> $elapsedtime{$a}} keys %elapsedtime
		$key (in) &
		_note () // commented out (2002/2/15)
			print () // $key . ' - ' . $elapsedtime{$key} . "s\n"
		$hour (out) //   int($elapsedtime{$key} / (60 * 60))
		$min (out) //   int($elapsedtime{$key} / 60) - $hour * 60
		$sec (out) //   $elapsedtime{$key} - $min * 60 - $hour * 60 * 60
		$hstr (out) //   ''
		$mstr (out) //   ''
		$sstr (out) //   ''
		if () // $hour != 0
			$hstr (out) //   $hour . 'h'
		if () // $min != 0
			$mstr (out) //   $min . 'm'
		if () // $sec != 0
			$sstr (out) //   $sec . 's'
		$graphline (out) //   '*' x (int($elapsedtime{$key} / $elemtime))
		STDOUT (out) // format
			_text () //  %% @>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> - @>>@>>@>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< CRLF $key $hstr $mstr $sstr $graphline
		write ()
	print () // "\n"
	_note () // commented out (2002/4/4)
		foreach () % // sort keys %elapsedtimeofday
			$key (in) &
			$hour (out) //   int($elapsedtimeofday{$key} / (60 * 60))
			$min (out) //   int($elapsedtimeofday{$key} / 60) - $hour * 60
			$sec (out) //   $elapsedtimeofday{$key} - $min * 60 - $hour * 60 * 60
			$hstr (out) //   ''
			$mstr (out) //   ''
			$sstr (out) //   ''
			if () // $hour != 0
				$hstr (out) //   $hour . 'h'
			if () // $min != 0
				$mstr (out) //   $min . 'm'
			if () // $sec != 0
				$sstr (out) //   $sec . 's'
			$graphline (out) //   '*' x (int($elapsedtimeofday{$key} / $elemtime))
			STDOUT (out) // format
				_text () //  %% @>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> - @>>@>>@>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< CRLF $key $hstr $mstr $sstr $graphline
			write ()
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
