# File: AssocSeq_Perl.pl
# Date            Author        number of nodes
# 2005/12/9       Walking Lint  21
# 2005/12/9       Walking Lint  38 (sort_Perl->AssocSeq_Perl)
# 2005/8/17       Walking Lint  38
# 2005/8/16       Walking Lint  32
# 2005/6/25       Walking Lint  18
# 2005/3/16       Walking Lint  17
# 2003/8/30       Walking@Lint 22
# 2003/8/6        Walking@Lint 15
# 2003/5/10       Walking Lint  9
# 2002/11/6       Walking Lint  7
# 2002/11/4       Walking Lint  3
# 2002/2/3        Walking Lint  3 (Sort2_Perl->sort_Perl)

=pod

=head1 NAME

AssocSeq_Perl.pl - reseq 3rd and 4th column associating 3rd to 1st column

=head1 DESCRIPTION

activate as filter2

=head1 AUTHOR

Walking Lint

=cut

@firsts = ();
@thirds = ();
%firsts = ();
%thirds = ();
while (<STDIN>) {
  $_ =~ s/[\n\r]*$//;
  ($first, $second, $third, $fourth) = split(/\t/, $_);
  if (length($first) != 0) {
    push @firsts, $first;
    $firsts{$first} = $second;
  }
  if (length($third) != 0) {
    push @thirds, $third;
    $thirds{$third} = $fourth;
  }
}
foreach $first (@firsts) {
  if (defined($thirds{$first})) {
    DebugPrint($first . "\t" . $thirds{$first});
  } else {
    DebugPrint($first . "\t" . 0);
  }
}
foreach $third (@thirds) {
  unless (defined($firsts{$third})) {
    DebugPrint($third . "\t" . $thirds{$third});
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
