# File: BakReader_Perl.pl
# Date            Author        number of nodes
# 2002/11/28      Walking Lint  18
# 2002/11/10      Walking Lint  33 (PodReader_Perl->BakReader_Perl)
# 2002/11/10      Walking Lint  20 (CsvReader_Perl->PodReader_Perl)
# 2002/11/9       Walking Lint  16
# 2002/3/10       Walking Lint  16 (CSVReader_Perl->CsvReader_Perl)

=pod

=head1 NAME

BakReader_Perl.pl - bak reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use File::Copy;
$from_file = shift;
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
if (-e $to_file) {
  $tmp_file = $from_file; # not actually ...
  $tmp_file =~ s/\..+/.bkr/;
  copy($from_file, $tmp_file);
}
open IN, $from_file || die("Can't open $from_file: $!\n");
open OUT, ">$to_file";
while (<IN>) {
  print OUT $_;
}
close IN;
close OUT;
