# File: BakWriter_Perl.pl
# Date            Author        number of nodes
# 2002/11/28      Walking Lint  34
# 2002/11/28      Walking Lint  18 (CsvWriter_Perl->BakWriter_Perl)
# 2002/11/10      Walking Lint  33
# 2002/11/9       Walking Lint  29
# 2002/6/4        Walking Lint  29 (CSVWriter_Perl->CsvWriter_Perl)
# 2002/3/10       Walking Lint  20

=pod

=head1 NAME

BakWriter_Perl.pl - csv writer

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use File::Copy;
use Win32::File;
use Time::localtime;
$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
open IN, $from_file || die("Can't open $from_file: $!\n");
open OUT, ">$to_file";
while (<IN>) {
  print OUT $_;
}
close IN;
close OUT;
$tmp_file = $to_file; # not actually ...
$tmp_file =~ s/\..+/.bkr/;
if (-e $tmp_file) { # hack ...
  $tm = localtime($last_time);
  $year = $tm->year + 1900;
  $month = $tm->mon + 1;
  $day = $tm->mday;
  @stat = stat($tmp_file);
  $tm2 = localtime($stat[9]);
  $year2 = $tm->year + 1900;
  $month2 = $tm->mon + 1;
  $day2 = $tm->mday;
  if ($year == $year2 and $month == $month2 and $day == $day2) { # may be better to check elapse of time but think later ...
    copy($tmp_file, $from_file);
    unlink $tmp_file;
  }
}
