//
// File: ChangeColorRose_LSL.lsl
// Date            Author        number of nodes
// 2007/3/31       Walking Lint  22
// 2007/3/31       Walking Lint  22 (test->ChangeColorRose_LSL)
// 2007/3/31       Walking Lint  22
//
setcolor(vector color) {
    integer num_of_prims;
    integer i;
    num_of_prims = llGetNumberOfPrims();
    for (i = 0; i <= num_of_prims; i++) {
        if (lGetLinkName(i) != "non_petal") {
            llSetLinkColor(i, color, ALL_SIDES);
        }
    }
}
default {
    state_entry() {
        llSetText(llUnescapeURL("%E9%9D%92%E3%81%84%E8%96%94%E8%96%87"), <0.0, 0.0, 1.0>, 0.5);
    }
    touch_start(integer id) {
        setcolor(<1.0, 0.0, 0.0>);
        llSetText(llUnescapeURL("%E8%B5%A4%E3%81%84%E8%96%94%E8%96%87"), <1.0, 0.0, 0.0>, 0.5);
        state touched;
    }
}
state touche {
    touch_start(integer id) {
        setcolor(<0.0, 0.0, 1.0>);
        llSetText(llUnescapeURL("%E9%9D%92%E3%81%84%E8%96%94%E8%96%87"), <0.0, 0.0, 1.0>, 0.5);
        state default;
    }
}
