//
// File: Clock_LSL.lsl
// Date            Author        number of nodes
// 2007/3/25       Walking Lint  25
//
string smin;
string sseconds;
default {
    state_entry() {
        llSetTimerEvent(2.0);
    }
    timer() {
        integer seconds = llFloor(llGetWallclock());
        integer min = llFloor(seconds / 60);
        seconds = seconds - (min * 60);
        integer hour = llFloor(min / 60);
        min = min - (hour * 60);
        hour = hour + 16;
        if (hour > 24) {
            hour = hour - 24;
        }
        string shour = (string)hour;
        if (min < 10) {
            smin = "0" + (string)min;
        } else {
            smin = (string)min;
        }
        if (seconds < 10) {
            sseconds = "0" + (string)seconds;
        } else {
            sseconds = (string)seconds;
        }
        string time = shour + ":" + smin + ":" + sseconds;
        llSetText(time, ZERO_VECTOR, 1.0);
    }
}
