# File: Convert2PatWithPatentReader_Perl.pl
# Date            Author        number of nodes
# 2005/7/12       Walking Lint  36
# 2005/3/10       Walking Lint  36
# 2005/3/7        Walking Lint  34
# 2005/3/7        Walking Lint  35 (Convert2HtmWithHtmlWithFoldWriter_Perl->Convert2PatWithPatentReader_Perl)
# 2005/3/7        Walking Lint  35
# 2005/3/7        Walking Lint  35 (grep_Perl->Convert2HtmWithHtmlWithFoldWriter_Perl)
# 2004/1/9        Walking Lint  43
# 2003/2/13       Walking Lint  27
# 2002/8/15       Walking Lint  21
# 2002/7/15       Walking Lint  19
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

Convert2PatWithPatentReader_Perl.pl - convert to htm with PatentReader_Perl (.htm with image)

=head1 DESCRIPTION

activate as program ex. Convert2PatWithPatentReader_Perl () // "CurrentFolder\|*.txt"

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Cwd;
$from = shift;
if (length($from) != 0) {
  $templatesfolder = $ENV{TEMPLATESFOLDER};
  $perl = $ENV{PERL};
  $dir = dirname($from);
  $dir2 = &mydirname($from);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  $dir = dirname($from);
  $dir2 = &mydirname($from);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  $count = @from_files;
  foreach $from_file (@from_files) {
    $to_file = $from_file;
    $to_file =~ s/\.txt/.pat/;
    if (not -e $to_file) {
      system '"' . $perl . '" "' . $templatesfolder . '\PatentReader_Perl.pl" "' . $from_file . '"';
    } else {
      DebugPrint("found $to_file");
    }
  }
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
