root () //  %% File: CopyFilesToMail_Perl.pl CRLF Date            Author        number of nodes CRLF 2003/7/20       Walking Lint  69 CRLF 2003/3/13       Walking Lint  65 CRLF 2002/11/29      Walking Lint  62 CRLF 2002/11/27      Walking Lint  67 CRLF 2002/11/23      Walking Lint  67 CRLF 2002/11/6       Walking Lint  58 CRLF 2002/10/31      Walking Lint  58 CRLF 2002/10/4       Walking Lint  56 CRLF 2002/9/26       Walking Lint  46 CRLF 2002/9/25       Walking Lint  46 (CopyFilesToMail_Perl->CopyFilesToMail_Perl) CRLF 2002/9/9        Walking Lint  49 (CopyFilesToMail_Perl->CopyFilesToMail_Perl) CRLF 2002/9/7        Walking Lint  49 CRLF 2002/7/23       Walking Lint  9 (CheckModifiedTime_Perl->CopyFilesToMail_Perl) CRLF 2002/6/4        Walking Lint  6 (Time_Perl->CheckModifiedTime_Perl) CRLF 2002/3/3        Walking Lint  3 (Time_Perl->NewFile) CRLF 2002/2/19       Walking Lint  3 CRLF 2002/2/17       Walking Lint  3
	_doc ()
		NAME () //  %% CopyFilesToMail_Perl.pl - copy files changed after previous activation of this script
		DESCRIPTION () //  %% ex. perl.exe CopyFilesToMail_Perl.pl "D:\common\cv\templates" "D:\common\cv\templates\mail"
		AUTHOR () //  %% [[Author]]
	use () // File::Basename
	use () // Win32::File
	use () // File::Copy
	use () // Time::localtime
	$from_dir (out) //   $ENV{TEMPLATESFOLDER}
	$from_dir (inout) //   =~ s/"//g
	$to_dir (out) //   $from_dir . '\mail'
	_ () //  %% get last mailed time
		$timestampfile (out) //   $from_dir . "\\" . "lastmailedtime"
		if () // -e $timestampfile
			open () // IN, $timestampfile || die("Can't open $timestampfile: $!\n")
			$last_time (out) //   <IN>
			close () // IN
		else ()
			$last_time (out) //   0 %% not sure if this is OK ...
		_note () // commented out (2002/11/23)
			DebugPrint () // "last_time = $last_time"
		DebugPrint () // "last_time = " . &gendate($last_time)
	_ () //  %% clear mail dir
		if () // not (-e $to_dir)
			mkdir () // $to_dir, 0700 or die("Cannot make $to_dir: $!")
		opendir () // DIR, $to_dir or die "opendir $to_dir failed: $!"
		@files (out) //   readdir DIR
		closedir () // DIR
		foreach () // $from_file (@files)
			$from_file (out) //   $to_dir . "\\" . basename($from_file)
			unlink () // $from_file
	_ () //  %% copy files modified after ftpx's last activation
		opendir () // DIR, $from_dir or die "opendir $from_dir failed: $!"
		@files (out) //   grep /\.(pat)$/i, readdir DIR
		%dates (out) //   ()
		closedir () // DIR
		foreach () // $from_file (@files) %% (sort {lc($b) cmp lc($a)} @files)
			if () // ($from_file =~ /^Log.pat/) or ($from_file =~ /^WebLog.pat/) or ($from_file =~ /^AutoBackup.pat/) or ($from_file =~ /^Programs.pat/)
				next ()
			$from_file (out) //   $from_dir . "\\" . basename($from_file)
			@stat (out) //   stat($from_file) %% better to set this info to $to_file ... check later ...
			if () // (($stat[9] > $last_time) or ($stat[10] > $last_time)) and not (basename($from_file) eq 'copyright.html') and not (basename($from_file) eq 'menu.html')
				$to_file (out) //   $to_dir . "\\" . basename($from_file)
				copy () // $from_file, $to_file
				$dates{$to_file} (out) //   &gendate($stat[9])
		$first (out) //   1
		foreach () // $key (sort {$dates{$a} cmp $dates{$b}} keys %dates)
			if () // $first
				$first (out) //   0
				DebugPrint () // ''
			DebugPrint () // "copied to $key - $dates{$key}"
	_ () //  %% record last activation time in timestampfile
		open () // OUT, ">$timestampfile"
		$currenttime (out) //   time()
		print () // OUT "$currenttime\n"
		close () // OUT
	gendate ()
		$time (in) &
		$tm (out) //   localtime($time)
		$year (out) //   $tm->year + 1900
		$month (out) //   $tm->mon + 1
		$day (out) //   $tm->mday
		$hour (out) //   $tm->hour
		$min (out) //   $tm->min
		$sec (out) //   $tm->sec
		return () // sprintf("$year/%02d/%02d $hour:$min:$sec", $month, $day)
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
