root () //  %% File: CopyFilesToUpdate_Perl.pl CRLF Date            Author        number of nodes CRLF 2003/7/20       Walking Lint  60 CRLF 2002/11/29      Walking Lint  56 CRLF 2002/11/27      Walking Lint  54 CRLF 2002/11/6       Walking Lint  54 CRLF 2002/10/31      Walking Lint  58 (CopyFilesToUpdate_Perl->CopyFilesToUpdate_Perl) CRLF 2002/10/4       Walking Lint  56 CRLF 2002/9/26       Walking Lint  46 CRLF 2002/9/25       Walking Lint  46 (CopyFilesToUpdate_Perl->CopyFilesToUpdate_Perl) CRLF 2002/9/9        Walking Lint  49 (CopyFilesToUpdate_Perl->CopyFilesToUpdate_Perl) CRLF 2002/9/7        Walking Lint  49 CRLF 2002/7/23       Walking Lint  9 (CheckModifiedTime_Perl->CopyFilesToUpdate_Perl) CRLF 2002/6/4        Walking Lint  6 (Time_Perl->CheckModifiedTime_Perl) CRLF 2002/3/3        Walking Lint  3 (Time_Perl->NewFile) CRLF 2002/2/19       Walking Lint  3 CRLF 2002/2/17       Walking Lint  3
	_doc ()
		NAME () //  %% CopyFilesToUpdate_Perl.pl - copy files changed after previous activation of this script
		DESCRIPTION () //  %% ex. perl.exe CopyFilesToUpdate_Perl.pl "C:\memo\cv\templates" "D:\HP" "C:\memo\cv\templates\update"
		AUTHOR () //  %% [[Author]]
	use () // File::Basename
	use () // Win32::File
	use () // File::Copy
	use () // Time::localtime
	$from_dir (out) //   shift
	$update_dir (out) //   shift
	$to_dir (out) //   shift
	if () // length($from_dir) == 0 or length($update_dir) == 0 or length($to_dir) == 0
		exit ()
	_ () //  %% clear to_dir (temporary)
		opendir () // DIR, $to_dir or die "opendir $to_dir failed: $!"
		@files (out) //   readdir DIR
		closedir () // DIR
		foreach () // $file (@files)
			$file (out) //   $to_dir . "\\" . basename($file)
			unlink () // $file
	_ () //  %% copy files modified
		opendir () // DIR, $update_dir or die "opendir $update_dir failed: $!"
		@files (out) //   grep /\.(pat)$/i, readdir DIR
		%dates (out) //   ()
		closedir () // DIR
		foreach () // $file (@files)
			$from_file (out) //   $from_dir . "\\" . basename($file)
			$update_file (out) //   $update_dir . "\\" . basename($file)
			if () // not -e $from_file
				next ()
			@stat (out) //   stat($from_file) %% better to set this info to $to_file ... check later ...
			@stat2 (out) //   stat($update_file) %% better to set this info to $to_file ... check later ...
			_note () // commented out (2002/11/6)
				DebugPrint () // "from_file = $from_file"
				DebugPrint () // "update_file = $update_file"
				DebugPrint () // "stat[9] = $stat[9] "
				DebugPrint () // "stat2[9] = $stat2[9] "
			if () // $stat[9] > $stat2[9]
				$to_file (out) //   $to_dir . "\\" . basename($from_file)
				copy () // $from_file, $to_file
				$dates{$to_file} (out) //   &gendate($stat[9])
		$first (out) //   1
		foreach () // $key (sort {$dates{$a} cmp $dates{$b}} keys %dates)
			if () // $first
				$first (out) //   0
				DebugPrint () // ''
			DebugPrint () // "copied to $key - $dates{$key}"
	gendate ()
		$time (in) &
		$tm (out) //   localtime($time)
		$year (out) //   $tm->year + 1900
		$month (out) //   $tm->mon + 1
		$day (out) //   $tm->mday
		$hour (out) //   $tm->hour
		$min (out) //   $tm->min
		$sec (out) //   $tm->sec
		return () // sprintf("$year/%02d/%02d $hour:$min:$sec", $month, $day)
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
