# File: CopyGeneratedOrRelatedFiles_Perl.pl
# Date            Author        number of nodes
# 2003/2/13       Walking Lint  64
# 2002/11/16      Walking Lint  59
# 2002/10/3       Walking Lint  59
# 2002/9/26       Walking Lint  46 (CopyGeneratedOrRelatedFiles_Perl->CopyGeneratedOrRelatedFiles_Perl)
# 2002/9/25       Walking Lint  46 (CopyGeneratedOrRelatedFiles_Perl->CopyGeneratedOrRelatedFiles_Perl)
# 2002/9/9        Walking Lint  49 (CopyGeneratedOrRelatedFiles_Perl->CopyGeneratedOrRelatedFiles_Perl)
# 2002/9/7        Walking Lint  49
# 2002/7/23       Walking Lint  9 (CheckModifiedTime_Perl->CopyGeneratedOrRelatedFiles_Perl)
# 2002/6/4        Walking Lint  6 (Time_Perl->CheckModifiedTime_Perl)
# 2002/3/3        Walking Lint  3 (Time_Perl->NewFile)
# 2002/2/19       Walking Lint  3
# 2002/2/17       Walking Lint  3

=pod

=head1 NAME

CopyGeneratedOrRelatedFiles_Perl.pl - copy files changed after previous activation of this script

=head1 DESCRIPTION

ex. perl.exe CopyGeneratedOrRelatedFiles_Perl.pl "D:\My Weblog\AboutCMS.pat" "D:\My Weblog\generated"

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Win32::File;
use File::Copy;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_dir = shift;
DebugPrint("to_dir = $to_dir");
$from_dir = &mydirname($from_file);
$root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
# clear generated dir
opendir DIR, $to_dir or die "opendir $to_dir failed: $!";
@files = readdir DIR;
closedir DIR;
  foreach $from_file (@files) {
    $from_file = $to_dir . "\\" . basename($from_file);
    unlink $from_file;
  }
$from_file2 = $from_file;
$from_file2 =~ s/\.pat/.html/;
$to_file = $to_dir . "\\" . basename($from_file2);
copy($from_file2, $to_file);
DebugPrint("copied to $to_file");
&copyfile($root);
sub copyfile {
  my($nd) = @_;
  if ($nd->{NAME} eq '_part') {
    $to_file = $to_dir . "\\" . $nd->{TYPE};
    copy($from_dir . "\\" . $nd->{TYPE}, $to_file);
    DebugPrint("copied to $to_file");
  } elsif ($nd->{KIND} =~ /\//) {
    $to_file = $to_dir . "\\" . $nd->{TYPE} . ".html";
    copy($from_dir . "\\" . $nd->{TYPE} . ".html", $to_file);
    DebugPrint("copied to $to_file");
  } elsif ($nd->{NAME} eq '_note') {
    return;
  }
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      &copyfile($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
