# File: CountChars_Perl.pl
# Date            Author        number of nodes
# 2004/11/3       Walking Lint  39
# 2003/8/31       Walking@Lint 39
# 2003/8/8        Walking@Lint 33
# 2003/5/14       Walking Lint  31
# 2003/5/14       Walking Lint  15 (wc_Perl->CountChars_Perl)
# 2003/3/19       Walking Lint  15
# 2002/4/21       Walking Lint  6 (WordCount_Perl->wc_Perl)

=pod

=head1 NAME

CountChars_Perl.pl - count chars

=head1 DESCRIPTION

activate as filter2

=head1 AUTHOR

Walking Lint

=cut

$use_tk = shift;
$han = 0;
$zen = 0;
$total = 0;
while (<STDIN>) {
  $zen += ($_ =~ tr/\xa1-\xfe/\xa1-\xfe/);
  $han += ($_ =~ tr/\x21-\x7e/\x21-\x7e/);
  $total += length($_);
  print $_;
}
$else = $total - $zen - $han;
if ($use_tk) {
  use Tk;
  $mw = new MainWindow;
  $lab = $mw->Label(-anchor => "w", -text => "zenkaku = $zen\nhankaku(\\x2a - \\x7e) = $han\nhankaku(else) = $else\n----------------------------\ntotal = $total"); # anchor is not functioning ??
  $lab->pack();
  MainLoop();
} else {
  DebugPrint("");
  DebugPrint("zenkaku = $zen");
  DebugPrint("hankaku(\\x2a - \\x7e) = $han");
  DebugPrint("hankaku(else) = $else");
  DebugPrint("----------------------------");
  DebugPrint("total = $total");
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
