# File: Csv2Table_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 21
# 2003/8/6        Walking@Lint 15
# 2003/8/4        Walking@Lint 15
# 2002/12/5       Walking Lint  10
# 2002/6/14       Walking Lint  10 (CSV2Table_Perl->Csv2Table_Perl)
# 2002/4/20       Walking Lint  10
print "<table>\n";
$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  $_ =~ s/\n$//;
  $_ =~ s/(^[ ]+|[ ]+$)//;
  @items = split(/,/, $_);
  $line = join("</td><td>", @items);
  print "<tr>";
  print "<td>" . $line . "</td>";
  print "</tr>\n";
  if ($breaklater) {
    last;
  }
}
print "</table>\n";
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
