# File: Csv2Txt_Perl.pl
# Date            Author        number of nodes
# 2003/12/10      Walking Lint  51
# 2003/12/10      Walking Lint  24 (Csv2Html_Perl->Csv2Txt_Perl)
# 2002/11/16      Walking Lint  24
# 2002/10/11      Walking Lint  25
# 2002/10/7       Walking Lint  25
# 2002/10/7       Walking Lint  23 (Csv2Text_Perl->Csv2Html_Perl)
# 2002/6/14       Walking Lint  10 (CSV2Table_Perl->Csv2Text_Perl)
# 2002/4/20       Walking Lint  10

=pod

=head1 NAME

Csv2Txt_Perl.pl - csv to txt

=head1 DESCRIPTION

ex. _text () ^ // [[CurrentSrcBaseFile2]] %% aaa,bbb,ccc

=head1 AUTHOR

Walking Lint

=cut

$from_file = shift;
if (length($from_file) != 0) {
  open IN, $from_file || die("Can't open $from_file: $!\n");
  $filehandle = IN;
} else {
  $filehandle = 'STDIN';
}
@lines = ();
while (<$filehandle>) {
  chop $_;
  $_ =~ s/(^[ "]+|[ ",]+$)//g;
  push @lines, $_;
  @items = split(/[" ]*,[" ]*/, $_); # this is hack ...
  $i = 0;
  foreach $item (@items) {
    if ((not defined($width{$i})) or ($width{$i} < length($item))) {
      $width{$i} = length($item);
    }
    $i++;
  }
}
$separator = '+';
$i = 0;
foreach $item (@items) {
  $separator .= '-' x $width{$i} . '+';
  $i++;
}
print "$separator\n";
foreach $line (@lines) {
  @items = split(/[" ]*,[" ]*/, $line); # this is hack ...
  $i = 0;
  $line = '|';
  foreach $item (@items) {
    $padding = ' ' x ($width{$i} - length($item));
    $line .= $item . $padding . '|';
    $i++;
  }
  print "$line\n";
  print "$separator\n";
}
if (length($from_file) != 0) {
  close IN;
}
