# File: DB2_Perl.pl
# Date            Author        number of nodes
# 2002/12/23      Walking Lint  18
# 2002/12/23      Walking Lint  18 (DB3_Perl->DB2_Perl)
# 2002/12/23      Walking Lint  17 (DB2_Perl->DB3_Perl)
use Fcntl;
use SDBM_File;
use Config;
$flags = O_CREAT | O_RDWR | BINARY();
$db_file = 'SDBM_Perl';
tie (%hash, 'SDBM_File', $db_file, $flags, 0666) or die "Cannot open $db_file: $!";
$tm = localtime();
$hash{$tm} = 'Hello right now';
untie %hash;
tie (%hash, 'SDBM_File', $db_file, $flags, 0666) or die "Cannot open $db_file: $!";
while (($key, $value) = each (%hash)) {
  print "$key = $value\n";
}
untie %hash;
sub BINARY {
  return O_BINARY if is_windows();
}
sub is_windows {
  return $Config{osname} =~ /^(MS)?Win/;
}
