# File: DiffWithLatestSnapShot_Perl.pl
# Date            Author        number of nodes
# 2003/3/24       Walking Lint  31
# 2003/3/23       Walking Lint  30 (DiffAutoBackupWithLatestWeblog_Perl->DiffWithLatestSnapShot_Perl)
# 2002/12/26      Walking Lint  26
# 2002/8/20       Walking Lint  30 (DiffAutoBackup_Perl->DiffAutoBackupWithLatestWeblog_Perl)
# 2002/8/20       Walking Lint  18 (diffAutoBackup_Perl->DiffAutoBackup_Perl)
# 2002/7/24       Walking Lint  10 (DiffAutoBackup_Perl->diffAutoBackup_Perl)
# 2002/7/24       Walking Lint  7 (notepad_Perl->DiffAutoBackup_Perl)
# 2002/7/24       Walking Lint  7 (note_Perl->notepad_Perl)

=pod

=head1 NAME

DiffWithLatestSnapShot_Perl.pl - ŐṼXibvVbgƂ diff 

=head1 DESCRIPTION

ex. perl.exe DiffWithLatestSnapShot_Perl.pl D:\tmp\cv\templates\DiffWithLatestSnapShot_Perl.pat

=head1 AUTHOR

Walking Lint

=cut

use Win32;
use Win32::Process;
use File::Basename;
$diff = $ENV{DIFF};
$diff =~ s/"//g;
$cmd = $diff;
$curfile = shift;
$curfolder = &mydirname($curfile);
opendir DIR, $curfolder or die "Cannot open $curfolder: $!";
@files = grep !/^\.\.?$/, readdir DIR;
@files = sort grep /^Snap[0-9]+$/, @files;
closedir DIR;
$latestsnapshot = $curfolder . "\\" . (pop @files) . "\\" . basename($curfile);
DebugPrint("curfile = $curfile");
DebugPrint("latestsnapshot = $latestsnapshot");
Win32::Process::Create($Win32::Process::Create::ProcessObj, $cmd, $cmd . ' "' . $curfile . '" "' . $latestsnapshot . '"', 0, DETACHED_PROCESS, ".")
or die print_error();
sub print_error {
  return Win32::FormatMessage(Win32::GetLastError());
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
