root () //  %% File: ExcludeCommentedOutImageFiles_Perl.pl CRLF Date            Author        number of nodes CRLF 2006/6/27       Walking Lint  67 CRLF 2006/6/26       Walking Lint  67 CRLF 2006/6/24       Walking Lint  66
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]]
		DESCRIPTION () //  %% can be used to clean-up commented out image files in current folder
		AUTHOR () //  %% [[Author]]
	use () // File::Copy
	$from_file (out) //   shift
	_note () // commented out (2006/6/26)
		DebugPrint () // "from_file = $from_file"
	$backup_folder (out) //   shift
	$check_only (out) //   shift
	$commented_out (out) //   0
	$indent (out) //   ''
	%commentedout_files (out) //   ()
	%not_commentedout_files (out) //   ()
	@exclude_files (out) //   ()
	open () // IN, $from_file or die("Cannot open $from_file: $!\n")
	while () // <IN>
		if () // $commented_out == 0
			if () // $_ =~ /^([\t]*)_note \(\) \/\/ commented out/
				$indent (out) //   $1 . "\t"
				$commented_out (out) //   1
		else ()
			if () // $_ =~ /^$indent/
				_ () //  %% commented out
			elsif () // $_ =~ /^([\t]*)_note \(\) \/\/ commented out/
				$indent (out) //   $1 . "\t"
			else ()
				$commented_out (out) //   0
		if () // $commented_out
			if () // $_ =~ /_part \(\) (?:[^\/]*)\/\/ (.*\.jpg)/
				$commentedout_files (inout) // {$1}  ++
				_note () // commented out (2006/6/26)
					DebugPrint () // "commented out $_"
		else ()
			if () // $_ =~ /_part \(\) (?:[^\/]*)\/\/ (.*\.jpg)/
				$not_commentedout_files (inout) // {$1}  ++
				_note () // commented out (2006/6/26)
					DebugPrint () // "not commented out $_"
			if () // $_ =~ /_text \(\) (?:[^\/]*)\/\/(?: )+\%\% (.*)/
				$text (out) //   $1
				while () // $text =~ /(?:src|href)="([^"]*)"/g
					$matched (out) //   $1
					_note () // commented out (2006/6/26)
						DebugPrint () // "matched = $matched"
					$not_commentedout_files (inout) // {$matched}  ++
	close () // IN
	foreach () // $commentedout_file (keys %commentedout_files)
		if () // defined($not_commentedout_files{$commentedout_file})
			_ () //  %% there was not commented out node
		else ()
			$image_file (out) //   $from_file
			$image_file (inout) // =~ s/\\[^\\]*$/\\$commentedout_file/
			if () // -e $image_file
				DebugPrint () // "found $image_file to exclude"
				push () // @exclude_files, $commentedout_file
	if () // $check_only != 1
		if () // not -e $backup_folder
			mkdir () // $backup_folder, 0700 or die("Cannot make $backup_folder: $!")
		foreach () // $exclude_file (@exclude_files)
			$to_file (out) //   $backup_folder . '\\' . $exclude_file
			$image_file (out) //   $from_file
			$image_file (inout) // =~ s/\\[^\\]*$/\\$exclude_file/
			move () // $image_file, $to_file
			DebugPrint () // "moved $image_file to $to_file"
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
