# File: ExtractLongNames_Perl.pl
# Date            Author        number of nodes
# 2004/4/8        Walking Lint  17
# 2004/4/8        Walking Lint  28 (ExtractLongName_Perl->ExtractLongNames_Perl)
# 2004/4/8        Walking Lint  33
# 2004/4/8        Walking Lint  33 (DeleteCommentedOut_Perl->ExtractLongName_Perl)
# 2002/12/19      Walking Lint  36
# 2002/11/10      Walking Lint  94 (Index_Perl->DeleteCommentedOut_Perl)
# 2002/11/8       Walking Lint  91
# 2002/11/6       Walking Lint  27 (Index_Perl->Index_Perl)
# 2002/11/5       Walking Lint  212 (Index_Perl->Index_Perl)
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (Index_Perl->Index_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->Index_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

ExtractLongNames_Perl.pl - extract long names

=head1 DESCRIPTION

activate as filter2

=head1 AUTHOR

Walking Lint

=cut

$count = 0;
$limit = shift;
if (not defined($limit)) {
  $limit = 250;
}
while (<STDIN>) {
  $count++;
  if ($_ =~ /^[\t]*(.{$limit,}?) \(\)/) {
    DebugPrint($count . '(' . length($1) . ") $1\n");
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
