# File: GenGraphWithGraphviz_Perl.pl
# Date            Author        number of nodes
# 2006/5/9        Walking Lint  29
# 2005/4/7        Walking Lint  25
# 2005/4/4        Walking Lint  22
# 2005/4/2        Walking Lint  19
# 2005/4/2        Walking Lint  57 (DotWriter_Perl->GenGraphWithGraphviz_Perl)
# 2003/10/20      Walking Lint  61
# 2003/10/20      Walking Lint  44 (IniWriter_Perl->DotWriter_Perl)
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85
use CVTree_Perl;
$is_smaller = shift;
$to_file = shift;
$to2_file = $to_file;
$to2_file =~ s/\..+/.dot/;
$templates_dir = $ENV{TEMPLATESFOLDER};
$perl = $ENV{PERL};
$dot = $ENV{DOT};
$dot =~ s/dot/neato/; # this is hack ...
system '"' . $perl . '" "' . $templates_dir . "\\DotWriter_Perl.pl\" " . '"' . $to2_file . '"';
$to_file =~ /\.(.+)/;
$sfx = $1;
$cmd = '"' . $dot . '"' . " -T$sfx -o $to_file \"" . $to2_file . '"';
if ($is_smaller == 1) {
  system '"' . $dot . '"' . " -Earrowsize=0.3 -Nfontsize=6 -Nheight=0.01 -Nwidth=0.02 -Nshape=plaintext -T$sfx -o \"$to_file\" \"" . $to2_file . '"';
} else {
  system '"' . $dot . '"' . " -Earrowsize=0.4 -Nfontsize=8 -Nheight=0.01 -Nwidth=0.03 -Nshape=plaintext -T$sfx -o \"$to_file\" \"" . $to2_file . '"';
}
DebugPrint("generated $to_file");
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
