# File: GenIndexFor3ColumnWithTable_Perl.pl
# Date            Author        number of nodes
# 2002/7/25       Walking Lint  66
# 2002/7/4        Walking Lint  60
# 2002/6/21       Walking Lint  59
# 2002/6/20       Walking Lint  57
# 2002/6/20       Walking Lint  53 (GenIndex2_Perl->GenIndexFor3ColumnWithTable_Perl)
# 2002/6/19       Walking Lint  53 (GenIndexForDevTechWriters_Perl->GenIndex2_Perl)
# 2002/6/18       Walking Lint  53
# 2002/6/18       Walking Lint  46 (GenIndex_Perl->GenIndexForDevTechWriters_Perl)
# 2002/5/29       Walking Lint  22
# 2002/5/22       Walking Lint  4 (DeleteMatchedLine_Perl->NewFile)
# 2002/4/28       Walking Lint  4
# 2002/4/20       Walking Lint  4
use File::Basename;
$path = shift;
print STDERR "path = $path\n";
$dir = dirname($path);
$dir =~ s/\\$//; # this is needed for ex. F:\200206.pat case ...
$file = basename($path);
$foundcontent = 0;
opendir DIR, $dir or die "opendir() failed: $!";
@files = grep !/^\.\.?$/, readdir DIR;
@files = grep /^200[0-9]+.pat$/, @files;
closedir DIR;
foreach $from_file (reverse @files) {
  if ($from_file eq $file) {
    $first = 1;
    open IN, $dir . "\\" . $from_file || die("Can't open $from_file: $!\n");
    while (<IN>) {
      if (/class="body"/) {
        $foundcontent = 1;
      } elsif ($foundcontent) {
        if (/^\t\t\t\t\t\t\t20/) {
          $_ =~ s/[\t]*//;
          ($year, $month, $day, $weekday) = split(/[\/\(\)]/, $_);
          if ($first) {
            $first = 0;
            print '<div class="li">- ' . "$year/$month</div>\n";
            print '<div class="ul">' . "\n";
          }
          if (length($weekday) != 0) {
            print '<div class="li">&nbsp;- <a href="#' . $day . '">' . $day . ' (' . $weekday . ')</a></div>' . "\n";
          } else {
            $day =~ s/ //;
            print '<div class="li">&nbsp;- <a href="#' . $day . '">' . $day . '</a></div>' . "\n";
          }
        }
      }
    }
    close IN;
    unless ($first) {
      print "</div>\n";
    }
  } else {
    $year = substr($from_file, 0, 4);
    $month = substr($from_file, 4, 2);
    print '<div class="li"><a href="' . "$year$month" . ".html" . '">';
    $month =~ s/^0//;
    print "+ $year/$month</a></div>\n";
  }
}
