# File: GenPatentMapFromAugmentedFTerm_Perl.pl
# Date            Author        number of nodes
# 2005/4/26       Walking Lint  357
# 2005/4/20       Walking Lint  275
# 2005/4/19       Walking Lint  266
# 2005/4/18       Walking Lint  236
# 2005/4/14       Walking Lint  125
# 2005/4/6        Walking Lint  105
# 2005/3/31       Walking Lint  95
# 2005/3/30       Walking Lint  95
# 2005/3/30       Walking Lint  44 (CountPatentWithAugmentedFTerm_Perl->GenPatentMapFromAugmentedFTerm_Perl)
# 2005/3/29       Walking Lint  44
use CVTree_Perl;
$is_US = shift;
$out_pat_inf = shift;
$max_num_of_pat = $out_pat_inf;
$from_file = shift;
$pat_pattern = shift;
$column = shift;
@rows = @ARGV;
foreach $row (@rows) {
  $rows{$row} = 1; # this is hack ...
}
%subrows = ();
%subrowsmisc = ();
%subcols = ();
%subcolsmisc = ();
$with_main_category = 0;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
if ($root->{CHILD} != undef) {
  $nd = $root->{CHILD};
  while ($nd != undef) {
    $nn = $nd->{NEXT};
    if ($nd->{NAME} =~ /^_/) {
      &delnode($nd);
    } else {
      last;
    }
    $nd = $nn;
  }
}
if ($#rows == -1) {
  if (($root->{CHILD} != undef) and ($root->{CHILD}->{CHILD} != undef)) {
    $node = $root->{CHILD}->{CHILD};
    while (1) {
      if ($node == undef) {
        last;
      }
      push @rows, $node->{NAME};
      $node = $node->{NEXT};
    }
    $first_row = 1;
  }
}
%def = ();
%patents = ();
%patents_with_category = ();
if (($root->{CHILD} != undef) and ($root->{CHILD}->{CHILD} != undef)) {
  $node = $root->{CHILD}->{CHILD};
  while (1) {
    if ($node == undef) {
      last;
    }
    if ($node->{CHILD} != undef) {
      $nd = $node->{CHILD};
      $main_category = $node->{NAME};
      while (1) {
        $nn = $nd->{NEXT};
        $nnnnn = $node->{NEXT}; # try this now ...
        $sub_category = $nd->{NAME};
        if (not ($sub_category =~ /^<a /)) {
          if (defined($rows{$sub_category})) { # this is top level in this case ... so ...
            $defp = $nd->{TEXT};
            if ($main_category eq $column) {
              $subcols{$sub_category} = 1;
            } else {
              $subrows{$sub_category} = 1;
            }
            $main_category2 = $sub_category;
            $first_sub = 1;
            $nd2 = $nd->{CHILD};
            while ($nd2 != undef) {
              $nn2 = $nd2->{NEXT};
              $nn3 = $nd->{NEXT};
              $sub_category = $nd2->{NAME};
              if (not ($sub_category =~ /^<a /)) {
                push @{$main_category}, $sub_category;
                if ($first_sub == 1) {
                  $first_sub = 0;
                  $def{$sub_category} = $defp . '/' . $nd2->{TEXT};
                } else {
                  $def{$sub_category} = '.../' . $nd2->{TEXT};
                }
                $cn = $nd2;
                while (1) {
                  if (($cn == $nn2) or ($cn == $nn3) or ($cn == $nnnnn)) {
                    last;
                  }
                  if ($cn->{NAME} =~ />([^<]+)</) {
                    $pat = $1;
                    if (length($pat_pattern) != 0) {
                      if ($cn->{TEXT} =~ /$pat_pattern/) {
                        $idx = $sub_category . '_' . $pat;
                        $patents{$pat}++;
                        $patents_with_category{$idx}++;
                      }
                    } else {
                      $idx = $sub_category . '_' . $pat;
                      $patents{$pat}++;
                      $patents_with_category{$idx}++;
                    }
                  }
                  $cn = &getnext($cn);
                }
              } else {
                $sub_category = $main_category2;
                if (not defined($def{$sub_category})) {
                  push @{$main_category}, $sub_category;
                  if ($main_category2 eq $column) {
                    $subcolsmisc{$sub_category} = 1;
                  } else {
                    $subrowsmisc{$sub_category} = 1;
                  }
                  if ($is_US) {
                    if ($first_sub == 1) {
                      $first_sub = 0;
                      $def{$sub_category} = $defp . '/' . 'misc';
                    } else {
                      $def{$sub_category} = '.../' . 'misc';
                    }
                  } else {
                    if ($first_sub == 1) {
                      $first_sub = 0;
                      $def{$sub_category} = $defp . '/' . '̑';
                    } else {
                      $def{$sub_category} = '.../' . '̑';
                    }
                  }
                }
                if ($nd2->{NAME} =~ />([^<]+)</) {
                  $pat = $1;
                  if (length($pat_pattern) != 0) {
                    if ($cn->{TEXT} =~ /$pat_pattern/) {
                      $idx = $sub_category . '_' . $pat;
                      $patents{$pat}++;
                      $patents_with_category{$idx}++;
                    }
                  } else {
                    $idx = $sub_category . '_' . $pat;
                    $patents{$pat}++;
                    $patents_with_category{$idx}++;
                  }
                }
              }
              $nd2 = $nn2;
            }
          } else {
            push @{$main_category}, $sub_category;
            $def{$sub_category} = $nd->{TEXT};
            $cn = $nd;
            while (1) {
              if (($cn == $nn) or ($cn == $nnnnn)) {
                last;
              }
              if ($cn->{NAME} =~ />([^<]+)</) {
                $pat = $1;
                if (length($pat_pattern) != 0) {
                  if ($cn->{TEXT} =~ /$pat_pattern/) {
                    $idx = $sub_category . '_' . $pat;
                    $patents{$pat}++;
                    $patents_with_category{$idx}++;
                  }
                } else {
                  $idx = $sub_category . '_' . $pat;
                  $patents{$pat}++;
                  $patents_with_category{$idx}++;
                }
              }
              $cn = &getnext($cn);
            }
          }
        } else {
          $sub_category = $main_category;
          if (not defined($def{$sub_category})) {
            push @{$main_category}, $sub_category;
            if ($is_US) {
              $def{$sub_category} = 'misc';
            } else {
              $def{$sub_category} = '̑';
            }
          }
          if ($nd->{NAME} =~ />([^<]+)</) {
            $pat = $1;
            if (length($pat_pattern) != 0) {
              if ($cn->{TEXT} =~ /$pat_pattern/) {
                $idx = $sub_category . '_' . $pat;
                $patents{$pat}++;
                $patents_with_category{$idx}++;
              }
            } else {
              $idx = $sub_category . '_' . $pat;
              $patents{$pat}++;
              $patents_with_category{$idx}++;
            }
          }
        }
        if ($nn == undef) {
          last;
        }
        $nd = $nn;
      }
    }
    $node = $node->{NEXT};
  }
  $first_row = 1;
  foreach $row (@rows) {
    if (not defined($subcols{$row})) { # not ($row eq $column) and not defined($subcols{$row})
      foreach $r (@{$row}) {
        if (not defined($subrows{$r}) or defined($subrowsmisc{$r})) { # must be here ...
          if ($first_row) {
            $first_row = 0;
            if ($with_main_category == 1) {
              $first_column = 1;
              foreach $c (@{$column}) {
                if ($first_column) {
                  $first_column = 0;
                  print "\t\t$c";
                } else {
                  print "\t$c";
                }
              }
              print "\n";
            }
            $first_column = 1;
            foreach $c (@{$column}) {
              if ($first_column) {
                $first_column = 0;
                if ($with_main_category == 1) {
                  print "$r\t\t$c - $def{$c}";
                } else {
                  print "\t$c - $def{$c}";
                }
              } else {
                print "\t$c - $def{$c}";
              }
            }
            print "\n";
          }
          $first_column = 1;
          if ($out_pat_inf > 0) {
            $max = 0;
            foreach $c (@{$column}) {
              $cnt = 0;
              foreach $patent (reverse sort keys %patents) { # may be slow ... think later ...
                $idx1 = $r . '_' . $patent;
                $idx2 = $c . '_' . $patent;
                if (defined($patents_with_category{$idx1}) and defined($patents_with_category{$idx2})) {
                  $idx3 = $r . '_' . $c;
                  push @{$idx3}, $patent;
                  $cnt++;
                  if ($cnt > $max) {
                    $max = $cnt;
                  }
                }
                if ($cnt == $max_num_of_pat) {
                  last;
                }
              }
            }
            if ($max > 0) {
              for ($i = 0; $i < $max; $i++) {
                $first_column = 1;
                foreach $c (@{$column}) {
                  $idx3 = $r . '_' . $c;
                  $pat = pop @{$idx3};
                  if ($first_column == 1) {
                    $first_column = 0;
                    if ($i == 0) {
                      if ($with_main_category == 1) {
                        print "$r\t$r - $def{$r}\t$pat";
                      } else {
                        print "$r - $def{$r}\t$pat";
                      }
                    } else {
                      if ($with_main_category == 1) {
                        print "\t\t$pat";
                      } else {
                        print "\t$pat";
                      }
                    }
                  } else {
                    print "\t$pat";
                  }
                }
                print "\n";
              }
            } else { # try this ...
              if ($with_main_category == 1) {
                print "$r\t$r - $def{$r}\t\n";
              } else {
                print "$r - $def{$r}\t\n";
              }
            }
          } else {
            foreach $c (@{$column}) {
              my $count = 0;
              foreach $patent (keys %patents) {
                $idx1 = $r . '_' . $patent;
                $idx2 = $c . '_' . $patent;
                if (defined($patents_with_category{$idx1}) and defined($patents_with_category{$idx2})) {
                  $count++;
                }
              }
              if ($first_column) {
                $first_column = 0;
                if ($with_main_category == 1) {
                  print "$r\t$r - $def{$r}\t$count";
                } else {
                  print "$r - $def{$r}\t$count";
                }
              } else {
                print "\t$count";
              }
            }
            print "\n";
          }
        }
      }
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
