# File: GenReverseFilter_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 18
# 2003/8/6        Walking@Lint 12
# 2002/5/22       Walking Lint  10
# 2002/4/28       Walking Lint  4 (DeleteMatchedLine_Perl->GenReverseFilter_Perl)
# 2002/4/20       Walking Lint  4
$first = 1;
$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  if ($first) {
    $first = 0;
    print $_;
  } else {
    if (/^([\t]*)([^ ]*) \(\) \/\/[ ]+\%\% ([^\n\r]*)/) {
      print $1 . $3 . " () // \%\% $2\n";
    } else {
      print $_;
    }
  }
  if ($breaklater) {
    last;
  }
}
