# File: GenStyleSheetForPrintAndSubPage_Perl.pl
# Date            Author        number of nodes
# 2003/8/20       Walking@Lint 12
# 2002/12/23      Walking Lint  10
# 2002/12/22      Walking Lint  9
# 2002/12/13      Walking Lint  18 (UpdateStatusOfLinksAtStartup_Perl->GenStyleSheetForPrintAndSubPage_Perl)
# 2002/12/12      Walking Lint  16
# 2002/12/11      Walking Lint  14
# 2002/12/6       Walking Lint  11
# 2002/11/26      Walking Lint  10
# 2002/11/22      Walking Lint  10
# 2002/11/22      Walking Lint  9 (UpdateLinksAtStartup_Perl->UpdateStatusOfLinksAtStartup_Perl)
# 2002/11/21      Walking Lint  9 (UpdateLinks_Perl->UpdateLinksAtStartup_Perl)
# 2002/8/13       Walking Lint  30 (DropArchiveAndReadOnlyAttributesOfHtmlFiles_Perl->UpdateLinks_Perl)
# 2002/7/19       Walking Lint  18 (SetFileAttr_Perl->DropArchiveAndReadOnlyAttributesOfHtmlFiles_Perl)
# 2002/7/18       Walking Lint  18 (PDFRef2ActiveXRef_Perl->SetFileAttr_Perl)
# 2001/8/15       Walking Lint  17 (Filter3_Perl->NewFile)

=pod

=head1 NAME

GenStyleSheetForPrintAndSubPage_Perl.pl - gen style sheets for print and for sub page

=head1 DESCRIPTION

ex. perl.exe GenStyleSheetForPrintAndSubPage_Perl.pl D:\HP\2Column.css

=head1 AUTHOR

Walking Lint

=cut

use strict;
my $infile = shift;
my $perl = $ENV{PERL};
$perl =~ s/"//g;
my $templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
system '"' . $perl . '" "' . $templatesfolder . '\GenStyleSheetForPrint_Perl.pl" ' . $infile;
system '"' . $perl . '" "' . $templatesfolder . '\GenStyleSheetForSubPage_Perl.pl" ' . $infile;
