# File: GenStyleSheets_Perl.pl
# Date            Author        number of nodes
# 2003/4/11       Walking Lint  27
# 2003/4/8        Walking Lint  25
# 2003/3/20       Walking Lint  18
# 2003/2/5        Walking Lint  13
# 2003/1/6        Walking Lint  10
# 2002/12/10      Walking Lint  58 (GenStyleSheetForSubPage_Perl->GenStyleSheets_Perl)
# 2002/12/9       Walking Lint  31 (GenStyleSheetForPrint_Perl->GenStyleSheetForSubPage_Perl)
# 2002/12/9       Walking Lint  30 (GenStyleSheetFromPrint_Perl->GenStyleSheetForPrint_Perl)
# 2002/12/8       Walking Lint  30 (GenStyleSheetForPrint_Perl->GenStyleSheetFromPrint_Perl)
# 2002/7/4        Walking Lint  5 (DeleteMatchedLine_Perl->GenStyleSheetForPrint_Perl)
# 2002/5/22       Walking Lint  4
# 2002/4/28       Walking Lint  4
# 2002/4/20       Walking Lint  4

=pod

=head1 NAME

[[CurrentSrcBaseName]] - gen stylesheets

=head1 DESCRIPTION

ex1. perl.exe [[CurrentSrcBaseName]] D:\HP\200304.pat

ex2. perl.exe GenStyleSheets_Perl.pl D:\HP\200304.pat 1

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
$pat_file = shift;
open IN, $pat_file or die("Cannot open $pat_file: $!\n");
while (<IN>) {
  if (($_ =~ /\t_part/) and ($_ =~ /([0-9a-zA-Z]+\.css)/)) {
    $from_file = dirname($pat_file) . "\\" . $1;
    last;
  }
}
close IN;
DebugPrint("from_file = $from_file");
$use_menu = shift;
DebugPrint("use_menu = $use_menu");
$perl = $ENV{PERL};
$perl =~ s/\"//g;
$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/\"//g;
system '"' . $perl . '" "' . $templatesfolder . '\GenStyleSheetForPrint_Perl.pl" "' . $from_file . '"';
if (defined($use_menu)) {
  system '"' . $perl . '" "' . $templatesfolder . '\GenStyleSheetForSubPage_Perl.pl" "' . $from_file . '" ' . $use_menu;
} else {
  system '"' . $perl . '" "' . $templatesfolder . '\GenStyleSheetForSubPage_Perl.pl" "' . $from_file . '"';
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
