# File: Getopt2_Perl.pl
# Date            Author        number of nodes
# 2002/12/23      Walking Lint  16
# 2002/12/23      Walking Lint  15 (Getoption{Perl->Getopt2_Perl)

=pod

=head1 NAME

Getoption{Perl.pl - sample Getopt

=head1 DESCRIPTION

ex. perl.exe Getopt2_Perl.pl -v -D -o test file1

=head1 AUTHOR

Walking Lint

=cut

use Getopt::Std;
%option = ();
getopts("vDo:", \%option);
DebugPrint("option{a} = $option{a}");
DebugPrint("option{v} = $option{v}");
DebugPrint("option{D} = $option{D}");
DebugPrint("option{o} = $option{o}");
$file = shift;
DebugPrint("file = $file");
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
