# File: Getopt3_Perl.pl
# Date            Author        number of nodes
# 2002/12/23      Walking Lint  15
# 2002/12/23      Walking Lint  15 (Getopt2_Perl->Getopt3_Perl)
# 2002/12/23      Walking Lint  15 (Getopt_Perl->Getopt2_Perl)

=pod

=head1 NAME

Getopt_Perl.pl - sample Getopt

=head1 DESCRIPTION

ex. perl.exe Getopt3_Perl.pl -verbose -Debug -output=test file1

=head1 AUTHOR

Walking Lint

=cut

use Getopt::Long;
GetOptions("verbose" => \$verbose, "Debug" => \$debug, "output=s" => \$output);
DebugPrint("a = $a");
DebugPrint("verbose = $verbose");
DebugPrint("debug = $debug");
DebugPrint("output = $output");
$file = shift;
DebugPrint("file = $file");
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
