# File: Getopt_Perl.pl
# Date            Author        number of nodes
# 2002/12/23      Walking Lint  15

=pod

=head1 NAME

Getopt_Perl.pl - sample Getopt

=head1 DESCRIPTION

ex. perl.exe Getopt_Perl.pl -v -D -o test file1

=head1 AUTHOR

Walking Lint

=cut

use Getopt::Std;
getopts("vDo:");
DebugPrint("opt_a = $opt_a");
DebugPrint("opt_v = $opt_v");
DebugPrint("opt_D = $opt_D");
DebugPrint("opt_o = $opt_o");
$file = shift;
DebugPrint("file = $file");
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
