root () // %% File: Graph_HTML.html CRLF Date            Author        number of nodes CRLF                 Walking Lint  330 CRLF 2001/12/22      Walking Lint  330 CRLF 2001/12/22      Walking Lint  330 (Graph->Graph_HTML) CRLF 2001/10/30      Walking Lint  328 CRLF 2001/10/26      Walking Lint  15
	html ()
		head ()
			title () // %% Graph Layout (example 1)
		body ()
			h1 () // %% Graph Layout (example 1)
			hr ()
			applet () // codebase="." code="Graph.class" width=400 height=400
				param () // name=edges value="joe-food,joe-dog,joe-tea,joe-cat,joe-table,table-plate/50,plate-food/30,food-mouse/100,food-dog/100,mouse-cat/150,table-cup/30,cup-tea/30,dog-cat/80,cup-spoon/50,plate-fork,dog-flea1,dog-flea2,flea1-flea2/20,plate-knife"
				param () // name=center value="joe"
				_text () //  %% alt="Your browser understands the &lt;APPLET&gt; tag but isn't running the applet, for some reason." CRLF Your browser is completely ignoring the &lt;APPLET&gt; tag!
			hr ()
			a () // href="Graph.java" %% The source
			_text () //  %% .
	_part () // Graph.java
		_ () //  %% @(#)Graph.java  1.8 98/10/28 CRLF Copyright (c) 1997, 1998 Sun Microsystems, Inc. All Rights Reserved. CRLF Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,  CRLF modify and redistribute this software in source and binary code form,  CRLF provided that i) this copyright notice and license appear on all copies of  CRLF the software; and ii) Licensee does not utilize the software in a manner  CRLF which is disparaging to Sun. CRLF This software is provided "AS IS," without a warranty of any kind. ALL  CRLF EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY  CRLF IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR  CRLF NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE  CRLF LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING  CRLF OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS  CRLF LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,  CRLF INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER  CRLF CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF  CRLF OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE  CRLF POSSIBILITY OF SUCH DAMAGES. CRLF This software is not designed or intended for use in on-line control of  CRLF aircraft, air traffic, aircraft navigation or aircraft communications; or in  CRLF the design, construction, operation or maintenance of any nuclear  CRLF facility. Licensee represents and warrants that it will not use or  CRLF redistribute the Software for such purposes.
		import () // java.util.*
		import () // java.awt.*
		import () // java.applet.Applet
		import () // java.awt.event.*
		Node () + $
			x (out) // double
			y (out) // double
			dx (out) // double
			dy (out) // double
			fixed (out) // boolean
			lbl (out) // String
		Edge () + $
			from (out) // int
			to (out) // int
			len (out) // double
		GraphPanel () + $
			Panel () +
			Runnable () + |
			MouseListener () + |
			MouseMotionListener () + |
			graph (out) // Graph
			nnodes (out) // int
			nodes[] (out) // Node  new Node[100]
			nedges (out) // int
			edges[] (out) // Edge  new Edge[200]
			relaxer (out) // Thread
			stress (out) // boolean
			random (out) // boolean
			GraphPanel () $
				graph (in) & // Graph
				this . graph (out) //   graph
				addMouseListener () // this
			findNode () $ // int
				lbl (in) & // String
				for () $ // int i = 0; i < nnodes; i++
					if () // nodes[i].lbl.equals (lbl)
						return () // i
				return () // addNode(lbl)
			addNode () $ // int
				lbl (in) & // String
				n (out) // Node  new Node()
				n.x (out) //   10 + 380 * Math.random()
				n.y (out) //   10 + 380 * Math.random()
				n.lbl (out) //   lbl
				nodes[nnodes] (out) //   n
				return () // nnodes++
			addEdge () $ // void
				from (out) & // String
				to (out) & // String
				len (out) & // int
				e (out) // Edge  new Edge()
				e.from (out) //   findNode(from)
				e.to (out) //   findNode(to)
				e.len (out) //   len
				edges[nedges++] (out) //   e
			run () // void
				me (out) // Thread  Thread.currentThread()
				while () // relaxer == me
					relax ()
					if () // random && (Math.random() < 0.03)
						n (out) // Node  nodes[(int)(Math.random() * nnodes)]
						if () // !n.fixed
							n.x (inout) // += 100 * Math.random() - 50
							n.y (inout) // += 100 * Math.random() - 50
						graph.play () / // graph.getCodeBase(), "audio/drip.au"
					try ()
						Thread.sleep () / // 100
					catch () $
						e (out) & // InterruptedException
						break ()
			relax () * $ // void
				for () $ // int i = 0; i < nedges; i++
					e (out) // Edge  edges[i]
					vx (out) // double  nodes[e.to].x - nodes[e.from].x
					vy (out) // double  nodes[e.to].y - nodes[e.from].y
					len (out) // double  Math.sqrt (vx * vx + vy * vy)
					len (out) //   (len == 0) ? .0001 : len
					f (out) // double  (edges[i].len - len) / (len * 3)
					dx (out) // double  f * vx
					dy (out) // double  f * vy
					nodes[e.to].dx (inout) // += dx
					nodes[e.to].dy (inout) // += dy
					nodes[e.from].dx (inout) // += -dx
					nodes[e.from].dy (inout) // += -dy
				for () $ // int i = 0; i < nnodes; i++
					n1 (out) // Node  nodes[i]
					dx (out) // double  0
					dy (out) // double  0
					for () $ // int j = 0; j < nnodes; j++
						if () // i == j
							continue ()
						n2 (out) // Node  nodes[j]
						vx (out) // double  n1.x - n2.x
						vy (out) // double  n1.y - n2.y
						len (out) // double  vx * vx + vy * vy
						if () // len == 0
							dx (inout) // += Math.random()
							dy (inout) // += Math.random()
						else () $
							if () $ // len < 100 * 100
								dx (inout) // += vx / len
								dy (inout) // += vy / len
					dlen (out) // double  dx * dx + dy * dy
					if () // dlen > 0
						dlen (out) //   Math.sqrt (dlen) / 2
						n1.dx (inout) // += dx / dlen
						n1.dy (inout) // += dy / dlen
				d (out) // Dimension  getSize()
				for () $ // int i = 0; i < nnodes; i++
					n (out) // Node  nodes[i]
					if () // !n.fixed
						n.x (inout) // += Math.max (-5, Math.min (5, n.dx))
						n.y (inout) // += Math.max (-5, Math.min (5, n.dy))
					if () // n.x < 0
						n.x (out) //   0
					else () $
						if () $ // n.x > d.width
							n.x (out) //   d.width
					if () // n.y < 0
						n.y (out) //   0
					else () $
						if () $ // n.y > d.height
							n.y (out) //   d.height
					n.dx (inout) // /= 2
					n.dy (inout) // /= 2
				repaint ()
			pick (out) // Node
			pickfixed (out) // boolean
			offscreen (out) // Image
			offscreensize (out) // Dimension
			offgraphics (out) // Graphics
			_note () // commented out (2001/10/31)
				Color.red (in)
			fixedColor (out) % // Color  new Color(0xf8, 0xc0, 0xc0)
			Color.pink (in)
			selectColor (out) % // Color
			Color.black (in)
			edgeColor (out) % // Color
			_note () // commented out (2001/10/31)
				nodeColor (out) % // Color  new Color(250, 220, 100)
			nodeColor (out) % // Color  new Color(0xf8, 0xf0, 0xb0)
			Color.darkGray (in)
			stressColor (out) % // Color
			Color.black (in)
			arcColor1 (out) % // Color
			Color.pink (in)
			arcColor2 (out) % // Color
			Color.red (in)
			arcColor3 (out) % // Color
			paintNode () // void
				g (out) & // Graphics
				n (out) & // Node
				fm (out) & // FontMetrics
				x (out) // int  (int)n.x
				y (out) // int  (int)n.y
				g.setColor () / // (n == pick) ? selectColor : (n.fixed ? fixedColor : nodeColor)
				w (out) // int  fm.stringWidth (n.lbl) + 10
				h (out) // int  fm.getHeight() + 4
				g.fillRect () / // x - w / 2, y - h / 2, w, h
				g.setColor () / // Color.black
				g.drawRect () / // x - w / 2, y - h / 2, w - 1, h - 1
				g.drawString () / // n.lbl, x - (w - 10) / 2, (y - (h - 4) / 2) + fm.getAscent()
			update () * // void
				g (in) & // Graphics
				d (out) // Dimension  getSize()
				if () // (offscreen == null) || (d.width != offscreensize.width) || (d.height != offscreensize.height)
					offscreen (out) //   createImage(d.width, d.height)
					offscreensize (out) //   d
					offgraphics (out) //   offscreen.getGraphics()
					offgraphics.setFont () / // getFont()
				_ () //  %% offgraphics.setColor(getBackground());
				offgraphics.setColor () / // Color.white
				offgraphics.fillRect () / // 0, 0, d.width, d.height
				for () $ // int i = 0; i < nedges; i++
					e (out) // Edge  edges[i]
					x1 (out) // int  (int)nodes[e.from].x
					y1 (out) // int  (int)nodes[e.from].y
					x2 (out) // int  (int)nodes[e.to].x
					y2 (out) // int  (int)nodes[e.to].y
					len (out) // int  (int)Math.abs (Math.sqrt ((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)) - e.len)
					offgraphics.setColor () / // (len < 10) ? arcColor1 : (len < 20 ? arcColor2 : arcColor3)
					offgraphics.drawLine () / // x1, y1, x2, y2
					if () // stress
						lbl (out) // String  String.valueOf (len)
						offgraphics.setColor () / // stressColor
						offgraphics.drawString () / // lbl, x1 + (x2 - x1) / 2, y1 + (y2 - y1) / 2
						offgraphics.setColor () / // edgeColor
				fm (out) // FontMetrics  offgraphics.getFontMetrics()
				for () $ // int i = 0; i < nnodes; i++
					paintNode () // offgraphics, nodes[i], fm
				g.drawImage () / // offscreen, 0, 0, null
			_ () //  %% 1.1 event handling
			mouseClicked () // void
				e (in) & // MouseEvent
			mousePressed () // void
				e (in) & // MouseEvent
				addMouseMotionListener () // this
				Double.MAX_VALUE (in)
				bestdist (out) // double
				x (out) // int  e.getX()
				y (out) // int  e.getY()
				for () $ // int i = 0; i < nnodes; i++
					n (out) // Node  nodes[i]
					dist (out) // double  (n.x - x) * (n.x - x) + (n.y - y) * (n.y - y)
					if () // dist < bestdist
						pick (out) //   n
						bestdist (out) //   dist
				pickfixed (out) //   pick.fixed
				pick.fixed (out) //   true
				pick.x (out) //   x
				pick.y (out) //   y
				repaint ()
				e.consume ()
			mouseReleased () // void
				e (in) & // MouseEvent
				removeMouseMotionListener () // this
				if () // pick != null
					pick.x (out) //   e.getX()
					pick.y (out) //   e.getY()
					pick.fixed (out) //   pickfixed
					pick (out) //   null
				repaint ()
				e.consume ()
			mouseEntered () // void
				e (in) & // MouseEvent
			mouseExited () // void
				e (in) & // MouseEvent
			mouseDragged () // void
				e (in) & // MouseEvent
				pick.x (out) //   e.getX()
				pick.y (out) //   e.getY()
				repaint ()
				e.consume ()
			mouseMoved () // void
				e (in) & // MouseEvent
			start () // void
				relaxer (out) //   new Thread(this)
				relaxer.start ()
			stop () // void
				relaxer (out) //   null
		Graph () +
			Applet () +
			ActionListener () + |
			ItemListener () + |
			panel (out) // GraphPanel
			controlPanel (out) // Panel
			scramble (out) // Button  new Button("Scramble")
			shake (out) // Button  new Button("Shake")
			stress (out) // Checkbox  new Checkbox("Stress")
			random (out) // Checkbox  new Checkbox("Random")
			init () // void
				setLayout () // new BorderLayout()
				panel (out) //   new GraphPanel(this)
				add () // "Center", panel
				_ () //  %% controlPanel = new Panel();  CRLF controlPanel.setBackground(Color.white);  CRLF add("South", controlPanel);
				_ () //  %% controlPanel.add(scramble); scramble.addActionListener(this);  CRLF controlPanel.add(shake); shake.addActionListener(this);  CRLF controlPanel.add(stress); stress.addItemListener(this);  CRLF controlPanel.add(random); random.addItemListener(this);
				edges (out) // String  getParameter("edges")
				for () $ // StringTokenizer t = new StringTokenizer(edges, ","); t.hasMoreTokens();
					str (out) // String  t.nextToken()
					i (out) // int  str.indexOf ('-')
					if () // i > 0
						len (out) // int  50
						j (out) // int  str.indexOf ('/')
						if () // j > 0
							len (out) //   Integer.valueOf (str.substring (j + 1)) . intValue()
							str (out) //   str.substring (0, j)
						panel.addEdge () / // str.substring (0, i), str.substring (i + 1), len
				d (out) // Dimension  getSize()
				center (out) // String  getParameter("center")
				if () // center != null
					n (out) // Node  panel.nodes[panel.findNode (center)]
					n.x (out) //   d.width / 2
					n.y (out) //   d.height / 2
					n.fixed (out) //   true
			destroy () // void
				remove () // panel
				remove () // controlPanel
			start () // void
				panel.start ()
			stop () // void
				panel.stop ()
			actionPerformed () // void
				e (in) & // ActionEvent
				src (out) // Object  e.getSource()
				if () // src == scramble
					play () // getCodeBase(), "audio/computer.au"
					d (out) // Dimension  getSize()
					for () $ // int i = 0; i < panel.nnodes; i++
						n (out) // Node  panel.nodes[i]
						if () // !n.fixed
							n.x (out) //   10 + (d.width - 20) * Math.random()
							n.y (out) //   10 + (d.height - 20) * Math.random()
					return ()
				if () // src == shake
					play () // getCodeBase(), "audio/gong.au"
					d (out) // Dimension  getSize()
					for () $ // int i = 0; i < panel.nnodes; i++
						n (out) // Node  panel.nodes[i]
						if () // !n.fixed
							n.x (inout) // += 80 * Math.random() - 40
							n.y (inout) // += 80 * Math.random() - 40
			itemStateChanged () // void
				e (in) & // ItemEvent
				src (out) // Object  e.getSource()
				on (out) // boolean  e.getStateChange() == ItemEvent.SELECTED
				if () // src == stress
					panel.stress (out) //   on
				else () $
					if () $ // src == random
						panel.random (out) //   on
			getAppletInfo () // String
				return () // "Title: GraphLayout \nAuthor: <unknown>"
			getParameterInfo () // String[][]
				info (out) // String[][]  {{"edges", "delimited string", "A comma-delimited list of all the edges."}, {"center", "string", "The name of the center node."}}
				return () // info
