# File: GrepOutline_Perl.pl
# Date            Author        number of nodes
# 2003/3/23       Walking Lint  37
# 2003/1/6        Walking Lint  40
# 2002/11/21      Walking Lint  33 (Thesaurus_Perl->GrepOutline_Perl)
# 2002/11/18      Walking Lint  32
# 2002/11/9       Walking Lint  32 (SearchThesaurus_Perl->Thesaurus_Perl)
# 2002/11/2       Walking Lint  32
# 2002/11/2       Walking Lint  32 (SearchThesaurus_Perl->SearchThesaurus_Perl)
# 2002/11/2       Walking Lint  59 (LoopUpInThesaurus_Perl->SearchThesaurus_Perl)
# 2002/9/10       Walking Lint  59 (Zips2Adrs_Perl->LoopUpInThesaurus_Perl)
# 2002/9/5        Walking Lint  58
# 2002/9/5        Walking Lint  58 (zips2adrs_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  66 (Zips2Adrs_Perl->zips2adrs_Perl)
# 2002/8/16       Walking Lint  57 (zip2adr_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  35 (zup2adr_Perl->zip2adr_Perl)
# 2002/7/15       Walking Lint  19 (grep_Perl->zup2adr_Perl)
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

GrepOutline_Perl.pl - grep outline

=head1 DESCRIPTION

perl.exe GrepOutline_Perl.pl thesaurus "D:\common\cv\templates\Thesaurus.pat"

=head1 AUTHOR

Walking Lint

=cut

$word = shift;
$from_file = shift;
$word2 = $word;
open IN, $from_file or die("Cannot open $from_file: $!\n");
while (<IN>) {
  $_ =~ /^(\t*)([^\(]+)/;
  $level = length($1);
  $name = $2;
  $name =~ s/( )+$//;
  $path{$level} = $name;
  if (/$word2/) {
    ($category, @groups) = split(/( \(\) \/\/ \%\% | \(\) \/\/  \%\% | \CRLF  \CRLF )/, $_);
    $category =~ s/^\t+//;
    foreach $i (1..$level - 1) {
      print "$path{$i} > ";
    }
    $category =~ s/($word)/*$1*/g;
    print "$category\n";
    foreach $group (@groups) {
      if ($group =~ /$word2/) {
        $group =~ s/ \CRLF /\n\t/g;
        $group =~ s/($word)/*$1*/g;
        print "\t$group\n";
      }
    }
    print "\n";
  }
}
close IN;
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
