# File: Hex2Float_Perl.pl
# Date            Author        number of nodes
# 2002/11/28      Walking Lint  10

=pod

=head1 NAME

Hex2Float_Perl.pl - hex to float

=head1 DESCRIPTION

ex. perl.exe Hex2Float_Perl.pl #f8b800

=head1 AUTHOR

Walking Lint

=cut

$hex = shift;
$hex =~ /^#([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})/;
$r = hex($1);
$g = hex($2);
$b = hex($3);
printf "%.2f %.2f %.2f\n", $r/256.0, $g/256.0, $b/256.0;
