# File: Hex2Float_Ruby.rb
# Date            Author        number of nodes
# 2002/11/16      Walking Lint  10
# 2002/11/16      Walking Lint  10 (Hex2Float_Perl->Hex2Float_Ruby)
# 2002/10/26      Walking Lint  10 (Hex2Float_Ruby->Hex2Float_Perl)

=begin

= NAME

Hex2Float_Ruby.rb - hex to float

= DESCRIPTION

ex. ruby.exe Hex2Float_Ruby.rb #f8b800

= AUTHOR

Walking Lint

=end

hex = ARGV.shift
hex =~ /^#([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})/
r = $1.hex
g = $2.hex
b = $3.hex
printf "%.2f %.2f %.2f\n", r/256.0, g/256.0, b/256.0
