root () //  %% File: HistogramAccessLog_Perl.pl CRLF Date            Author        number of nodes CRLF 2003/9/9        Walking Lint  81 CRLF 2003/9/9        Walking Lint  80 (HistogramWebLog_Perl->HistogramAccessLog_Perl) CRLF 2003/8/13       Walking Lint  80 CRLF 2003/7/14       Walking Lint  80 CRLF 2003/3/14       Walking Lint  65 CRLF 2003/3/3        Walking Lint  30 CRLF 2002/11/27      Walking Lint  144 (HistogramLog_Perl->HistogramWebLog_Perl) CRLF 2002/10/22      Walking Lint  142 CRLF 2002/7/4        Walking Lint  135 (AnalyzeLog_Perl->HistogramLog_Perl) CRLF 2002/4/4        Walking Lint  134 CRLF 2002/3/3        Walking Lint  130 CRLF 2002/3/2        Walking Lint  89 CRLF 2002/2/17       Walking Lint  89 CRLF 2002/2/16       Walking Lint  85
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - generate histogram from web server's access log
		DESCRIPTION () // %% ex1. perl.exe [[CurrentSrcBaseFile]] "D:\tmp\access.log" CRLF  CRLF ex2. perl.exe [[CurrentSrcBaseFile]] "D:\tmp\access.log" 1 50
		AUTHOR () //  %% [[Author]]
	use () // File::Basename
	use () // Socket
	$graphlength (out) //   30
	$from_file (out) //   shift %% log file
	DebugPrint () // "from_file = $from_file"
	$show_client (out) //   shift
	$convert (out) //   shift %% num of IP to convert ...
	if () // $show_client
		$use_log (out) //   1 %% this is assumed ...
	else ()
		$use_log (out) //   shift
	%accesscount (out) //   ()
	%ip2host_cache (out) //   ()
	open () // IN, $from_file || die("Can't open $from_file: $!\n")
	_note () // commented out (2003/3/14)
		$count (out) //   10000 %% actual data is near 15000 ...
	while () // <IN>
		_ () //  %% customize here according to your log file format ... actually only $url (or if specified $client_ip) is used ...
		_note () // commented out (2003/7/14)
			($client, $dummy, $date, $dummy, $dummy, $dummy, $dummy, $server_ip, $server_port, $byte, $dummy, $dummy, $kind, $url, $dummy, $dummy) (out) //   split(/, /, $_)
		($client_ip, $dummy, $dummy, $date, $date2, $kind, $url, $protocol, $port, $byte) (out) //   split(/ /, $_)
		if () // ($kind eq '"HEAD') or ($url =~ /\.(css|gif|jpg)$/) %% better ???
			next ()
		if () // $show_client
			_note () // commented out (2003/7/14)
				($dummy, $client_ip) (out) //   split(/:/, $client)
			$accesscount{$client_ip} (inout) // ++
		else ()
			$accesscount{$url} (inout) // ++
		_note () // commented out (2003/3/14)
			if () // --$count == 0
				last ()
	close () // IN
	if () // $use_log
		_note () // commented out (2003/8/13)
			$log_file (out) //   $from_file
		$log_file (out) //   dirname($from_file)
		$log_file (inout) // =~ s/[\\]*$//
		$log_file (inout) // .= '\HistogramWebLog_Perl.log'
		DebugPrint () // "log_file = $log_file"
		open () // LOG, ">$log_file" or die("Cannot open $log_file: $!\n")
		select () // LOG
		$| (out) //   1 %% no buffering ...
	$max (out) //   0
	foreach () // $key (keys %accesscount)
		$tmp (out) //   $accesscount{$key}
		$tmp (in) // > $max
		if ()
			$max (out) //   $tmp
	$elemcount (out) //   $max / $graphlength
	foreach () // $key (sort {$accesscount{$b} <=> $accesscount{$a}} keys %accesscount)
		$count (out) //   $accesscount{$key}
		$graphline (out) //   '*' x (int($accesscount{$key} / $elemcount))
		if () // $use_log %% actually $show_client ...
			if () // $convert > 0 %% not functioning as expected ^^;
				$convert (inout) // --
				$org_key (out) //   $key
				DebugPrint () // "org_key = " . $org_key
				$key (out) //   gethostbyaddr(inet_aton($key), AF_INET) or next %% die "Cannot resolve $key: $!\n"
				DebugPrint () // "key = " . $key
				LOG (out) // format
					_text () //  %% @>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> @>>>>>>>>>>>>>>>> - @>>>>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< CRLF $key $org_key $count $graphline
			else ()
				LOG (out) // format
					_text () //  %% @>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> - @>>>>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< CRLF $key $count $graphline
		else ()
			STDOUT (out) // format
				_text () //  %% @>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> - @>>>>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< CRLF $key $count $graphline
		write ()
	if () // $use_log
		close () // LOG
		DebugPrint () // "\ngenerated " . $log_file
	else ()
		print () // "\n"
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
