root () //  %% File: HistogramHistory_Perl.pl CRLF Date            Author        number of nodes CRLF 2004/6/22       Walking Lint  111 CRLF 2003/5/14       Walking Lint  104 CRLF 2003/5/14       Walking Lint  104 (HistogramHistoryWithTk_Perl->HistogramHistory_Perl) CRLF 2003/4/8        Walking Lint  104 CRLF 2002/12/23      Walking Lint  104 (HistogramHistory2_Perl->HistogramHistoryWithTk_Perl) CRLF 2002/12/23      Walking Lint  57 (HistogramHistory_Perl->HistogramHistory2_Perl) CRLF 2002/11/7       Walking Lint  57 CRLF 2002/11/7       Walking Lint  57 (HistogramHistory_Perl->HistogramHistory_Perl) CRLF 2002/10/22      Walking Lint  142 CRLF 2002/7/4        Walking Lint  135 (AnalyzeLog_Perl->HistogramLog_Perl) CRLF 2002/4/4        Walking Lint  134 CRLF 2002/3/3        Walking Lint  130 CRLF 2002/3/2        Walking Lint  89 CRLF 2002/2/17       Walking Lint  89 CRLF 2002/2/16       Walking Lint  85
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - generate histogram from function point log
		DESCRIPTION () //  %% ex. perl.exe [[CurrentSrcBaseFile]] HistogramHistoryWithTk_Perl.pat
		AUTHOR () //  %% [[Author]]
	$from_file (out) //   shift
	DebugPrint () // "from_file = $from_file"
	$use_tk (out) //   shift
	DebugPrint () // "use_tk = " . $use_tk
	if () // defined($use_tk)
		use () // Tk
		use () // File::Basename
		$width (out) //   300
		$max_height (out) //   600
		$elem_height (out) //   12
		$bottom_margin (out) //   30
		$left_margin (out) //   80
		$label_off (out) //   10
		$right_margin (out) //   20
		_note () // commented out (2004/6/22)
			$top_margin (out) //   30
		$top_margin (out) //   50
		$relative_height (out) //   0.5
	else ()
		$graph_length (out) //   30
	open () // IN, $from_file or die("Cannot open $from_file: $!\n")
	$line (out) //   <IN>
	close () // IN
	@lines (out) //   split(/ \CRLF /, $line)
	shift () // @lines
	shift () // @lines
	$latest_num_of_nodes (out) //   0
	$first (out) //   1
	foreach () // $historyitem (@lines)
		if () // length($historyitem) == 0
			next ()
		_note () // commented out (2004/6/22)
			if () // $historyitem =~ /\t/
				_ () //  %% treat new format ... but may not be implemented ... think later ...
				($key, $fp, $cg) (out) //   split(/\t/, $historyitem)
				if () // not defined($history{$key}) %% this is needed ...
					$history{$key} (out) //   $fp
				if () // $cg =~ /\(([^\)]+)\)/
					$change{$key} (out) //   $1
				if () // $first
					$first (out) //   0
					$latest_num_of_nodes (out) //   $fp
			else ()
		$historyitem (inout) // =~ /^([0-9]+)\/([0-9]+)\/([0-9]+)/
		$key (out) //   sprintf("%04d/%02d/%02d", $1, $2, $3)
		if () // $historyitem =~ / \(/ %% this is assumed
			$historyitem (inout) // =~ / \(([^\)]+)\)$/
			$change{$key} (out) //   $1
			$historyitem (inout) // =~ s/ \(([^\)]+)\)$//
		$historyitem (inout) // =~ /([0-9]+)$/
		if () // not defined($history{$key}) %% this is needed ...
			$history{$key} (out) //   $1
		if () // $first
			$first (out) //   0
			$latest_num_of_nodes (out) //   $1
	$max (out) //   0
	$count (out) //   0
	foreach () % // keys %history
		$key (in) &
		$tmp (out) //   $history{$key}
		$tmp (in) // > $max
		if ()
			$max (out) //   $tmp
		$count (inout) // ++
	$title (out) //   basename($from_file)
	$title (inout) // =~ s/\.pat$//
	if () // defined($use_tk)
		$mw (out) //   MainWindow->new
		$mw (out) // ->title("History")
		$height (out) //   $elem_height * $count + $top_margin + $bottom_margin
		if () // $height < $max_height
			$can (out) //   $mw->Canvas(-width => $width, -height => $height, -background => "white")
			->pack ()
		else ()
			$yscrl (out) //   $mw->Scrollbar()
			->pack () // -side => 'right', -fill => 'y'
			$can (out) //   $mw->Canvas(-width => $width, -height => $max_height, -background => "white", -scrollregion => [0, 0, $width, $height], -yscrollcommand =>['set', $yscrl])
			->pack ()
			$yscrl (out) // ->configure(-command => ['yview', $can])
		$xoff (out) //   $left_margin
		$yoff (out) //   $top_margin
		$elem_width (out) //   ($width - $left_margin - $right_margin) / $max
		DebugPrint () // "elem_width = $elem_width"
		$can (out) // ->createText($width / 2, $top_margin / 3, -text => $title, -anchor => 'c')
		$can (out) // ->createText($width / 2, $top_margin * 2 / 3, -text => "current num of nodes = " . $latest_num_of_nodes, -anchor => 'c')
	else ()
		$elem_num (out) //   $max / $graph_length
	foreach () % // reverse sort keys %history
		$key (in) &
		if () // $use_tk
			$can (out) // ->createText($label_off, $yoff, -text => "$key", -anchor => 'nw')
			$can (out) // ->createRectangle($xoff, $yoff + $elem_height * ((1 - $relative_height) / 2), $xoff + $elem_width * $history{$key}, $yoff + $elem_height * ((1 + $relative_height) / 2), -fill => 'green')
			$yoff (inout) // += $elem_height
		else ()
			$graphline (out) //   '*' x (int($history{$key} / $elem_num))
			STDOUT (out) // format
				_text () //  %% @<<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< CRLF $key $graphline $change{$key}
			write ()
	if () // $use_tk
		_note () // commented out (2004/6/22)
			$can (out) // ->createText($width / 2, $height - $bottom_margin / 2, -text => "current num of nodes = " . $latest_num_of_nodes, -anchor => 'c')
		MainLoop ()
	else ()
		printf () // "\n* = %d\n", $elem_num
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
