root () //  %% File: PatentClassReader_Perl.pl CRLF Date            Author        number of nodes CRLF 2006/3/29       Walking Lint  203 CRLF 2006/3/22       Walking Lint  201 CRLF 2005/4/4        Walking Lint  176 CRLF 2005/3/29       Walking Lint  176 CRLF 2005/3/25       Walking Lint  162 CRLF 2005/3/24       Walking Lint  158 CRLF 2005/3/23       Walking Lint  140 CRLF 2005/3/17       Walking Lint  138 CRLF 2005/3/8        Walking Lint  124 CRLF 2005/3/7        Walking Lint  72 CRLF 2005/3/7        Walking Lint  62 (FTermTableReader_Perl->PatentClassReader_Perl) CRLF 2005/2/10       Walking Lint  62
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - patent class reader
		DESCRIPTION () //  %% activate as filter CRLF  CRLF [[Patent Classification Home Page - Internet!http://www.uspto.gov/go/classification/]] CRLF  CRLF ex. [[Class Schedule for Class 704 DATA PROCESSING: SPEECH SIGNAL PROCESSING, LINGUISTICS, LANGUAGE TRANSLATION, AND AUDIO COMPRESSION/DECOMPRESSION!http://www.uspto.gov/go/classification/uspc704/sched704.htm]]
		AUTHOR () //  %% [[Author]]
	use () // CVTree_Perl
	$pcnums (out) //   shift
	DebugPrint () // "pcnums = $pcnums"
	$to_dir (out) //   shift
	DebugPrint () // "to_dir = $to_dir"
	if () // (length($to_dir) == 0) and (length($pcnums) != 0)
		$to_dir (out) //   $pcnums
		undef () // $pcnums
	$list_fn (out) //   $ENV{TEMPLATESFOLDER} . "\\" . "PatentClassList.txt"
	%list (out) //   ()
	if () // -e $list_fn
		open () // IN, $list_fn or die("Cannot open $list_fn: $!\n")
		while () // <IN>
			$_ (inout) // =~ s/[\r\n]+$//
			($name, $def) (out) //   split(/\t/, $_)
			$list (out) // {$name}  $def
		close () // IN
	if () // length($pcnums) == 0
		&readtable () // ''
	else ()
		@pcnums (out) //   split(/\t/, $pcnums)
		foreach () // $pcnum (@pcnums)
			&readtable () // $pcnum
	open () // OUT, ">$list_fn" or die("Cannot open $list_fn: $!\n") %% PatentClassList.txt is updated ...
	foreach () // $key (sort keys %list)
		print () // OUT "$key\t$list{$key}\n"
	close () // OUT
	readtable ()
		$pcnum (in) &
		if () // length($pcnum) == 2
			$pcnum (out) //   '0' . $pcnum
		elsif () // length($pcnum) == 1
			$pcnum (out) //   '00' . $pcnum
		if () // length($pcnum) == 0
			@lines (out) //   <STDIN>
		else ()
			use () // LWP::UserAgent
			use () // Win32::Registry
			use () // Win32::Clipboard
			use () // Jcode
			$HKEY_CURRENT_USER (out) // ->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!"
			$ref (out) // ->GetValues(\%values)
			$refproxyoverride (out) //   $values{'ProxyOverride'}
			$refproxyserver (out) //   $values{'ProxyServer'}
			$ref (out) // ->Close()
			$proxyoverride (out) //   $$refproxyoverride[2]
			$proxyoverride (inout) // =~ s/\*//g
			$proxyoverride (inout) // =~ s/;?<local>//g
			$proxyoverride (inout) // =~ s/;/\|/g %% not actually ...
			$proxyoverride (out) //   quotemeta $proxyoverride
			$proxyoverride (inout) // =~ s/\\\|/\|/g %% hack ...
			$proxyoverride (out) //   '(' . $proxyoverride . ')'
			_note () // commented out (2004/4/14)
				DebugPrint () // "proxyoverride = $proxyoverride"
			$proxyserver (out) //   $$refproxyserver[2]
			_note () // commented out (2004/4/14)
				DebugPrint () // "proxyserver = $proxyserver"
			$url (out) //   'http://www.uspto.gov/go/classification/uspc' . $pcnum . '/sched' . $pcnum . '.htm'
			_note () // commented out (2004/4/14)
				DebugPrint () // "url = $url"
			$webagent (out) //   new LWP::UserAgent
			unless () // $url =~ /$proxyoverride/
				$webagent->proxy () // ['ftp', 'http'] => "http://$proxyserver"
			_note () // commented out (2004/4/14)
				$to_file (out) //   shift
			$request (out) //   HTTP::Request->new('GET' => $url)
			$response (out) // my  $webagent->request($request)
			if () // $response->is_success
				$doc (out) //   $response->content
				$doc (inout) //   =~ s/[\n\r]+/\n/g %% not sure if needed ...
				_note () // commented out (2004/4/14)
					if () // length($to_file) != 0
						open () // OUT, ">$to_file"
						print () // OUT $doc . "\n"
						close () // OUT
						DebugPrint () // "generated $to_file"
					else ()
						print () // $doc . "\n"
					print () // $doc . "\n"
				@lines (out) //   split(/\n/, $doc)
			else ()
				DebugPrint () // "Cannot download $url"
				exit ()
		$list_fn (out) //   $ENV{TEMPLATESFOLDER} . "\\" . "PatentClassList.txt"
		@fterms (out) //   ()
		@ftermdefs (out) //   ()
		$foundtop (out) //   0
		$top (out) //   ''
		$topdef (out) //   ''
		foreach () // $line (@lines)
			_note () // commented out (2005/3/7)
				DebugPrint () // "line = $line"
			if () // ($foundtop == 0) and ($line =~ /">Class \&nbsp; ([^<]*)<\/a><\/td><td valign="top" class="ClassTitle">([^<]*)/)
				$top (out) //   $1
				$foundtop (out) //   1
				$topdef (out) //   $2
			elsif () // $line =~ />([0-9\.A-Z]+) <\/a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<\/td><td  width="85%" class="SubTtl"><b><big><\/big>([^<]+)<\/b>/
				push () // @fterms, $1
				push () // @ftermlevels, 1
				$ftermdef (out) //   $2
				$ftermdef (inout) // =~ s/^[ ]+//
				$ftermdef (inout) // =~ s/[ ]+$//
				push () // @ftermdefs, $ftermdef
			elsif () // $line =~ /Subclass ([0-9\.A-Z]+) indent level is ([0-9]+)"><\/big>([^<]+)<\/td>/
				push () // @fterms, $1
				push () // @ftermlevels, $2 + 1
				$ftermdef (out) //   $3
				$ftermdef (inout) // =~ s/^[ ]+//
				$ftermdef (inout) // =~ s/[ ]+$//
				push () // @ftermdefs, $ftermdef
			elsif () // $line =~ /Subclass   indent level is ([0-9]+)"><\/big>([^<]+)<\/td>/ %% hack
				push () // @fterms, ' '
				push () // @ftermlevels, $1 + 1
				$ftermdef (out) //   $2
				$ftermdef (inout) // =~ s/^[ ]+//
				$ftermdef (inout) // =~ s/[ ]+$//
				push () // @ftermdefs, $ftermdef
		if () // (length($pcnum) != 0) and (length($top) == 0)
			DebugPrint () // "$pcnum ͂܂"
			exit ()
		if () // length($topdef) == 0
			$topdef (out) //   'none'
		if () // &updatelist($top, $topdef) == 0 %% not obsolete
			$root (out) // my  {}
			&initnode () // $root, 'root', '', '', ''
			$node (out) //   &addchildnode($root, $top, '', '', $topdef);
			&gentree () // $node
			$to_file (out) //   ''
			if () // length($to_dir) != 0
				$to_file (out) //   $to_dir . "\\" . $top . ".pat"
			&savetree () // $root, $to_file
			if () // length($to_dir) != 0
				&savetree () // $root, '' %% hack ...
				DebugPrint () // "generated $to_file"
		else ()
			print () // "$top - obsolute?\n"
			DebugPrint () // "$top - obsolute?"
	gentree ()
		$nd (in) &
		$prevlevel (out) //   -1
		@prevlevels (out) //   ()
		push () // @prevlevels, $prevlevel %% not sure if needed ...
		$cur (out) // my  $nd
		foreach () // $fterm (@fterms)
			$name (out) //   $fterm
			_note () // commented out (2005/3/7)
				DebugPrint () // "name = $name"
			$text (out) //   shift @ftermdefs
			_note () // commented out (2005/3/7)
				DebugPrint () // "text = $text"
			$level (out) //   shift @ftermlevels
			_note () // commented out (2005/3/7)
				DebugPrint () // "level = $level"
			_ () //  %% construct tree here ...
			if () // $prevlevel < $level
				push () // @prevlevels, $prevlevel
				$cur (out) //   addchildnode($cur, $name, $kind, $type, $text)
			elsif () // $prevlevel == $level
				$cur (out) //   addnode($cur, $name, $kind, $type, $text)
			else ()
				until () // $prevlevel <= $level
					if () // $cur->{PARENT} == $root %% hack ???
						break ()
					$cur (out) //   $cur->{PARENT}
					$prevlevel (out) //   pop @prevlevels
				$cur (out) //   addnode($cur, $name, $kind, $type, $text)
			$prevlevel (out) //   $level
	updatelist ()
		$nm (in) &
		$df (in) &
		$obsolete (out) //   0
		_note () // commented out (2005/11/17)
			DebugPrint () // "$df $nm $list{$nm}"
		if () // ($df eq 'none') and defined($list{$nm}) and not ($list{$nm} eq 'none')
			$df (out) //   $list{$nm} . ' - obsolete?'
			$obsolete (out) //   1
		$list (out) // {$nm}  $df
		return () // $obsolete
	_note () // commented out (2006/3/22)
		updatelist ()
			$nm (in) &
			$df (in) &
			$fn (in) &
			_note () // commented out (2005/3/25)
				Trace () // "enter updatelist(nm = " . $nm . ", df = " . $df . ", fn = " . $fn . ")"
			open () // IN, $fn or die("Cannot open $fn: $!\n")
			while () // <IN>
				$_ (inout) // =~ s/[\r\n]+$//
				($name, $def) (out) //   split(/\t/, $_)
				$list (out) // {$name}  $def
			close () // IN
			$list (out) // {$nm}  $df
			open () // OUT, ">$fn" or die("Cannot open $fn: $!\n")
			foreach () // $key (sort {$a <=> $b} keys %list)
				print () // OUT "$key\t$list{$key}\n"
			close () // OUT
	DebugPrint ()
		$str (in) &
		print () // STDERR "$str\n"
