# File: PerlDocViewer_Perl.pl
# Date            Author        number of nodes
# 2002/7/11       Walking Lint  26
# 2002/7/11       Walking Lint  13 (Button_Perl->PerlDocViewer_Perl)
use Tk;
$opt = ' ';
$buffer = '';
sub display {
  $t0->configure(-state => 'normal');
  $t0->delete('1.0', 'end');
  open IN, "perldoc $opt $buffer |" or die "Can't exec perldoc\n";
  while (<IN>) {
    $t0->insert('end', $_);
  }
  close IN;
  $t0->configure(-state => 'disable');
  $t0->focusForce();
}
$top = MainWindow->new();
$f0 = $top->Frame();
$f1 = $top->Frame();
$l0 = $f0->Label(-text => 'Key word: ')->pack(-side => 'left');
$e0 = $f0->Entry(-textvariable => \$buffer)->pack(-side => 'left');
$e0->bind("<Return>", \&display);
$f0->pack(-anchor => 'w');
$r0 = $f1->Radiobutton(-text => 'Page, Module, Porgram', -variable => \$opt, -value => ' ')->pack(-side => 'left');
$r1 = $f1->Radiobutton(-text => 'Perl Function', -variable => \$opt, -value => ' -f ')->pack(-side => 'left');
$r2 = $f1->Radiobutton(-text => 'Perl FAQ', -variable => \$opt, -value => ' -q ')->pack(-side => 'left');
$f1->pack(-anchor => 'w');
$t0 = $top->Scrolled('Text', -scrollbars => 'se', -wrap => 'none')->pack(-expand => 1, -fill => 'both');
$e0->focus();
MainLoop();
