# File: RGBView_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 20
# 2003/8/6        Walking@Lint 19
# 2002/9/6        Walking Lint  18
# 2002/7/9        Walking Lint  26 (RGBEdit_Perl->RGBView_Perl)
# 2002/3/26       Walking Lint  16

=pod

=head1 NAME

RGBView_Perl.pl - view color of RGB

=head1 DESCRIPTION

activate as filter2

=head1 AUTHOR

Walking Lint

=cut

$color = <STDIN>;
$color =~ s/__EOF__[\n\r]*$//;
$color =~ s/\n$//;
DebugPrint("color = $color");
use Tk;
$mw = MainWindow->new();
$mw->title("RGB View");
$mw->minsize(200, 200);
$color_display = $mw->Button
  ->pack(-fill => 'both', -expand => 'yes');
DebugPrint("rgb_number = $rgb_number");
$color_display->configure(-activebackground => '#' . $color . '', -background => '#' . $color . '');
MainLoop();
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
