root () //  %% File: ReSchedule_Perl.pl CRLF Date            Author        number of nodes CRLF 2002/12/26      Walking Lint  153 CRLF 2002/12/5       Walking Lint  146 CRLF 2002/12/1       Walking Lint  48 (ReCalc_Perl->ReSchedule_Perl) CRLF 2002/11/29      Walking Lint  93 (GeppouReader_Perl->ReCalc_Perl) CRLF 2002/11/24      Walking Lint  315 (PythonReader_Perl->GeppouReader_Perl) CRLF 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl) CRLF 2002/11/23      Walking Lint  173 CRLF 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl) CRLF 2002/11/10      Walking Lint  245 CRLF 2002/11/8       Walking Lint  244 CRLF 2002/11/6       Walking Lint  225 CRLF 2002/11/1       Walking Lint  226 CRLF 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl) CRLF 2002/10/16      Walking Lint  155 CRLF 2002/10/15      Walking Lint  144 CRLF 2002/10/8       Walking Lint  137 CRLF 2002/10/1       Walking Lint  135 CRLF 2002/9/30       Walking Lint  128 CRLF 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree) CRLF 2002/9/28       Walking Lint  182 CRLF 2002/9/22       Walking Lint  178 CRLF 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl) CRLF 2002/7/15       Walking Lint  126 CRLF 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl) CRLF 2002/6/7        Walking Lint  136 CRLF 2002/6/4        Walking Lint  131 CRLF 2002/4/21       Walking Lint  120 CRLF 2002/4/12       Walking Lint  112 CRLF 2002/4/4        Walking Lint  85
	_backup ()
	_doc ()
		NAME () //  %% ReSchedule_Perl.pl - re-schedule
		DESCRIPTION () //  %% ex. perl.exe ReSchedule_Perl.pl schedule2003.pat
		AUTHOR () //  %% [[Author]]
	use () // lib '.'
	use () // CVTree_Perl
	use () // Time::localtime
	use () // Time::Local
	_note () // commented out (2002/12/5)
		use () // Date::Calc
		qw () // Add_Delta_Days
		$year () //   2002
		$month () //   12
		$day () //   5
	_note () // commented out (2002/12/5)
		$nextdate (out) //   &add_delta_days('2002/12/5()', 10)
		DebugPrint () // "nextdate = $nextdate"
		exit ()
	@yobi (out) //   ('', '', '', '', '', '', 'y')
	$from_file (out) //   shift
	DebugPrint () // "from_file = $from_file"
	$to_file (out) //   $from_file
	$root (out) // my  {}
	&initnode () // $root, 'root'
	&gentree () // $root, $from_file
	_note () // commented out (2002/12/1)
		&printtree () // $root, '', '  '
		exit ()
	&recalc () // $root
	&reschedule () // $root, ''
	&savetree () // $root, $to_file
	DebugPrint () // "modified $to_file"
	add_delta_days ()
		$date (in) &
		$days (in) &
		_note () // commented out (2002/12/5)
			Trace () // "enter add_delta_days($date, $days)"
		($year, $month, $day) (out) //   split(/[\/ \(]/, $date)
		$time (out) //   timelocal(0, 0, 0, $day, $month - 1, $year - 1900)
		DebugPrint () // "time = $time"
		$count (out) //   $days
		_note () // commented out (2002/12/5)
			DebugPrint () // "count = $count"
		while () // $count > 0
			$time (inout) // += 60 * 60 * 24
			$tm (out) //   localtime($time)
			_note () // commented out (2002/12/5)
				DebugPrint () // "tm = $tm"
			$lastyear (out) //   $tm->year + 1900
			$lastmonth (out) //   $tm->mon + 1
			$lastday (out) //   $tm->mday
			_note () // commented out (2002/12/5)
				($lastyear, $lastmonth, $lastday) (out) //   ($tm->year + 1900, $tm->mon + 1, $tm->mday)
			if () // not &ishoriday($lastyear, $lastmonth, $lastday)
				$count (inout) // --
		$lastdate (out) // my  sprintf("%s/%02d/%02d", $lastyear, $lastmonth, $lastday)
		_note () // commented out (2002/12/5)
			DebugPrint () // int($lastyear + int($lastyear / 4) - int($lastyear / 100) + int($lastyear / 400) + int((13 * $lastmonth + 8) / 5) + $lastday) % 7
		$lastdate (inout) // .= '(' . $yobi[int($lastyear + int($lastyear / 4) - int($lastyear / 100) + int($lastyear / 400) + int((13 * $lastmonth + 8) / 5) + $lastday) % 7] . ')'
		return () // $lastdate
	day_of_week () //  %% [[Re: Getting Day of Week for a specific date!http://granite.unh.edu/pasnews/msg00674.html]]
		$y (in) &
		$m (in) &
		$d (in) &
		@t (out) //   (0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4)
		$y (inout) // -= ($m < 3)
		return () // ($y + int($y / 4) - int($y / 100) + int($y / 400) +$t[$m - 1] + $d) % 7
	ishoriday ()
		$year (in) &
		$month (in) &
		$day (in) &
		$res (out) //   0
		$yobi (out) //   &day_of_week($year, $month, $day)
		if () // $yobi == 0 or $yobi == 6
			$res (out) //   1
		_ () //  %% add here some more checks for other horidays ...
		return () // $res
	normalize ()
		$date (in) &
		($year, $month, $day) (out) //   split(/[\/ \(]/, $date)
		$date (out) //   sprintf("%s/%02d/%02d", $year, $month, $day)
		$date (inout) // .= '(' . $yobi[&day_of_week($year, $month, $day)] . ')'
		return () // $date
	recalc ()
		$nd (in) &
		_note () // commented out (2002/12/1)
			Trace () // "enter($nd->{NAME})"
		$val (out) // my  0
		if () // defined($nd->{CHILD})
			$cn (out) // my  $nd->{CHILD}
			while () // 1
				if () // not $cn->{NAME} =~ /^_/
					$val (inout) // += &recalc($cn)
				if () // not defined($cn->{NEXT})
					last ()
				$cn (out) //   $cn->{NEXT}
			if () // not ($nd->{NAME} eq 'root')
				_note () // commented out (2002/12/5)
					$nd (out) // ->{TEXT}  $val
				$nd (out) // ->{TYPE}  $val
			_note () // commented out (2002/12/5)
				if () // defined($nd->{TYPE})
					$val (out) //   $cn->{TYPE}
					$val (inout) // =~ s/^[ ]*//
		else ()
			$val (out) //   $nd->{TYPE}
			$val (inout) // =~ s/^[ ]*//
		return () // $val
	reschedule ()
		$nd (in) &
		$date (in) &
		Trace () // "enter reschedule($nd->{NAME}, $date)"
		if () // not $nd->{NAME} eq 'root'
			if () // length($date) == 0
				$text (out) //   $nd->{TEXT}
				if () // $text =~ / - /
					($date, $dummy) (out) //   split(/ - /, $text)
				else ()
					$date (out) //   $text
				$date (out) //   &normalize($date)
		$nextdate (out) // my  $date
		$lastdate (out) // my  $nextdate
		if () // defined($nd->{CHILD})
			$cn (out) // my  $nd->{CHILD}
			while () // 1
				if () // not $cn->{NAME} =~ /^_/
					if () // $nd->{NAME} eq 'root' %% may be hack ... think later ...
						($lastdate, $nextdate) (out) //   &reschedule($cn, '')
					else ()
						($lastdate, $nextdate) (out) //   &reschedule($cn, $nextdate)
				if () // not defined($cn->{NEXT})
					last ()
				$cn (out) //   $cn->{NEXT}
		else ()
			if () // length($date) != 0
				if () // $nd->{TYPE} > 1
					$lastdate (out) //   &add_delta_days($date, $nd->{TYPE} - 1)
				$nextdate (out) //   &add_delta_days($date, $nd->{TYPE})
		if () // length($date) != 0
			if () // (length($lastdate) != 0) and (not $date eq $lastdate)
				$nd (out) // ->{TEXT}  $date . ' - ' . $lastdate
			else ()
				$nd (out) // ->{TEXT}  $date
		DebugPrint () // "lastdate = $lastdate"
		DebugPrint () // "nextdate = $nextdate"
		return () // ($lastdate, $nextdate)
	DebugPrint ()
		$str (in) &
		print () // STDERR $str . "\n"
	Trace ()
		$str (in) &
		print () // STDERR $str . "\n"
