# File: RefFromClipboard_Perl.pl
# Date            Author        number of nodes
# 2002/10/2       Walking Lint  39
# 2002/9/29       Walking Lint  28 (SplitLine_Perl->RefFromClipboard_Perl)
# 2002/7/4        Walking Lint  13 (EncloseLinesWithTag_Perl->SplitLine_Perl)
# 2002/7/4        Walking Lint  7 (DeleteNotMatchedLine_Perl->EncloseLinesWithTag_Perl)
# 2002/6/14       Walking Lint  6
# 2002/4/24       Walking Lint  4
# 2002/4/20       Walking Lint  4 (DeleteMatchedLine_Perl->DeleteNotMatchedLine_Perl)

=pod

=head1 NAME

RefFromClipboard_Perl.pl - gen ref from clipbaord

=head1 DESCRIPTION

ex. perl.exe RefFromClipboard_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use Win32::Clipboard;
$CLIP = Win32::Clipboard();
$line = $CLIP->Get();
$line =~ s/\r//g;
$line =~ s/[ ]*\n/\n/g;
@lines = split(/\n/, $line);
$maxlinelength = 80;
print '<div class="ref">' . "\n";
foreach $line (@lines) {
  @words = split(/\s/, $line);
  $line = '';
  $linelength = 0;
  foreach $word (@words) {
    $wordlength = length($word);
    if ($linelength == 0) {
      $line = $word;
      $linelength = $wordlength;
    } elsif ($linelength + $wordlength > $maxlinelength) {
      print "$line\n";
      $line = $word;
      $linelength = $wordlength;
    } else {
      $line .= ' ' . $word;
      $linelength += 1 + $wordlength;
    }
  }
  if ($linelength != 0) {
    print "$line";
  }
  print "\n";
}
print '</div>';
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
