# File: SaveImageInClipboard_Python.py
# Date            Author        number of nodes
# 2002/9/25       Walking Lint  15
# NAME
# 
#   SaveImageInClipboard_Python.py - save image in clipboard
# 
# DESCRIPTION
# 
#   ex. python.exe SaveImageInClipboard_Python.py "D:\My Weblog\clipboard.bmp"
# 
# AUTHOR
# 
#   [[Author]]
from wxPython import wx
import sys
def DebugPrint(str):
  sys.stderr.write(str + "\n")
filename = sys.argv[1]
DebugPrint("filename = " + filename)
if wx.wxTheClipboard.Open():
  if wx.wxTheClipboard.IsSupported(wx.wxDataFormat(wx.wxDF_BITMAP)):
    dobj = wx.wxBitmapDataObject()
    wx.wxTheClipboard.GetData(dobj)
    bmp = dobj.GetBitmap()
    bmp.SaveFile(filename, wx.wxBITMAP_TYPE_BMP)
    wx.wxTheClipboard.Close
