# File: SplitWords_Perl.pl
# Date            Author        number of nodes
# 2003/8/30       Walking@Lint 36
# 2003/8/30       Walking@Lint 27 (Statistic_Perl->SplitWords_Perl)
# 2003/8/30       Walking@Lint 27
# 2003/8/6        Walking@Lint 21
# 2003/4/9        Walking Lint  15
# 2003/4/9        Walking Lint  15 (InfoText_Perl->Statistic_Perl)
# 2003/1/14       Walking Lint  15
# 2003/1/14       Walking Lint  15 (Info_Perl->InfoText_Perl)
# 2002/11/28      Walking Lint  15
# 2002/11/22      Walking Lint  15 (Count_Perl->Info_Perl)
# 2002/10/21      Walking Lint  11 (ShowInfo_Perl->Count_Perl)
# 2002/9/23       Walking Lint  11 (ShowInfo_Perl->ShowInfo_Perl)
# 2002/9/6        Walking Lint  19 (RGBView_Perl->ShowInfo_Perl)
# 2002/7/9        Walking Lint  26 (RGBEdit_Perl->RGBView_Perl)
# 2002/3/26       Walking Lint  16

=pod

=head1 NAME

SplitWords_Perl.pl - split words

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$separator = '(\.|,|\?|:|\(|\))';
@texts = ();
$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  push @texts, $_;
  if ($breaklater) {
    last;
  }
}
$text = join('', @texts);
$text =~ s/$separator/$1 /g;
@words = split(/[\t\n ]+/, $text);
$firstword = '';
$secondword = '';
$thirdword = '';
foreach $word (@words) {
  $firstword = $secondword;
  $secondword = $thirdword;
  $thirdword = $word;
  $thirdword2 = $thirdword;
  $thirdword2 =~ s/$separator$//;
  if (length($firstword) != 0) {
    print "$firstword $secondword $thirdword2\n";
  }
  if ($thirdword =~ /$separator$/) {
    $firstword = '';
    $secondword = '';
    $thirdword = '';
  }
}
