root () //  %% File: TextWithHierarchyReader_Perl.pl CRLF Date            Author        number of nodes CRLF 2004/7/21       Walking Lint  124 CRLF 2004/4/15       Walking Lint  103 CRLF 2003/10/3       Walking@Lint 106 CRLF 2003/5/17       Walking Lint  98 CRLF 2003/5/8        Walking Lint  92 CRLF 2003/5/8        Walking Lint  170 (TextWithStructureReader_Perl->TextWithHierarchyReader_Perl) CRLF 2003/5/8        Walking Lint  170 CRLF 2003/5/8        Walking Lint  315 (PythonReader_Perl->TextWithStructureReader_Perl) CRLF 2002/12/1       Walking Lint  315 CRLF 2002/11/24      Walking Lint  315 CRLF 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl) CRLF 2002/11/23      Walking Lint  173 CRLF 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl) CRLF 2002/11/10      Walking Lint  245 CRLF 2002/11/8       Walking Lint  244 CRLF 2002/11/6       Walking Lint  225 CRLF 2002/11/1       Walking Lint  226 CRLF 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl) CRLF 2002/10/16      Walking Lint  155 CRLF 2002/10/15      Walking Lint  144 CRLF 2002/10/8       Walking Lint  137 CRLF 2002/10/1       Walking Lint  135 CRLF 2002/9/30       Walking Lint  128 CRLF 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree) CRLF 2002/9/28       Walking Lint  182 CRLF 2002/9/22       Walking Lint  178 CRLF 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl) CRLF 2002/7/15       Walking Lint  126 CRLF 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl) CRLF 2002/6/7        Walking Lint  136 CRLF 2002/6/4        Walking Lint  131 CRLF 2002/4/21       Walking Lint  120 CRLF 2002/4/12       Walking Lint  112 CRLF 2002/4/4        Walking Lint  85
	_doc ()
		NAME () //  %% [[CurrentSrcBaseFile]] - txt with hierarchy reader
		DESCRIPTION () //  %% activate as plug-in or filter
		AUTHOR () //  %% [[Author]]
	use () // lib '.'
	use () // CVTree_Perl
	use () // File::Basename
	use () // Time::localtime
	$from_file (out) //   shift
	DebugPrint () // "from_file = $from_file"
	$to_file (out) //   $from_file
	$to_file (inout) // =~ s/\..+/.pat/
	$root (out) // my  {}
	$tm (out) //   localtime
	$basename (out) //   ''
	if () // length($from_file) != 0
		$basename (out) //   basename($from_file)
	else ()
		$basename (out) //   'NewFile.txt'
	$file_comment (out) //   'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF '
	$date (out) //   sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday)
	$file_comment (inout) // .=  $date
	&initnode () // $root, 'root', '', '', $file_comment
	&gentree () // $root, $from_file
	_note () // commented out (2002/11/24)
		&printtree () // $root, '', '  '
	&savetree () // $root, $to_file
	DebugPrint () // "generated $to_file"
	gentree ()
		$nd (in) &
		$from_file (in) &
		_note () // commented out (2002/11/23)
			Trace () // "enter gentree($nd, $from_file)"
		_note () // commented out (2002/9/30)
			DebugPrint () // "from_file = $from_file"
		_ () //  %% gen tree from fn ...
		$prevname (out) //   ''
		$previndentedcomment (out) //   ''
		$prevlevel (out) //   -1
		@prevlevels (out) //   ()
		push () // @prevlevels, $prevlevel %% not sure if needed ...
		$cur (out) // my  $nd
		$first (out) //   1
		if () // length($from_file) != 0
			open () // IN, $from_file || die("Can't open $from_file: $!\n")
			$infilehandle (out) //   'IN' %% see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
		else ()
			$infilehandle (out) //   'STDIN'
		$name (out) //   ''
		$text (out) //   ''
		$firsttext (out) //   1
		while () // <$infilehandle>
			_note () // commented out (2002/11/6)
				DebugPrint () // "line = $_"
			if () // (length($_) != 0)
				_ () //  %% should treat following text ... think ...
				_note () // commented out (2004/7/21)
					chop () // $_
				$_ (inout) // =~ s/[\n\r]+$//
				$_ (inout) // =~ /^(\.*)(.*)/
				$level (out) //   length($1)
				DebugPrint () // "level = $level"
				_note () // commented out (2004/7/21)
					$tmpname (out) //   $2
				$name (out) //   $2
				DebugPrint () // "name = $name"
				_ () //  %% construct tree here ...
				if () // $level != 0
					if () // length($name) != 0 %% this is assumed ...
						if () // $prevlevel < $level
							push () // @prevlevels, $prevlevel
							_note () // commented out (2004/7/21)
								$cur (out) //   addchildnode($cur, $name, '', '', $text)
							$cur (out) //   addchildnode($cur, $name, '', '', '')
						elsif () // $prevlevel == $level
							_note () // commented out (2004/7/21)
								$cur (out) //   addnode($cur, $name, '', '', $text)
							$cur (out) //   addnode($cur, $name, '', '', '')
						else ()
							until () // $prevlevel <= $level
								$cur (out) //   $cur->{PARENT}
								$prevlevel (out) //   pop @prevlevels
							_note () // commented out (2004/7/21)
								$cur (out) //   addnode($cur, $name, $kind, $type, $text)
							$cur (out) //   addnode($cur, $name, $kind, $type, '')
						$prevlevel (out) //   $level
					_note () // commented out (2004/7/21)
						else ()
						$name (out) //   $tmpname
						$text (out) //   ''
					$firsttext (out) //   1
				else ()
					if () // $firsttext
						$firsttext (out) //   0
						_note () // commented out (2004/7/21)
							$text (out) //   $_
						$cur->{TEXT} (out) //   $_
					else ()
						_note () // commented out (2004/7/21)
							$text (inout) // .= ' CR' . 'LF ' . $_
						$cur->{TEXT} (inout) // .= ' CR' . 'LF ' . $_
		_note () // commented out (2004/7/21)
			if () // length($name) != 0 %% this is assumed ...
				if () // $prevlevel < $level
					DebugPrint () // "1 name = $name"
					push () // @prevlevels, $prevlevel
					$cur (out) //   addchildnode($cur, $name, '', '', $text)
				elsif () // $prevlevel == $level
					DebugPrint () // "2 name = $name"
					$cur (out) //   addnode($cur, $name, '', '', $text)
				else ()
					DebugPrint () // "3 name = $name"
					until () // $prevlevel <= $level
						$cur (out) //   $cur->{PARENT}
						$prevlevel (out) //   pop @prevlevels
					$cur (out) //   addnode($cur, $name, '', '', $text)
		if () // length($from_file) != 0
			close () // IN
	DebugPrint ()
		$str (in) &
		print () // STDERR $str . "\n"
	Trace ()
		$str (in) &
		print () // STDERR $str . "\n"
