# File: ThumbnailFile_Python.py
# Date            Author        number of nodes
# 2003/8/1        Walking Lint  30
# 2003/7/31       Walking Lint  29
# 2003/7/31       Walking Lint  33 (ThumbnailFolder_Python->ThumbnailFile_Python)
# 2003/7/31       Walking Lint  33
# 2003/7/31       Walking Lint  30 (Thumbnail_Python->ThumbnailFolder_Python)
# 2003/7/30       Walking Lint  25
# 2002/12/7       Walking Lint  21
# 2002/9/13       Walking Lint  18
# 2002/9/13       Walking Lint  3 (viewer->Thumbnail_Python)

# NAME

# ThumbnailFile_Python.py - generate thumnail for image

# DESCRIPTION

# ex. python.exe ThumbnailFile_Python.py |

# AUTHOR

# Walking Lint

import os
import re
import string
import sys
import PIL.Image
def DebugPrint(str):
  sys.stderr.write(str + "\n")
infile = sys.argv[1]
rep = re.compile('\.jpg$')
rep2 = re.compile('_small\.jpg$')
if rep.search(infile) != None and rep2.search(infile) == None:
  outfile = infile
  outfile = string.replace(infile, '.jpg', '_small.jpg')
  DebugPrint("generated " + outfile)
  try:
    im = PIL.Image.open(infile)
    im = im.convert('RGB')
    im.thumbnail((60, 60))
    im.save(outfile, "JPEG")
  except IOError:
    print "cannot create thumbnail for" . infile
