# File: TimeServer_Perl.pl
# Date            Author        number of nodes
# 2002/11/4       Walking Lint  14
# 2002/10/14      Walking Lint  10
# 2002/10/14                    16

=pod

=head1 NAME

TimeServer_Perl.pl - Server which returns time

=head1 DESCRIPTION

ex. perl.exe TimeServer_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use IO::Socket;
$server_sock = new IO::Socket::INET (LocalPort => 2345, Listen => $SOMAXCONN, Proto => 'tcp', Reuse => 1);
unless ($server_sock) {
  die "Cannot create server socket; $!";
}
while ($sock_to_client = $server_sock->accept()) {
  $time = localtime();
  print $sock_to_client "$time\n";
  $sock_to_client->close();
}
close $server_sock;
print "Server going down\n";
