# File: Type2Text_Perl.pl
# Date            Author        number of nodes
# 2003/3/10       Walking Lint  28
# 2002/11/6       Walking Lint  27 (SortItems_Perl->Type2Text_Perl)
# 2002/11/5       Walking Lint  212 (SortItems_Perl->SortItems_Perl)
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (SortItems_Perl->SortItems_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->SortItems_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

Type2Text_Perl.pl - type -> text

=head1 DESCRIPTION

activate as file->program->Type2Text

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
my $root = {};
&initnode($root, 'root', '', '', '');
$from_file = shift;
&gentree($root, $from_file);
&type2text($root);
&savetree($root, $from_file);
sub type2text {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    $cn = $nd->{CHILD};
    while (1) {
      $cn->{TEXT} = $cn->{TYPE};
      $cn->{TYPE} = '';
      type2text($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
