# File: Upload_Perl.pl
# Date            Author        number of nodes
# 2003/12/9       Walking Lint  43
# 2003/12/8       Walking Lint  43
# 2003/12/6       Walking Lint  40
# 2003/12/6       Walking Lint  10 (ftpdir->Upload_Perl)
# 2003/12/6       Walking Lint  8

=pod

=head1 NAME

Upload_Perl.pl - upload files

=head1 DESCRIPTION

ex. perl.exe Upload_Perl.pl [[CurerntFile]] index.html rssj.xml CategorizedLink.html

=head1 AUTHOR

Walking Lint

=cut

use Net::FTP;
use File::Basename;
$hostname = $ENV{FtpHostName};
DebugPrint("hostname = $hostname");
$username = $ENV{FtpUserName};
$password = $ENV{FtpPassWord};
$remotedir = $ENV{FtpRemoteDir};
DebugPrint("remotedir = $remotedir");
DebugPrint("");
$arg = shift @ARGV;
if (length($arg) == 0) {
  exit;
}
$dirname = mydirname($arg);
$arg =~ s/\.pat$/.html/;
@files = ();
push @files, $arg;
foreach $arg (@ARGV) {
  push @files, $dirname . '\\' . $arg;
}
$ftp = Net::FTP->new($hostname);
$ftp->login($username, $password);
$ftp->cwd($remotedir);
foreach $file (@files) {
  $ftp->put($file, basename($file));
  DebugPrint("transfered $file");
}
$ftp->quit();
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
