# File: ViewMemo2_Perl.pl
# Date            Author        number of nodes
# 2005/2/3        Walking Lint  88
# 2005/2/3        Walking Lint  88 (ViewMemo_Perl->ViewMemo2_Perl)
# 2003/5/9        Walking Lint  88
# 2003/3/23       Walking Lint  87
# 2003/3/2        Walking Lint  89
# 2003/2/25       Walking Lint  64
# 2002/11/27      Walking Lint  56
# 2002/11/27      Walking Lint  52 (MemoView_Perl->ViewMemo_Perl)
# 2002/11/21      Walking Lint  33 (Thesaurus_Perl->MemoView_Perl)
# 2002/11/18      Walking Lint  32
# 2002/11/9       Walking Lint  32 (SearchThesaurus_Perl->Thesaurus_Perl)
# 2002/11/2       Walking Lint  32
# 2002/11/2       Walking Lint  32 (SearchThesaurus_Perl->SearchThesaurus_Perl)
# 2002/11/2       Walking Lint  59 (LoopUpInThesaurus_Perl->SearchThesaurus_Perl)
# 2002/9/10       Walking Lint  59 (Zips2Adrs_Perl->LoopUpInThesaurus_Perl)
# 2002/9/5        Walking Lint  58
# 2002/9/5        Walking Lint  58 (zips2adrs_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  66 (Zips2Adrs_Perl->zips2adrs_Perl)
# 2002/8/16       Walking Lint  57 (zip2adr_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  35 (zup2adr_Perl->zip2adr_Perl)
# 2002/7/15       Walking Lint  19 (grep_Perl->zup2adr_Perl)
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

ViewMemo2_Perl.pl - grep memo

=head1 DESCRIPTION

perl.exe ViewMemo2_Perl.pl  C:\memo\cv\templates\Memo2.pat

=head1 AUTHOR

Walking Lint

=cut

$word = shift;
$from_file = shift;
$category_only = shift;
if (not defined($from_file)) {
  $templatesfolder = $ENV{TEMPLATESFOLDER};
  $templatesfolder =~ s/"//g;
  $from_file = $templatesfolder . '\Memo2.pat';
}
open IN, $from_file or die("Cannot open $from_file: $!\n");
$first = 1;
while (<IN>) {
  if ($first) { # skip root
    $first = 0;
    next;
  }
  $_ =~ /^(\t*)([^\(]+)/;
  $level = length($1);
  $name = $2;
  $name =~ s/( )+$//;
  $path{$level} = $name;
  if (/$word/i) {
    ($category, $groups) = split(/\(\) \+|\(\) \-|\(\)|\(in\)|\(out\)|\(inout\)/, $_, 2);
    ($kind, $groups) = split(/\/\/ /, $groups, 2);
    if ($groups =~ /\%\% /) {
      ($type, $groups) = split(/\%\% /, $groups, 2);
      @groups = split(/ \CRLF  \CRLF /, $groups);
    } else { # not actually ...
      $type = $groups;
    }
    $type =~ s/[ ]+$//;
    if (length($type) != 0) {
      unshift @groups, $type;
    }
    $category =~ s/[ ]+$//;
    $category =~ s/^\t+//;
    $matched_category = 0;
    if ($category =~ /$word/i) {
      $matched_category = 1;
    } else {
      if ($category_only) {
        next;
      }
    }
    $foundcommentout = 0;
    foreach $i (1..$level - 1) {
      $path = $path{$i};
      print "$path > ";
    }
    if ($foundcommentout) {
      next;
    }
    print "$category\n";
    $foundsome = 0;
    foreach $group (@groups) {
      if ($group =~ /$word/) {
        $group =~ s/ \CRLF /\n\t/g;
        $group =~ s/($word)/*$1*/g;
        $group =~ s/[\n]+$//;
        $group .= "\n"; # think later ...
        print "\t$group";
        $foundsome = 1;
      }
    }
    if (not $foundsome) {
      if (defined(@groups[0])) {
        print "\t@groups[0]\n";
      }
    } else {
      print "\n";
    }
  }
}
close IN;
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
