root () //  %% File: Weblogs_Perl.pl CRLF Date            Author        number of nodes CRLF 2003/3/3        Walking Lint  102 CRLF 2002/12/17      Walking Lint  100 (GenWeblogs_Perl->Weblogs_Perl) CRLF 2002/11/21      Walking Lint  96 CRLF 2002/11/19      Walking Lint  94 CRLF 2002/11/6       Walking Lint  86 CRLF 2002/10/15      Walking Lint  81 CRLF 2002/9/21       Walking Lint  168 CRLF 2002/8/31       Walking Lint  156
	_backup ()
	_doc ()
		NAME () //  %% Weblogs_Perl.pl - generate Weblogs section and Weblogs.html
		DESCRIPTION () //  %% ex. perl.exe Weblogs CRLF  CRLF meaning of flags in kind CRLF  CRLF ! - exclude
		AUTHOR () //  %% [[Author]]
	use () // lib '.'
	use () // CVTree_Perl
	use () // Time::localtime
	$tm (out) //   localtime
	$dateandtime (out) //   sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec)
	$templatesfolder (out) //   $ENV{TEMPLATESFOLDER}
	$weblogfolder (out) //   $ENV{WEBLOGFOLDER}
	_ () //  %% set parameters
		_note () // commented out (2002/10/15)
			$link_file (out) //   shift
		$link_file (out) //   $templatesfolder . '\Link.pat'
		DebugPrint () // "link_file = $link_file"
		_note () // commented out (2002/10/15)
			$weblog_file (out) //   shift
		$weblog_file (out) //   $weblogfolder . '\Weblogs.html'
		DebugPrint () // "weblog_file = $weblog_file"
		_note () // commented out (2002/10/15)
			$ParentTitle (out) //   shift
		$ParentTitle (out) //   'Revenge of My Two Cents' %% customize here
		DebugPrint () // "ParentTitle = $ParentTitle"
		_note () // commented out (2002/10/15)
			$ParentURL (out) //   shift
		$ParentURL (out) //   'index.html'
		DebugPrint () // "ParentURL = $ParentURL"
		_note () // commented out (2002/10/15)
			$CSSTemplate (out) //   shift
		$CSSTemplate (out) //   '2ColumnForSubPage.css' %% customize here
		DebugPrint () // "CSSTemplate = $CSSTemplate"
		_note () // commented out (2002/10/15)
			$copyright_file (out) //   shift
		$copyright_file (out) //   $weblogfolder . '\copyright.html'
		open () // IN, $copyright_file || die("Cannot open $copyright_file: $!\n")
		@copyrights (out) //   <IN>
		close () // IN
		$copyright (out) //   join('', @copyrights)
		DebugPrint () // "copyright = $copyright"
	$genfile (out) //   1 %% change here if needed ...
	$genrsslink (out) //   0 %% change here if needed ...
	$root (out) // my  {}
	&initnode () // $root, 'root', '', '', ''
	&gentree () // $root, $link_file
	&genlinks () // $root, $weblog_file
	DebugPrint () // "generated $weblog_file"
	_note () // commented out (2002/8/31)
		&printtree () // $root, '  '
	DebugPrint ()
		$str (in) &
		print () // STDERR $str . "\n"
	genlinks ()
		$nd (in) &
		$to_file (in) &
		if () // defined($nd->{CHILD})
			my $first (out) //   1
			$cn (out) //   $nd->{CHILD}
			while () // 1
				if () // ($cn->{NAME} =~ /^_/) or ($cn->{KIND} =~ /\!/) %% actually _node is already deleted ...
					_ () //  %% skip
				else ()
					if () // $first
						$first (out) //   0
						if () // $genfile
							open () // OUT, ">$to_file"
							<<END (in) //  %% <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN"> CRLF <html> CRLF <head> CRLF <title>book list</title> CRLF <meta http-equiv="content-type" content="text/html;charset=Shift_JIS" /> CRLF <meta http-equiv="content-style-type" content="text/css" /> CRLF <link rel="stylesheet" type="text/css" href="$CSSTemplate" /> CRLF </head> CRLF <body> CRLF <table class="navi"><tr><td class="path"><a href="$ParentURL">$ParentTitle</a> > Weblogs</td></tr></table> CRLF <h3>Weblogs</h3> CRLF <p> CRLF <ol>
							print () // OUT
						<<END (in) //  %% <h5><a href="Weblogs.html">Weblogs:</a></h5>
						print ()
					$rsslink (out) //   ''
					$type (out) //   $cn->{TYPE}
					if () // length($type) != 0
						if () // $type =~ /(http:.*)/ %% not actually ... but this is assumed ...
							if () // $genrsslink
								$rsslink (out) //   ' <a href="' . $1 . '"><img src="tinyxml.jpg" alt="RSS link" title="RSS link"></a>'
							$type (out) //   $cn->{TYPE}
							$type (inout) // =~ s/(http:.*)//
						$type (inout) // =~ s/[ ]*\([^)]+\)//
						if () // length($type) != 0
							$type (out) //   $rsslink . ' - ' . $type
						else ()
							$type (out) //   $rsslink
					if () // $genfile
						<<END (in) //  %% <li> <a href="$cn->{TEXT}">$cn->{NAME}</a>$type
						print () // OUT
					<<END (in) //  %% <div><a href="$cn->{TEXT}">$cn->{NAME}</a>$rsslink</div>
					print ()
				if () // not defined($cn->{NEXT})
					last ()
				$cn (out) //   $cn->{NEXT}
			if () // not $first
				if () // $genfile
					<<END (in) //  %% </ol> CRLF </p> CRLF $copyright CRLF </body> CRLF </html>
					print () // OUT
					close () // OUT
				<<END (in) //  %% <small><div class="lastupdate">($dateandtime)</div></small>
				print ()
	Trace ()
		$str (in) &
		print () // STDERR $str . "\n"
