# File: Word_Perl.pl
# Date            Author        number of nodes
# 2003/3/15       Walking Lint  23
# 2003/3/11       Walking Lint  19
# 2002/8/20       Walking Lint  30 (DiffAutoBackup_Perl->Word_Perl)
# 2002/8/20       Walking Lint  18 (diffAutoBackup_Perl->DiffAutoBackup_Perl)
# 2002/7/24       Walking Lint  10 (DiffAutoBackup_Perl->diffAutoBackup_Perl)
# 2002/7/24       Walking Lint  7 (notepad_Perl->DiffAutoBackup_Perl)
# 2002/7/24       Walking Lint  7 (note_Perl->notepad_Perl)

=pod

=head1 NAME

Word_Perl.pl

=head1 DESCRIPTION

ex. perl.exe DiffAutoBackup_Perl.pl "D:\tmp\test.txt"

=head1 AUTHOR

Walking Lint

=cut

use strict;
use File::Copy;
use Win32;
use Win32::Process;
my $cmd = 'D:\Program Files\Microsoft Office\Office\WINWORD.EXE';
my $in_file = shift;
DebugPrint("in_file = $in_file");
my $src_file = $in_file;
if ($in_file =~ /\.pat$/) {
  $src_file =~ s/\.pat/.txt/; # this is hack
  $in_file =~ s/\.pat/_tmp.txt/; # this is hack
}
copy($src_file, $in_file);
Win32::Process::Create($Win32::Process::Create::ProcessObj, $cmd, $cmd . ' "' . $in_file . '"', 0, DETACHED_PROCESS, ".")
or die print_error();
sub print_error {
  return Win32::FormatMessage(Win32::GetLastError());
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
