# File: WrapLines_Perl.pl
# Date            Author        number of nodes
# 2006/7/15       Walking Lint  111
# 2006/7/15       Walking Lint  111 (2MultiLines_Perl->WrapLines_Perl)
# 2004/2/9        Walking Lint  111
# 2004/2/9        Walking Lint  111 (BreakLines_Perl->2MultiLines_Perl)
# 2004/2/9        Walking Lint  111
# 2003/8/31       Walking@Lint 115
# 2003/8/29       Walking Lint  109
# 2003/8/6        Walking@Lint 107
# 2003/4/9        Walking Lint  105

=pod

=head1 NAME

WrapLines_Perl.pl - break lines with chars unit

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$width = shift;
if (length($width) == 0) {
  $width = 80;
}
$cut = shift;
$prevwasspace = 0;
$breaklater = 0;
while (<STDIN>) {
  $_ =~ s/B$/ENDMARU/; # this is hack ...
  $_ =~ s/A$/ENDTEN/; # this is hack ...
  if ($cut) {
    $length = 0;
  } else {
    if ($prevwasspace) {
      $length = 0;
      print "\n\n";
    }
    if ($_ eq "") {
      $prevwasspace = 1;
    } else {
      $prevwasspace = 0;
    }
  }
  @segments = split(/B/, $_);
  for ($i = 0; $i <= $#segments; $i++) {
    $segment = $segments[$i];
    @segments2 = split(/A/, $segment);
    for ($j = 0; $j <= $#segments2; $j++) {
      $segment2 = $segments2[$j];
      @segments3 = split(/@/, $segment2);
      for ($k = 0; $k <= $#segments3; $k++) {
        $segment3 = $segments3[$k];
        @segments4 = split(/ /, $segment3);
        for ($l = 0; $l <= $#segments4; $l++) {
          $segment4 = $segments4[$l];
          if (($width < $length) or ($length != 0) and ($width < $length + length($segment4))) {
            print "\n";
            $length = 0;
          }
          if ($i == $#segments) {
            if ($j == $#segments2) {
              if ($k == $#segments3) {
                if ($l == $#segments4) {
                  $segment4 =~ s/ENDTEN/A/;
                  $segment4 =~ s/ENDMARU/B/;
                } else {
                  $segment4 .= ' ';
                }
              } else {
                if ($l == $#segments4) {
                  $segment4 .= '@';
                } else {
                  $segment4 .= ' ';
                }
              }
            } else {
              if ($k == $#segments3) {
                if ($l == $#segments4) {
                  $segment4 .= 'A';
                } else {
                  $segment4 .= ' ';
                }
              } else {
                if ($l == $#segments4) {
                  $segment4 .= '@';
                } else {
                  $segment4 .= ' ';
                }
              }
            }
          } else {
            if ($j == $#segments2) {
              if ($k == $#segments3) {
                if ($l == $#segments4) {
                  $segment4 =~ s/ENDTEN/A/;
                  $segment4 .= 'B';
                } else {
                  $segment4 .= ' ';
                }
              } else {
                if ($l == $#segments4) {
                  $segment4 .= '@';
                } else {
                  $segment4 .= ' ';
                }
              }
            } else {
              if ($k == $#segments3) {
                if ($l == $#segments4) {
                  $segment4 .= 'A';
                } else {
                  $segment4 .= ' ';
                }
              } else {
                if ($l == $#segments4) {
                  $segment4 .= '@';
                } else {
                  $segment4 .= ' ';
                }
              }
            }
          }
          print $segment4;
          $length += length($segment4);
        }
      }
    }
  }
  if ($breaklater) {
    last;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
