# File: Zips2Adrs_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 67
# 2003/8/6        Walking@Lint 61
# 2002/9/10       Walking Lint  59
# 2002/9/5        Walking Lint  58
# 2002/9/5        Walking Lint  58 (zips2adrs_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  66 (Zips2Adrs_Perl->zips2adrs_Perl)
# 2002/8/16       Walking Lint  57 (zip2adr_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  35 (zup2adr_Perl->zip2adr_Perl)
# 2002/7/15       Walking Lint  19 (grep_Perl->zup2adr_Perl)
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

Zips2Adrs_Perl.pl - zip number -> address

=head1 DESCRIPTION

use as filter of CV

=head1 AUTHOR

Walking Lint

=cut

$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  $found = 0;
  $zip = $_;
  $zip =~ s/\n$//g;
  $saved_zip = $zip;
  # convert zenkaku suji to hankaku suji
$zip =~ s/O/0/g;
$zip =~ s/P/1/g;
$zip =~ s/Q/2/g;
$zip =~ s/R/3/g;
$zip =~ s/S/4/g;
$zip =~ s/T/5/g;
$zip =~ s/U/6/g;
$zip =~ s/V/7/g;
$zip =~ s/W/8/g;
$zip =~ s/X/9/g;
  $zip =~ s/[[|\-]//g;
  $zip = '"' . $zip . '"';
  DebugPrint("zip = $zip");
  # get these files from Web... eidt here if needed ...
  $from_file = 'D:\common\cv\templates\Jigyosyo.csv';
  $from_file2 = 'D:\common\cv\templates\Ken_all.csv';
  open IN, $from_file || die("Can't open $from_file: $!\n");
  while (<IN>) {
    ($dummy, $dummy, $corp, $adr1, $adr2, $adr3, $adr4, $fzip, $dummy) = split(/,/, $_);
    if ($fzip eq $zip) {
      $adr1 =~ s/"//g;
      $adr2 =~ s/"//g;
      $adr3 =~ s/"//g;
      $adr4 =~ s/"//g;
      $corp =~ s/"//g;
      $corp =~ s/@Ё@/ij/g;
      $corp =~ s/^Ё@/ij/g;
      $corp =~ s/@$/ij/g;
      print $saved_zip . ', ' . $adr1 . $adr2 . $adr3 . $adr4 . ', ' . $corp . ", \n";
      $found = 1;
    }
  }
  close IN;
  if ($found) { # found in Jigyosho.csv
    next;
  }
  open IN, $from_file2 || die("Can't open $from_file2: $!\n");
  while (<IN>) {
    ($dummy, $dummy, $fzip, $dummy, $dummy, $dummy, $adr1, $adr2, $adr3, $dummy) = split(/,/, $_);
    if ($fzip eq $zip) {
      $adr1 =~ s/"//g;
      $adr2 =~ s/"//g;
      $adr3 =~ s/"//g;
      print $saved_zip . ', ' . $adr1 . $adr2 . $adr3 . ", \n";
      $found = 1;
    }
  }
  close IN;
  if ($found) { # found in Ken_all.csv
    next;
  }
  print $saved_zip . ", , \n"; # not found
  if ($breaklater) {
    last;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
