# File: grep_Perl.pl
# Date            Author        number of nodes
# 2005/3/16       Walking Lint  43
# 2004/1/9        Walking Lint  43
# 2003/2/13       Walking Lint  27
# 2002/8/15       Walking Lint  21
# 2002/7/15       Walking Lint  19
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

grep_Perl.pl - grep str

=head1 DESCRIPTION

activate as filter or program

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Cwd;
$str = shift;
$from = shift;
if (length($from) != 0) {
  $dir = dirname($from);
  $dir2 = &mydirname($from);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  $dir = dirname($from);
  $dir2 = &mydirname($from);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  $count = @from_files;
  foreach $from_file (@from_files) {
    open IN, $from_file or die("Can't open $from_file: $!\n");
    while (<IN>) {
      if ($count > 1) {
        print "$dir2\\$from_file: $.\t$_" if /$str/o;
      } else {
        print "$_" if /$str/o;
      }
    }
    close IN;
  }
} else {
  while (<STDIN>) {
    print "$_" if /$str/o;
  }
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
