# File: hanoi_Ruby.rb
# Date            Author        number of nodes
# 2004/12/23      Walking Lint  18
# 2004/6/25       Walking Lint  18
#! /usr/bin/ruby
# 
# The Towers Of Hanoi
# Ruby
# Copyright (C) 1998 Amit Singh. All Rights Reserved.
# http://hanoi.kernelthread.com
def hanoi(n, f, t, u)
  def if
    move = "move " + f + " --> " + t + "\n"
    print move
  def else
    hanoi(n - 1, f, u, t)
    hanoi(1, f, t, u)
    hanoi(n - 1, u, t, f)
  end
end
def if
  STDERR.print("usage: hanoi.rb <n>\n")
  exit 1
end
hanoi(ARGV[0].to_i, "1", "3", "2")
