//
// File: linkColor_LSL.lsl
// Date            Author        number of nodes
// 2007/3/29       Walking Lint  17
//
setcolor(vector color) {
    integer num_of_prims;
    integer i;
    num_of_prims = llGetNumberOfPrims();
    for (i = 0; i < num_of_prims; i++) {
        if ((llGetLinkName(i) != "non_petal") && (llGetLinkName(i) != "Blue Rose T")) {
            llSetLinkColor(i, color, ALL_SIDES);
        }
    }
}
default {
    state_entry() {
        llSetText("Blue Rose", <0.0, 0.0, 1.0>, 0.5);
    }
    touch_start(integer id) {
        setcolor(<1.0, 0.0, 0.0>);
        llSetText("Red Rose", <1.0, 0.0, 0.0>, 0.5);
        state touched;
    }
}
state touched {
    touch_start(integer id) {
        setcolor(<0.0, 0.0, 1.0>);
        llSetText("Blue Rose", <0.0, 0.0, 1.0>, 0.5);
        state default;
    }
}
