//
// File: phy_bar_LSL.lsl
// Date            Author        number of nodes
// 2007/9/29       walkinglint   28
// 2007/9/29       walkinglint   28 (phy_bar->phy_bar_LSL)
// 2007/9/24       walkinglint   28
// 2007/9/20       walkinglint   19
// 2007/9/20       walkinglint   19 (bar->phy_bar)
// 2007/9/20       walkinglint   19
// 2007/9/17       walkinglint   16
//
vector scale;
default {
    on_rez(integer param) {
        integer is_minus = param / 10000;
        integer tmp = param % 10000;
        integer x = tmp / 100;
        integer y = tmp % 100;
        llSetTimerEvent(50);
        scale = llGetScale();
        if (x != 0 && y != 0) {
            scale.x = 1.41 * (float)x / 10 + scale.x;
            if (is_minus) {
                llSetRot(llGetRot() * llEuler2Rot(<0, 45 * DEG_TO_RAD, 0>));
            } else {
                llSetRot(llGetRot() * llEuler2Rot(<0, -45 * DEG_TO_RAD, 0>));
            }
        } else {
            if (x != 0) {
                scale.x = (float)x / 10 + scale.x;
            }
            if (y != 0) {
                scale.z = (float)y / 10 + scale.z;
            }
        }
        llSetScale(scale);
    }
    timer() {
        llSetStatus(STATUS_PHYSICS, TRUE);
    }
}
