# File: sedWordWithExcelForDevTech_Ruby.rb
# Date            Author        number of nodes
# 2002/9/13       Walking Lint  48
# 2002/7/18       Walking Lint  40
# 2002/7/17       Walking Lint  42
# 2002/7/17       Walking Lint  32 (sedWordWithFilterFileForDevTech_Ruby->sedWordWithExcelForDevTech_Ruby)
# 2002/7/17       Walking Lint  31 (sedWordWithFilterFile_Ruby->sedWordWithFilterFileForDevTech_Ruby)
# 2002/7/17       Walking Lint  21 (sedWord_Ruby->sedWordWithFilterFile_Ruby)
# 2002/7/17       Walking Lint  29 (grepWord_Ruby->sedWord_Ruby)

=begin

= NAME

sedWord_Ruby.rb - sed Word files with filterfile

= DESCRIPTION

ex. ruby sedWordWithExcelForDevTech_Ruby.rb "F:\w\200210\ƁiڍהŁj 2002.09.xls" "F:/w/200210/work/*.doc"

= AUTHOR

Walking Lint

=end

require "win32ole"
def DebugPrint(str)
  $stderr.print(str + "\n")
end
excelfile, files = ARGV # maybe you should use / to separate path instead of \ to designate files
DebugPrint("excelfile = " + excelfile)
DebugPrint("files = " + files)
dir = File.dirname(files)
basename = File.basename(files)
DebugPrint("dir = " + dir)
Dir.chdir(dir)
excel = WIN32OLE.new('Excel.Application')
ebook = excel.workbooks.open(excelfile)
area = ebook.activeSheet.usedRange
trans = {}
begin
def for
  row = area.rows(rowIndex)
  def for
    column = row.cells(1, columnIndex)
    pre = "[[#{(columnIndex + 65 - 1).chr}#{rowIndex}]]"
    post = "#{(column.value).to_i}"
    # [[Re: [Q]printfł̐l̏!http://blade.nagaokaut.ac.jp/cgi-bin/scat.rb/~poffice/news2/fj.comp.lang.ruby/63]] Q
    while post.sub! /(.*\d)(\d{3})/, '\1,\2'; end
    trans[pre] = post
  end
ensure
  ebook.close
end
excel.quit
wd = WIN32OLE.new("Word.Application")
Dir.glob(basename) do |file| 
  DebugPrint("file = " + file)
  doc = dir + '/' + file
  wdoc = wd.Documents.open(doc)
  trans.each() {|pre, post| wdoc.Content.Find.Execute ('FindText' => pre, 'ReplaceWith' => post, 'Replace' => 2)}
  wdoc.save
  wdoc.close
end
wd.Quit
