# File: sort_Perl.pl
# Date            Author        number of nodes
# 2005/8/16       Walking Lint  32
# 2005/6/25       Walking Lint  18
# 2005/3/16       Walking Lint  17
# 2003/8/30       Walking@Lint 22
# 2003/8/6        Walking@Lint 15
# 2003/5/10       Walking Lint  9
# 2002/11/6       Walking Lint  7
# 2002/11/4       Walking Lint  3
# 2002/2/3        Walking Lint  3 (Sort2_Perl->sort_Perl)

=pod

=head1 NAME

sort_Perl.pl - sort lines with uniq function

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use Jcode;
use encoding 'SJIS';
use Tk;
@unsorted = ();
while (<STDIN>) {
  $_ =~ s/[\n\r]*$//;
  push @unsorted, $_;
}
@sorted = sort {lc($a) cmp lc($b)} @unsorted;
%seen = ();
$msg = '';
foreach $item (@sorted) {
  if (length($item) > 0) {
    if ($seen{$item}++) {
      $msg .= $item . ' ';
    } else {
      print $item . "\n";
    }
  }
}
if (length($msg) != 0) {
  Jcode::convert(\$msg, 'sjis'); # why needed??? and not functioning???
  $mw = MainWindow->new;
  $mw->title("");
  $msg = "$msg" . '>= 2 times';
  $lab = $mw->Label(-text => $msg)
    ->pack();
  MainLoop();
  DebugPrint("$msg");
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
