# File: stat2_Perl.pl
# Date            Author        number of nodes
# 2002/12/23      Walking Lint  14
# 2002/12/23      Walking Lint  13 (stat_Perl->stat2_Perl)
# 2002/12/4       Walking Lint  13

=pod

=head1 NAME

stat2_Perl.pl - stat file

=head1 DESCRIPTION

ex. perl.exe stat2_Perl.pl stat2_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use File::stat;
$file = shift;
$inode = stat($file);
DebugPrint("atime = " . $inode->atime);
DebugPrint("ctime = " . $inode->ctime);
DebugPrint("mtime = " . $inode->mtime);
DebugPrint("size = " . $inode->size);
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
