# File: wc_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 35
# 2003/8/8        Walking@Lint 29
# 2003/5/14       Walking Lint  27
# 2003/5/14       Walking Lint  16 (wc2_Perl->wc_Perl)
# 2002/12/23      Walking Lint  16
# 2002/12/23      Walking Lint  26 (wc_Perl->wc2_Perl)

=pod

=head1 NAME

wc_Perl.pl - word count

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$use_tk = shift;
%words = ();
$count = 0;
$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  while (/\b([A-Za-z]+)\b/gi) {
    $words{lc($1)}++;
    $count++;
  }
  print $_;
  if ($breaklater) {
    last;
  }
}
if ($use_tk) {
  use Tk;
  $mw = new MainWindow;
  $lab = $mw->Label(-text => "total $count words");
  $lab->pack();
  MainLoop();
} else {
  DebugPrint("total $count words");
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
